=== modified file '.bzrignore'
--- .bzrignore	2005-07-11 05:46:55 +0000
+++ .bzrignore	2005-06-06 13:24:18 +0000
@@ -12,5 +12,3 @@
 ,,*
 testbzr.log
 api
-test.log
-./tmp

=== modified file 'NEWS'
--- NEWS	2005-07-23 13:53:01 +0000
+++ NEWS	2005-06-22 07:18:01 +0000
@@ -7,38 +7,14 @@
 
     * New 'bzr mkdir' command.
 
-    * Commit mesage is fetched from an editor if not given on the
-      command line; patch from Torsten Marek.
-
-    * ``bzr log -m FOO`` displays commits whose message matches regexp 
-      FOO.
-      
-    * ``bzr add`` with no arguments adds everything under the current directory.
-    
-  ENHANCEMENTS:
-
-    * Faster working tree operations.
-
   CHANGES:
 
-    * When exporting to a tarball with ``bzr export --format tgz``, put 
-      everything under a top directory rather than dumping it into the
-      current directory.   This can be overridden with the ``--root`` 
-      option.  Patch from William Dodé and John Meinel.
-
     * New ``bzr upgrade`` command to upgrade the format of a branch,
       replacing ``bzr check --update``.
 
     * Files within store directories are no longer marked readonly on
       disk.
 
-    * Changed ``bzr log`` output to a more compact form suggested by
-      John A Meinel.  Old format is available with the ``--long`` or
-      ``-l`` option, patched by William Dodé.
-
-    * By default the commit command refuses to record a revision with
-      no changes unless the ``--unchanged`` option is given.
-
 
 bzr-0.0.5  2005-06-15
   

=== modified file 'README'
--- README	2005-07-22 23:32:00 +0000
+++ README	2005-05-11 01:03:22 +0000
@@ -21,7 +21,7 @@
 This is mostly developed on Linux (Ubuntu); it should work on Unix,
 Windows, or OS X with relatively little trouble.
 
-The only dependency is Python 2.4.
+The only dependency is Python, at least 2.3 and preferably 2.4.  
 
 You may optionally install cElementTree to speed up some operations.
 This is strongly recommended if you are dealing with large trees.
@@ -49,7 +49,7 @@
 After installing, please run the test suite to identify any problems
 on your platform::
 
-  ./bzr selftest
+  ./testbzr
 
 If you use the setup.py script then bzr will be installed into the
 specified path.  In this case you must install ElementTree and

=== modified file 'TODO'
--- TODO	2005-07-22 23:43:26 +0000
+++ TODO	2005-06-22 06:59:06 +0000
@@ -1,4 +1,4 @@
-.. -*- mode: indented-text; compile-command: "make -C doc" -*-
+.. -*- mode: indented-text; compile-command: "make -C doc" -*- 
 
 
 *******************
@@ -17,33 +17,29 @@
 Small things
 ------------
 
-* is_within_any is very very dodgy
-
-* Merging add of a new file clashing with an existing file doesn't
-  work; add gets an error that it's already versioned and the merge
-  aborts.
-
-* Merge should ignore the destination's working directory, otherwise
-  we get an error about the statcache when pulling from a remote
-  branch.
-
 * Add of a file that was present in the base revision should put back
   the previous file-id.
 
-* Not sure I'm happy with needing to pass a root id to EmptyTree;
-  comparing anything against an EmptyTree with no root should have the
-  same effect(?)
-
 * Handle diff of files which do not have a trailing newline; probably
   requires patching difflib to get it exactly right, or otherwise
   calling out to GNU diff.
 
-* Should be able to copy files between branches to preserve their
-  file-id (and perhaps eventually parentage.)
+* Import ElementTree update patch.
+
+* Plugins that provide commands.  By just installing a file into some
+  directory (e.g. ``/usr/share/bzr/plugins``) it should be possible to
+  create new top-level commands (``bzr frob``).  Extensions can be
+  written in either Python (in which case they use the bzrlib API) or
+  in a separate process (in sh, C, whatever).   It should be possible
+  to get help for plugin commands.
+
+* Smart rewrap text in help messages to fit in $COLUMNS (or equivalent
+  on Windows)
 
 * -r option should take a revision-id as well as a revno.
 
-* allow ``bzr st -r 300`` to show a summary of changes since then.
+* ``bzr info`` could show space used by working tree, versioned files,
+  unknown and ignored files. 
 
 * ``bzr info`` should count only people with distinct email addresses as
   different committers.  (Or perhaps only distinct userids?)
@@ -70,6 +66,8 @@
 
 * ``bzr log DIR`` should give changes to any files within DIR.
 
+* Check all commands have decent help.
+
 * ``bzr inventory -r REV`` and perhaps unify this with ``bzr ls``,
   giving options to display ids, types, etc.
 
@@ -81,7 +79,7 @@
   temporary directory and then tar that up.)
 
   http://www.gelato.unsw.edu.au/archives/git/0504/2194.html
-
+  
 * RemoteBranch could maintain a cache either in memory or on disk.  We
   know more than an external cache might about which files are
   immutable and which can vary.  On the other hand, it's much simpler
@@ -112,12 +110,12 @@
   Nice for humans; less good for machine parsing.
 
 * Patches should probably use only forward slashes, even on Windows,
-  otherwise Unix patch can't apply them. (?)
+  otherwise Unix patch can't apply them. (?) 
 
 * Branch.update_revisions() inefficiently fetches revisions from the
   remote server twice; once to find out what text and inventory they
   need and then again to actually get the thing.  This is a bit
-  inefficient.
+  inefficient. 
 
   One complicating factor here is that we don't really want to have
   revisions present in the revision-store until all their constituent
@@ -130,31 +128,7 @@
 * ``bzr status FOO`` where foo is ignored should say so.
 
 * ``bzr mkdir A...`` should just create and add A.
-
-* Guard against repeatedly merging any particular patch.
-
-* More options for diff:
-
-  - diff two revisions of the same tree
-
-  - diff two different branches, optionally at different revisions
-
-  - diff a particular file in another tree against the corresponding
-    version in this tree (which should be the default if the second
-    parameter is a tree root)
-
-  - diff everything under a particular directory, in any of the above
-    ways
-
-  - diff two files inside the same tree, even if they have different
-    ids
-
-  - and, of course, tests for all this
-
-* ``bzr add`` with no arguments should probably be the same as ``bzr add .``
-
-* Reproducible performance benchmark to measure whether performance is 
-  getting better or worse.
+  
 
 
 Medium things
@@ -198,7 +172,7 @@
   At the very least we could run diffstat over the diff, or perhaps
   read the status output from patch.  Just knowing which files might
   be modified would be enough to guide the add and commit.
-
+  
   Given this we might be able to import patches at 1/second or better.
 
 * Get branch over http.
@@ -240,7 +214,7 @@
 
 * Handle symlinks in the working directory; at the very least it
   should be possible for them to be present and ignored/unknown
-  without causing assertion failures.
+  without causing assertion failures. 
 
   Eventually symlinks should be versioned.
 
@@ -248,7 +222,7 @@
   if the subdirectory is not already versioned.   Perhaps also require
   a ``--nested`` to protect against confusion.
 
-* Branch names?
+* Branch names? 
 
 * More test framework:
 
@@ -256,7 +230,7 @@
     assert it's equal.
 
 * There are too many methods on Branch() that really manipulate the
-  WorkingTree.  They should be moved across.
+  WorkingTree.  They should be moved across.  
 
   Also there are some methods which are duplicated on Tree and
   Inventory objects, and it should be made more clear which ones are
@@ -287,7 +261,7 @@
     object interface though, but perhaps that should just be a proxy
     for the elements.
 
-  - Less special cases for the root directory.
+  - Less special cases for the root directory. 
 
 * Perhaps inventories should remember the revision in which each file
   was last changed, as well as its current state?  This is a bit
@@ -299,7 +273,7 @@
 
 * It'd be nice to pipeline multiple HTTP requests.  Often we can
   predict what will be wanted in future: all revisions, or all texts
-  in a particular revision, etc.
+  in a particular revision, etc.  
 
   urlgrabber's docs say they are working on batched downloads; we
   could perhaps ride on that or just create a background thread (ew).
@@ -343,8 +317,6 @@
 * Don't pass around command classes but rather pass objects.  This'd
   make it cleaner to construct objects wrapping external commands.
 
-* Track all merged-in revisions in a versioned add-only metafile.
-
 
 Large things
 ------------
@@ -399,7 +371,7 @@
   a temporary directory.
 
   If the commit does not actually complete, we would rather the
-  content was not left behind in the stores.
+  content was not left behind in the stores.  
 
 * Web interface
 

=== modified file 'bzr'
--- bzr	2005-07-26 14:06:11 +0000
+++ bzr	2005-05-10 08:15:58 +0000
@@ -25,14 +25,13 @@
 
 
 REINVOKE = "__BZR_REINVOKE"    
-NEED_VERS = (2, 4)
-KNOWN_PYTHONS = ('python2.4',)
+NEED_VERS = (2, 3)
 
 if version_info < NEED_VERS:
     if not os.environ.has_key(REINVOKE):
         # mutating os.environ doesn't work in old Pythons
         os.putenv(REINVOKE, "1")
-        for python in KNOWN_PYTHONS:
+        for python in 'python2.4', 'python2.3':
             try:
                 os.execvp(python, [python] + sys.argv)
             except OSError:

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2005-07-23 13:52:38 +0000
+++ bzrlib/__init__.py	2005-06-22 06:04:43 +0000
@@ -16,9 +16,15 @@
 
 """bzr library"""
 
-# TODO: Do less imports here
+from inventory import Inventory, InventoryEntry
 from branch import Branch, ScratchBranch, find_branch
-from errors import BzrError
+from osutils import format_date
+from tree import Tree
+from diff import compare_trees
+from trace import mutter, warning, open_tracefile
+from log import show_log
+from plugin import load_plugins
+import add
 
 BZRDIR = ".bzr"
 
@@ -37,7 +43,7 @@
 IGNORE_FILENAME = ".bzrignore"
 
 import locale
-user_encoding = locale.getpreferredencoding() or 'ascii'
+user_encoding = locale.getpreferredencoding()
 del locale
 
 __copyright__ = "Copyright 2005 Canonical Development Ltd."
@@ -47,6 +53,7 @@
 
 def get_bzr_revision():
     """If bzr is run from a branch, return (revno,revid) or None"""
+    from errors import BzrError
     try:
         branch = Branch(__path__[0])
         rh = branch.revision_history()

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2005-07-23 14:06:37 +0000
+++ bzrlib/add.py	2005-06-15 04:14:26 +0000
@@ -14,6 +14,9 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+import os, sys
+import bzrlib
+
 from trace import mutter, note
 
 def glob_expand_for_win32(file_list):
@@ -37,18 +40,13 @@
     This is designed more towards DWIM for humans than API simplicity.
     For the specific behaviour see the help for cmd_add().
     """
-    import os
-    import sys
     from bzrlib.osutils import quotefn, kind_marker
     from bzrlib.errors import BadFileKindError, ForbiddenFileError
-    import bzrlib.branch
-    import bzrlib.osutils
 
+    assert file_list
+    
     if sys.platform == 'win32':
         file_list = glob_expand_for_win32(file_list)
-        
-    if not file_list:
-        file_list = ['.']
     
     user_list = file_list[:]
     assert not isinstance(file_list, basestring)
@@ -70,7 +68,7 @@
                 print "skipping %s (can't add file of kind '%s')" % (f, kind)
                 continue
 
-        mutter("smart add of %r, abs=%r" % (f, af))
+        bzrlib.mutter("smart add of %r, abs=%r" % (f, af))
         
         if bzrlib.branch.is_control_file(af):
             raise ForbiddenFileError('cannot add control file %s' % f)
@@ -84,7 +82,7 @@
         else:
             file_id = bzrlib.branch.gen_file_id(rf)
             inv.add_path(rf, kind=kind, file_id=file_id)
-            mutter("added %r kind %r file_id={%s}" % (rf, kind, file_id))
+            bzrlib.mutter("added %r kind %r file_id={%s}" % (rf, kind, file_id))
             count += 1 
 
             print 'added', quotefn(f)
@@ -104,6 +102,3 @@
         if verbose:
             note('added %d' % count)
         b._write_inventory(inv)
-    else:
-        print "nothing new to add"
-        # should this return 1 to the shell?

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-07-22 22:31:40 +0000
+++ bzrlib/branch.py	2005-06-15 03:43:04 +0000
@@ -15,13 +15,22 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-import sys, os
+import sys, os, os.path, random, time, sha, sets, types, re, shutil, tempfile
+import traceback, socket, fnmatch, difflib, time
+from binascii import hexlify
 
 import bzrlib
-from bzrlib.trace import mutter, note
-from bzrlib.osutils import isdir, quotefn, compact_date, rand_bytes, splitpath, \
-     sha_file, appendpath, file_kind
-from bzrlib.errors import BzrError
+from inventory import Inventory
+from trace import mutter, note
+from tree import Tree, EmptyTree, RevisionTree
+from inventory import InventoryEntry, Inventory
+from osutils import isdir, quotefn, isfile, uuid, sha_file, username, \
+     format_date, compact_date, pumpfile, user_email, rand_bytes, splitpath, \
+     joinpath, sha_file, sha_string, file_kind, local_time_offset, appendpath
+from store import ImmutableStore
+from revision import Revision
+from errors import BzrError
+from textui import show_status
 
 BZR_BRANCH_FORMAT = "Bazaar-NG branch, format 0.0.4\n"
 ## TODO: Maybe include checks for common corruption of newlines, etc?
@@ -36,22 +45,6 @@
         return Branch(f, **args)
 
 
-def find_cached_branch(f, cache_root, **args):
-    from remotebranch import RemoteBranch
-    br = find_branch(f, **args)
-    def cacheify(br, store_name):
-        from meta_store import CachedStore
-        cache_path = os.path.join(cache_root, store_name)
-        os.mkdir(cache_path)
-        new_store = CachedStore(getattr(br, store_name), cache_path)
-        setattr(br, store_name, new_store)
-
-    if isinstance(br, RemoteBranch):
-        cacheify(br, 'inventory_store')
-        cacheify(br, 'text_store')
-        cacheify(br, 'revision_store')
-    return br
-
 
 def _relpath(base, path):
     """Return path relative to base, or raise exception.
@@ -150,11 +143,6 @@
     _lock_count = None
     _lock = None
     
-    # Map some sort of prefix into a namespace
-    # stuff like "revno:10", "revid:", etc.
-    # This should match a prefix with a function which accepts
-    REVISION_NAMESPACES = {}
-
     def __init__(self, base, init=False, find_root=True):
         """Create new branch object at a particular location.
 
@@ -170,7 +158,6 @@
         In the test suite, creation of new trees is tested using the
         `ScratchBranch` class.
         """
-        from bzrlib.store import ImmutableStore
         if init:
             self.base = os.path.realpath(base)
             self._make_control()
@@ -262,7 +249,7 @@
 
     def controlfilename(self, file_or_path):
         """Return location relative to branch."""
-        if isinstance(file_or_path, basestring):
+        if isinstance(file_or_path, types.StringTypes):
             file_or_path = [file_or_path]
         return os.path.join(self.base, bzrlib.BZRDIR, *file_or_path)
 
@@ -295,9 +282,6 @@
 
 
     def _make_control(self):
-        from bzrlib.inventory import Inventory
-        from bzrlib.xml import pack_xml
-        
         os.mkdir(self.controlfilename([]))
         self.controlfile('README', 'w').write(
             "This is a Bazaar-NG control directory.\n"
@@ -307,12 +291,10 @@
             os.mkdir(self.controlfilename(d))
         for f in ('revision-history', 'merged-patches',
                   'pending-merged-patches', 'branch-name',
-                  'branch-lock',
-                  'pending-merges'):
+                  'branch-lock'):
             self.controlfile(f, 'w').write('')
         mutter('created control directory in ' + self.base)
-
-        pack_xml(Inventory(gen_root_id()), self.controlfile('inventory','w'))
+        Inventory().write_xml(self.controlfile('inventory','w'))
 
 
     def _check_format(self):
@@ -333,37 +315,18 @@
                            ['use a different bzr version',
                             'or remove the .bzr directory and "bzr init" again'])
 
-    def get_root_id(self):
-        """Return the id of this branches root"""
-        inv = self.read_working_inventory()
-        return inv.root.file_id
 
-    def set_root_id(self, file_id):
-        inv = self.read_working_inventory()
-        orig_root_id = inv.root.file_id
-        del inv._byid[inv.root.file_id]
-        inv.root.file_id = file_id
-        inv._byid[inv.root.file_id] = inv.root
-        for fid in inv:
-            entry = inv[fid]
-            if entry.parent_id in (None, orig_root_id):
-                entry.parent_id = inv.root.file_id
-        self._write_inventory(inv)
 
     def read_working_inventory(self):
         """Read the working inventory."""
-        from bzrlib.inventory import Inventory
-        from bzrlib.xml import unpack_xml
-        from time import time
-        before = time()
+        before = time.time()
+        # ElementTree does its own conversion from UTF-8, so open in
+        # binary.
         self.lock_read()
         try:
-            # ElementTree does its own conversion from UTF-8, so open in
-            # binary.
-            inv = unpack_xml(Inventory,
-                             self.controlfile('inventory', 'rb'))
+            inv = Inventory.read_xml(self.controlfile('inventory', 'rb'))
             mutter("loaded inventory of %d items in %f"
-                   % (len(inv), time() - before))
+                   % (len(inv), time.time() - before))
             return inv
         finally:
             self.unlock()
@@ -375,20 +338,16 @@
         That is to say, the inventory describing changes underway, that
         will be committed to the next revision.
         """
-        from bzrlib.atomicfile import AtomicFile
-        from bzrlib.xml import pack_xml
-        
-        self.lock_write()
-        try:
-            f = AtomicFile(self.controlfilename('inventory'), 'wb')
-            try:
-                pack_xml(inv, f)
-                f.commit()
-            finally:
-                f.close()
-        finally:
-            self.unlock()
-        
+        ## TODO: factor out to atomicfile?  is rename safe on windows?
+        ## TODO: Maybe some kind of clean/dirty marker on inventory?
+        tmpfname = self.controlfilename('inventory.tmp')
+        tmpf = file(tmpfname, 'wb')
+        inv.write_xml(tmpf)
+        tmpf.close()
+        inv_fname = self.controlfilename('inventory')
+        if sys.platform == 'win32':
+            os.remove(inv_fname)
+        os.rename(tmpfname, inv_fname)
         mutter('wrote working inventory')
             
 
@@ -422,11 +381,10 @@
               add all non-ignored children.  Perhaps do that in a
               higher-level method.
         """
-        from bzrlib.textui import show_status
         # TODO: Re-adding a file that is removed in the working copy
         # should probably put it back with the previous ID.
-        if isinstance(files, basestring):
-            assert(ids is None or isinstance(ids, basestring))
+        if isinstance(files, types.StringTypes):
+            assert(ids is None or isinstance(ids, types.StringTypes))
             files = [files]
             if ids is not None:
                 ids = [ids]
@@ -464,7 +422,7 @@
                 inv.add_path(f, kind=kind, file_id=file_id)
 
                 if verbose:
-                    print 'added', quotefn(f)
+                    show_status('A', kind, quotefn(f))
 
                 mutter("add file %s file_id:{%s} kind=%r" % (f, file_id, kind))
 
@@ -481,7 +439,7 @@
             # use inventory as it was in that revision
             file_id = tree.inventory.path2id(file)
             if not file_id:
-                raise BzrError("%r is not present in revision %s" % (file, revno))
+                raise BzrError("%r is not present in revision %d" % (file, revno))
             tree.print_file(file_id)
         finally:
             self.unlock()
@@ -501,10 +459,9 @@
         is the opposite of add.  Removing it is consistent with most
         other tools.  Maybe an option.
         """
-        from bzrlib.textui import show_status
         ## TODO: Normalize names
         ## TODO: Remove nested loops; better scalability
-        if isinstance(files, basestring):
+        if isinstance(files, types.StringTypes):
             files = [files]
 
         self.lock_write()
@@ -535,8 +492,7 @@
 
     # FIXME: this doesn't need to be a branch method
     def set_inventory(self, new_inventory_list):
-        from bzrlib.inventory import Inventory, InventoryEntry
-        inv = Inventory(self.get_root_id())
+        inv = Inventory()
         for path, file_id, parent, kind in new_inventory_list:
             name = os.path.basename(path)
             if name == "":
@@ -564,40 +520,32 @@
         return self.working_tree().unknowns()
 
 
-    def append_revision(self, *revision_ids):
-        from bzrlib.atomicfile import AtomicFile
-
-        for revision_id in revision_ids:
-            mutter("add {%s} to revision-history" % revision_id)
-
+    def append_revision(self, revision_id):
+        mutter("add {%s} to revision-history" % revision_id)
         rev_history = self.revision_history()
-        rev_history.extend(revision_ids)
-
-        f = AtomicFile(self.controlfilename('revision-history'))
-        try:
-            for rev_id in rev_history:
-                print >>f, rev_id
-            f.commit()
-        finally:
-            f.close()
+
+        tmprhname = self.controlfilename('revision-history.tmp')
+        rhname = self.controlfilename('revision-history')
+        
+        f = file(tmprhname, 'wt')
+        rev_history.append(revision_id)
+        f.write('\n'.join(rev_history))
+        f.write('\n')
+        f.close()
+
+        if sys.platform == 'win32':
+            os.remove(rhname)
+        os.rename(tmprhname, rhname)
+        
 
 
     def get_revision(self, revision_id):
         """Return the Revision object for a named revision"""
-        from bzrlib.revision import Revision
-        from bzrlib.xml import unpack_xml
-
-        self.lock_read()
-        try:
-            if not revision_id or not isinstance(revision_id, basestring):
-                raise ValueError('invalid revision-id: %r' % revision_id)
-            r = unpack_xml(Revision, self.revision_store[revision_id])
-        finally:
-            self.unlock()
-            
+        if not revision_id or not isinstance(revision_id, basestring):
+            raise ValueError('invalid revision-id: %r' % revision_id)
+        r = Revision.read_xml(self.revision_store[revision_id])
         assert r.revision_id == revision_id
         return r
-        
 
     def get_revision_sha1(self, revision_id):
         """Hash the stored value of a revision, and return it."""
@@ -616,11 +564,8 @@
         TODO: Perhaps for this and similar methods, take a revision
                parameter which can be either an integer revno or a
                string hash."""
-        from bzrlib.inventory import Inventory
-        from bzrlib.xml import unpack_xml
-
-        return unpack_xml(Inventory, self.inventory_store[inventory_id])
-            
+        i = Inventory.read_xml(self.inventory_store[inventory_id])
+        return i
 
     def get_inventory_sha1(self, inventory_id):
         """Return the sha1 hash of the inventory entry
@@ -630,13 +575,10 @@
 
     def get_revision_inventory(self, revision_id):
         """Return inventory of a past revision."""
-        # bzr 0.0.6 imposes the constraint that the inventory_id
-        # must be the same as its revision, so this is trivial.
         if revision_id == None:
-            from bzrlib.inventory import Inventory
-            return Inventory(self.get_root_id())
+            return Inventory()
         else:
-            return self.get_inventory(revision_id)
+            return self.get_inventory(self.get_revision(revision_id).inventory_id)
 
 
     def revision_history(self):
@@ -811,16 +753,8 @@
 
         pb.update('comparing histories')
         revision_ids = self.missing_revisions(other, stop_revision)
-
-        if hasattr(other.revision_store, "prefetch"):
-            other.revision_store.prefetch(revision_ids)
-        if hasattr(other.inventory_store, "prefetch"):
-            inventory_ids = [other.get_revision(r).inventory_id
-                             for r in revision_ids]
-            other.inventory_store.prefetch(inventory_ids)
-                
         revisions = []
-        needed_texts = set()
+        needed_texts = sets.Set()
         i = 0
         for rev_id in revision_ids:
             i += 1
@@ -851,178 +785,32 @@
                     
         
     def commit(self, *args, **kw):
+        """Deprecated"""
         from bzrlib.commit import commit
         commit(self, *args, **kw)
         
 
-    def lookup_revision(self, revision):
-        """Return the revision identifier for a given revision information."""
-        revno, info = self.get_revision_info(revision)
-        return info
-
-    def get_revision_info(self, revision):
-        """Return (revno, revision id) for revision identifier.
-
-        revision can be an integer, in which case it is assumed to be revno (though
-            this will translate negative values into positive ones)
-        revision can also be a string, in which case it is parsed for something like
-            'date:' or 'revid:' etc.
-        """
-        if revision is None:
-            return 0, None
-        revno = None
-        try:# Convert to int if possible
-            revision = int(revision)
-        except ValueError:
-            pass
-        revs = self.revision_history()
-        if isinstance(revision, int):
-            if revision == 0:
-                return 0, None
-            # Mabye we should do this first, but we don't need it if revision == 0
-            if revision < 0:
-                revno = len(revs) + revision + 1
-            else:
-                revno = revision
-        elif isinstance(revision, basestring):
-            for prefix, func in Branch.REVISION_NAMESPACES.iteritems():
-                if revision.startswith(prefix):
-                    revno = func(self, revs, revision)
-                    break
-            else:
-                raise BzrError('No namespace registered for string: %r' % revision)
-
-        if revno is None or revno <= 0 or revno > len(revs):
-            raise BzrError("no such revision %s" % revision)
-        return revno, revs[revno-1]
-
-    def _namespace_revno(self, revs, revision):
-        """Lookup a revision by revision number"""
-        assert revision.startswith('revno:')
-        try:
-            return int(revision[6:])
-        except ValueError:
-            return None
-    REVISION_NAMESPACES['revno:'] = _namespace_revno
-
-    def _namespace_revid(self, revs, revision):
-        assert revision.startswith('revid:')
-        try:
-            return revs.index(revision[6:]) + 1
-        except ValueError:
-            return None
-    REVISION_NAMESPACES['revid:'] = _namespace_revid
-
-    def _namespace_last(self, revs, revision):
-        assert revision.startswith('last:')
-        try:
-            offset = int(revision[5:])
-        except ValueError:
-            return None
-        else:
-            if offset <= 0:
-                raise BzrError('You must supply a positive value for --revision last:XXX')
-            return len(revs) - offset + 1
-    REVISION_NAMESPACES['last:'] = _namespace_last
-
-    def _namespace_tag(self, revs, revision):
-        assert revision.startswith('tag:')
-        raise BzrError('tag: namespace registered, but not implemented.')
-    REVISION_NAMESPACES['tag:'] = _namespace_tag
-
-    def _namespace_date(self, revs, revision):
-        assert revision.startswith('date:')
-        import datetime
-        # Spec for date revisions:
-        #   date:value
-        #   value can be 'yesterday', 'today', 'tomorrow' or a YYYY-MM-DD string.
-        #   it can also start with a '+/-/='. '+' says match the first
-        #   entry after the given date. '-' is match the first entry before the date
-        #   '=' is match the first entry after, but still on the given date.
-        #
-        #   +2005-05-12 says find the first matching entry after May 12th, 2005 at 0:00
-        #   -2005-05-12 says find the first matching entry before May 12th, 2005 at 0:00
-        #   =2005-05-12 says find the first match after May 12th, 2005 at 0:00 but before
-        #       May 13th, 2005 at 0:00
-        #
-        #   So the proper way of saying 'give me all entries for today' is:
-        #       -r {date:+today}:{date:-tomorrow}
-        #   The default is '=' when not supplied
-        val = revision[5:]
-        match_style = '='
-        if val[:1] in ('+', '-', '='):
-            match_style = val[:1]
-            val = val[1:]
-
-        today = datetime.datetime.today().replace(hour=0,minute=0,second=0,microsecond=0)
-        if val.lower() == 'yesterday':
-            dt = today - datetime.timedelta(days=1)
-        elif val.lower() == 'today':
-            dt = today
-        elif val.lower() == 'tomorrow':
-            dt = today + datetime.timedelta(days=1)
-        else:
-            import re
-            # This should be done outside the function to avoid recompiling it.
-            _date_re = re.compile(
-                    r'(?P<date>(?P<year>\d\d\d\d)-(?P<month>\d\d)-(?P<day>\d\d))?'
-                    r'(,|T)?\s*'
-                    r'(?P<time>(?P<hour>\d\d):(?P<minute>\d\d)(:(?P<second>\d\d))?)?'
-                )
-            m = _date_re.match(val)
-            if not m or (not m.group('date') and not m.group('time')):
-                raise BzrError('Invalid revision date %r' % revision)
-
-            if m.group('date'):
-                year, month, day = int(m.group('year')), int(m.group('month')), int(m.group('day'))
-            else:
-                year, month, day = today.year, today.month, today.day
-            if m.group('time'):
-                hour = int(m.group('hour'))
-                minute = int(m.group('minute'))
-                if m.group('second'):
-                    second = int(m.group('second'))
-                else:
-                    second = 0
-            else:
-                hour, minute, second = 0,0,0
-
-            dt = datetime.datetime(year=year, month=month, day=day,
-                    hour=hour, minute=minute, second=second)
-        first = dt
-        last = None
-        reversed = False
-        if match_style == '-':
-            reversed = True
-        elif match_style == '=':
-            last = dt + datetime.timedelta(days=1)
-
-        if reversed:
-            for i in range(len(revs)-1, -1, -1):
-                r = self.get_revision(revs[i])
-                # TODO: Handle timezone.
-                dt = datetime.datetime.fromtimestamp(r.timestamp)
-                if first >= dt and (last is None or dt >= last):
-                    return i+1
-        else:
-            for i in range(len(revs)):
-                r = self.get_revision(revs[i])
-                # TODO: Handle timezone.
-                dt = datetime.datetime.fromtimestamp(r.timestamp)
-                if first <= dt and (last is None or dt <= last):
-                    return i+1
-    REVISION_NAMESPACES['date:'] = _namespace_date
+    def lookup_revision(self, revno):
+        """Return revision hash for revision number."""
+        if revno == 0:
+            return None
+
+        try:
+            # list is 0-based; revisions are 1-based
+            return self.revision_history()[revno-1]
+        except IndexError:
+            raise BzrError("no such revision %s" % revno)
+
 
     def revision_tree(self, revision_id):
         """Return Tree for a revision on this branch.
 
         `revision_id` may be None for the null revision, in which case
         an `EmptyTree` is returned."""
-        from bzrlib.tree import EmptyTree, RevisionTree
         # TODO: refactor this to use an existing revision object
         # so we don't need to read it in twice.
         if revision_id == None:
-            return EmptyTree(self.get_root_id())
+            return EmptyTree()
         else:
             inv = self.get_revision_inventory(revision_id)
             return RevisionTree(self.text_store, inv)
@@ -1039,10 +827,9 @@
 
         If there are no revisions yet, return an `EmptyTree`.
         """
-        from bzrlib.tree import EmptyTree, RevisionTree
         r = self.last_patch()
         if r == None:
-            return EmptyTree(self.get_root_id())
+            return EmptyTree()
         else:
             return RevisionTree(self.text_store, self.get_revision_inventory(r))
 
@@ -1163,92 +950,6 @@
             self.unlock()
 
 
-    def revert(self, filenames, old_tree=None, backups=True):
-        """Restore selected files to the versions from a previous tree.
-
-        backups
-            If true (default) backups are made of files before
-            they're renamed.
-        """
-        from bzrlib.errors import NotVersionedError, BzrError
-        from bzrlib.atomicfile import AtomicFile
-        from bzrlib.osutils import backup_file
-        
-        inv = self.read_working_inventory()
-        if old_tree is None:
-            old_tree = self.basis_tree()
-        old_inv = old_tree.inventory
-
-        nids = []
-        for fn in filenames:
-            file_id = inv.path2id(fn)
-            if not file_id:
-                raise NotVersionedError("not a versioned file", fn)
-            if not old_inv.has_id(file_id):
-                raise BzrError("file not present in old tree", fn, file_id)
-            nids.append((fn, file_id))
-            
-        # TODO: Rename back if it was previously at a different location
-
-        # TODO: If given a directory, restore the entire contents from
-        # the previous version.
-
-        # TODO: Make a backup to a temporary file.
-
-        # TODO: If the file previously didn't exist, delete it?
-        for fn, file_id in nids:
-            backup_file(fn)
-            
-            f = AtomicFile(fn, 'wb')
-            try:
-                f.write(old_tree.get_file(file_id).read())
-                f.commit()
-            finally:
-                f.close()
-
-
-    def pending_merges(self):
-        """Return a list of pending merges.
-
-        These are revisions that have been merged into the working
-        directory but not yet committed.
-        """
-        cfn = self.controlfilename('pending-merges')
-        if not os.path.exists(cfn):
-            return []
-        p = []
-        for l in self.controlfile('pending-merges', 'r').readlines():
-            p.append(l.rstrip('\n'))
-        return p
-
-
-    def add_pending_merge(self, revision_id):
-        from bzrlib.revision import validate_revision_id
-
-        validate_revision_id(revision_id)
-
-        p = self.pending_merges()
-        if revision_id in p:
-            return
-        p.append(revision_id)
-        self.set_pending_merges(p)
-
-
-    def set_pending_merges(self, rev_list):
-        from bzrlib.atomicfile import AtomicFile
-        self.lock_write()
-        try:
-            f = AtomicFile(self.controlfilename('pending-merges'))
-            try:
-                for l in rev_list:
-                    print >>f, l
-                f.commit()
-            finally:
-                f.close()
-        finally:
-            self.unlock()
-
-
 
 class ScratchBranch(Branch):
     """Special test class: a branch that cleans up after itself.
@@ -1268,10 +969,9 @@
 
         If any files are listed, they are created in the working copy.
         """
-        from tempfile import mkdtemp
         init = False
         if base is None:
-            base = mkdtemp()
+            base = tempfile.mkdtemp()
             init = True
         Branch.__init__(self, base, init=init)
         for d in dirs:
@@ -1290,11 +990,9 @@
         >>> os.path.isfile(os.path.join(clone.base, "file1"))
         True
         """
-        from shutil import copytree
-        from tempfile import mkdtemp
-        base = mkdtemp()
+        base = tempfile.mkdtemp()
         os.rmdir(base)
-        copytree(self.base, base, symlinks=True)
+        shutil.copytree(self.base, base, symlinks=True)
         return ScratchBranch(base=base)
         
     def __del__(self):
@@ -1302,11 +1000,10 @@
 
     def destroy(self):
         """Destroy the test branch, removing the scratch directory."""
-        from shutil import rmtree
         try:
             if self.base:
                 mutter("delete ScratchBranch %s" % self.base)
-                rmtree(self.base)
+                shutil.rmtree(self.base)
         except OSError, e:
             # Work around for shutil.rmtree failing on Windows when
             # readonly files are encountered
@@ -1314,7 +1011,7 @@
             for root, dirs, files in os.walk(self.base, topdown=False):
                 for name in files:
                     os.chmod(os.path.join(root, name), 0700)
-            rmtree(self.base)
+            shutil.rmtree(self.base)
         self.base = None
 
     
@@ -1345,8 +1042,6 @@
     cope with just randomness because running uuidgen every time is
     slow."""
     import re
-    from binascii import hexlify
-    from time import time
 
     # get last component
     idx = name.rfind('/')
@@ -1364,10 +1059,4 @@
     name = re.sub(r'[^\w.]', '', name)
 
     s = hexlify(rand_bytes(8))
-    return '-'.join((name, compact_date(time()), s))
-
-
-def gen_root_id():
-    """Return a new tree-root file id."""
-    return gen_file_id('TREE_ROOT')
-
+    return '-'.join((name, compact_date(time.time()), s))

=== modified file 'bzrlib/changeset.py'
--- bzrlib/changeset.py	2005-07-22 19:54:37 +0000
+++ bzrlib/changeset.py	2005-06-06 04:17:53 +0000
@@ -17,7 +17,6 @@
 import errno
 import patch
 import stat
-from bzrlib.trace import mutter
 """
 Represent and apply a changeset
 """
@@ -25,10 +24,7 @@
 
 NULL_ID = "!NULL"
 
-class OldFailedTreeOp(Exception):
-    def __init__(self):
-        Exception.__init__(self, "bzr-tree-change contains files from a"
-                           " previous failed merge operation.")
+
 def invert_dict(dict):
     newdict = {}
     for (key,value) in dict.iteritems():
@@ -694,7 +690,6 @@
         :type reverse: bool
         :rtype: str
         """
-        mutter("Finding new path for %s" % self.summarize_name(changeset))
         if reverse:
             parent = self.parent
             to_dir = self.dir
@@ -719,7 +714,6 @@
         if from_dir == to_dir:
             dir = os.path.dirname(id_map[self.id])
         else:
-            mutter("path, new_path: %r %r" % (self.path, self.new_path))
             parent_entry = changeset.entries[parent]
             dir = parent_entry.get_new_path(id_map, changeset, reverse)
         if from_name == to_name:
@@ -832,10 +826,10 @@
     my_sort(target_entries, shortest_to_longest)
     return (source_entries, target_entries)
 
-def rename_to_temp_delete(source_entries, inventory, dir, temp_dir, 
-                          conflict_handler, reverse):
+def rename_to_temp_delete(source_entries, inventory, dir, conflict_handler,
+                          reverse):
     """Delete and rename entries as appropriate.  Entries are renamed to temp
-    names.  A map of id -> temp name (or None, for deletions) is returned.
+    names.  A map of id -> temp name is returned.
 
     :param source_entries: The entries to rename and delete
     :type source_entries: List of `ChangesetEntry`
@@ -848,16 +842,16 @@
     :return: a mapping of id to temporary name
     :rtype: Dictionary
     """
+    temp_dir = os.path.join(dir, "temp")
     temp_name = {}
     for i in range(len(source_entries)):
         entry = source_entries[i]
         if entry.is_deletion(reverse):
             path = os.path.join(dir, inventory[entry.id])
             entry.apply(path, conflict_handler, reverse)
-            temp_name[entry.id] = None
 
         else:
-            to_name = os.path.join(temp_dir, str(i))
+            to_name = temp_dir+"/"+str(i)
             src_path = inventory.get(entry.id)
             if src_path is not None:
                 src_path = os.path.join(dir, src_path)
@@ -873,12 +867,12 @@
     return temp_name
 
 
-def rename_to_new_create(changed_inventory, target_entries, inventory, 
-                         changeset, dir, conflict_handler, reverse):
+def rename_to_new_create(temp_name, target_entries, inventory, changeset, dir,
+                         conflict_handler, reverse):
     """Rename entries with temp names to their final names, create new files.
 
-    :param changed_inventory: A mapping of id to temporary name
-    :type changed_inventory: Dictionary
+    :param temp_name: A mapping of id to temporary name
+    :type temp_name: Dictionary
     :param target_entries: The entries to apply changes to
     :type target_entries: List of `ChangesetEntry`
     :param changeset: The changeset to apply
@@ -889,24 +883,22 @@
     :type reverse: bool
     """
     for entry in target_entries:
-        new_tree_path = entry.get_new_path(inventory, changeset, reverse)
-        if new_tree_path is None:
+        new_path = entry.get_new_path(inventory, changeset, reverse)
+        if new_path is None:
             continue
-        new_path = os.path.join(dir, new_tree_path)
-        old_path = changed_inventory.get(entry.id)
+        new_path = os.path.join(dir, new_path)
+        old_path = temp_name.get(entry.id)
         if os.path.exists(new_path):
             if conflict_handler.target_exists(entry, new_path, old_path) == \
                 "skip":
                 continue
         if entry.is_creation(reverse):
             entry.apply(new_path, conflict_handler, reverse)
-            changed_inventory[entry.id] = new_tree_path
         else:
             if old_path is None:
                 continue
             try:
                 os.rename(old_path, new_path)
-                changed_inventory[entry.id] = new_tree_path
             except OSError, e:
                 raise Exception ("%s is missing" % new_path)
 
@@ -1014,19 +1006,6 @@
         Exception.__init__(self, msg)
         self.filename = filename
 
-class NewContentsConflict(Exception):
-    def __init__(self, filename):
-        msg = "Conflicting contents for new file %s" % (filename)
-        Exception.__init__(self, msg)
-
-
-class MissingForMerge(Exception):
-    def __init__(self, filename):
-        msg = "The file %s was modified, but does not exist in this tree"\
-            % (filename)
-        Exception.__init__(self, msg)
-
-
 class ExceptionConflictHandler(object):
     def __init__(self, dir):
         self.dir = dir
@@ -1087,12 +1066,6 @@
     def missing_for_rename(self, filename):
         raise MissingForRename(filename)
 
-    def missing_for_merge(self, file_id, inventory):
-        raise MissingForMerge(inventory.other.get_path(file_id))
-
-    def new_contents_conflict(self, filename, other_contents):
-        raise NewContentsConflict(filename)
-
     def finalize():
         pass
 
@@ -1113,19 +1086,8 @@
     """
     if conflict_handler is None:
         conflict_handler = ExceptionConflictHandler(dir)
-    temp_dir = os.path.join(dir, "bzr-tree-change")
-    try:
-        os.mkdir(temp_dir)
-    except OSError, e:
-        if e.errno == errno.EEXIST:
-            try:
-                os.rmdir(temp_dir)
-            except OSError, e:
-                if e.errno == errno.ENOTEMPTY:
-                    raise OldFailedTreeOp()
-            os.mkdir(temp_dir)
-        else:
-            raise
+    temp_dir = dir+"/temp"
+    os.mkdir(temp_dir)
     
     #apply changes that don't affect filenames
     for entry in changeset.entries.itervalues():
@@ -1140,14 +1102,21 @@
     (source_entries, target_entries) = get_rename_entries(changeset, inventory,
                                                           reverse)
 
-    changed_inventory = rename_to_temp_delete(source_entries, inventory, dir,
-                                              temp_dir, conflict_handler,
-                                              reverse)
+    temp_name = rename_to_temp_delete(source_entries, inventory, dir,
+                                      conflict_handler, reverse)
 
-    rename_to_new_create(changed_inventory, target_entries, inventory,
-                         changeset, dir, conflict_handler, reverse)
+    rename_to_new_create(temp_name, target_entries, inventory, changeset, dir,
+                         conflict_handler, reverse)
     os.rmdir(temp_dir)
-    return changed_inventory
+    r_inventory = invert_dict(inventory)
+    new_entries, removed_entries = get_inventory_change(inventory,
+    r_inventory, changeset, reverse)
+    new_inventory = {}
+    for path, file_id in new_entries.iteritems():
+        new_inventory[file_id] = path
+    for file_id in removed_entries:
+        new_inventory[file_id] = None
+    return new_inventory
 
 
 def apply_changeset_tree(cset, tree, reverse=False):
@@ -1164,13 +1133,17 @@
 def get_inventory_change(inventory, new_inventory, cset, reverse=False):
     new_entries = {}
     remove_entries = []
+    r_inventory = invert_dict(inventory)
+    r_new_inventory = invert_dict(new_inventory)
     for entry in cset.entries.itervalues():
         if entry.needs_rename():
-            new_path = entry.get_new_path(inventory, cset)
-            if new_path is None:
-                remove_entries.append(entry.id)
+            old_path = r_inventory.get(entry.id)
+            if old_path is not None:
+                remove_entries.append(old_path)
             else:
-                new_entries[new_path] = entry.id
+                new_path = entry.get_new_path(inventory, cset)
+                if new_path is not None:
+                    new_entries[new_path] = entry.id
     return new_entries, remove_entries
 
 
@@ -1529,7 +1502,7 @@
 
 
         
-# XXX: Can't we unify this with the regular inventory object
+    
 class Inventory(object):
     def __init__(self, inventory):
         self.inventory = inventory
@@ -1544,23 +1517,15 @@
         return self.inventory.get(id)
 
     def get_name(self, id):
-        path = self.get_path(id)
-        if path is None:
-            return None
-        else:
-            return os.path.basename(path)
+        return os.path.basename(self.get_path(id))
 
     def get_dir(self, id):
         path = self.get_path(id)
         if path == "":
             return None
-        if path is None:
-            return None
         return os.path.dirname(path)
 
     def get_parent(self, id):
-        if self.get_path(id) is None:
-            return None
         directory = self.get_dir(id)
         if directory == '.':
             directory = './.'

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2005-07-11 07:33:45 +0000
+++ bzrlib/check.py	2005-06-20 03:29:21 +0000
@@ -16,76 +16,17 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-def _update_store_entry(obj, obj_id, branch, store_name, store):
-    """This is just a meta-function, which handles both revision entries
-    and inventory entries.
-    """
-    from bzrlib.trace import mutter
-    import tempfile, os, errno
-    from osutils import rename
-    obj_tmp = tempfile.TemporaryFile()
-    obj.write_xml(obj_tmp)
-    obj_tmp.seek(0)
-
-    tmpfd, tmp_path = tempfile.mkstemp(prefix=obj_id, suffix='.gz',
-        dir=branch.controlfilename(store_name))
-    os.close(tmpfd)
-    try:
-        orig_obj_path = branch.controlfilename([store_name, obj_id+'.gz'])
-        # Remove the old entry out of the way
-        rename(orig_obj_path, tmp_path)
-        try:
-            # TODO: We may need to handle the case where the old
-            # entry was not compressed (and thus did not end with .gz)
-
-            store.add(obj_tmp, obj_id) # Add the new one
-            os.remove(tmp_path) # Remove the old name
-            mutter('    Updated %s entry {%s}' % (store_name, obj_id))
-        except:
-            # On any exception, restore the old entry
-            rename(tmp_path, orig_obj_path)
-            raise
-    finally:
-        if os.path.exists(tmp_path):
-            # Unfortunately, the next command might throw
-            # an exception, which will mask a previous exception.
-            os.remove(tmp_path)
-        obj_tmp.close()
-
-def _update_revision_entry(rev, branch):
-    """After updating the values in a revision, make sure to
-    write out the data, but try to do it in an atomic manner.
-
-    :param rev:    The Revision object to store
-    :param branch: The Branch object where this Revision is to be stored.
-    """
-    _update_store_entry(rev, rev.revision_id, branch,
-            'revision-store', branch.revision_store)
-
-def _update_inventory_entry(inv, inv_id, branch):
-    """When an inventory has been modified (such as by adding a unique tree root)
-    this atomically re-generates the file.
-
-    :param inv:     The Inventory
-    :param inv_id:  The inventory id for this inventory
-    :param branch:  The Branch where this entry will be stored.
-    """
-    _update_store_entry(inv, inv_id, branch,
-            'inventory-store', branch.inventory_store)
+
 
 def check(branch):
     """Run consistency checks on a branch.
 
-    TODO: Also check non-mainline revisions mentioned as parents.
-
-    TODO: Check for extra files in the control directory.
+    TODO: Also check non-mailine revisions mentioned as parents.
     """
     from bzrlib.trace import mutter
     from bzrlib.errors import BzrCheckError
     from bzrlib.osutils import fingerprint_file
     from bzrlib.progress import ProgressBar
-    from bzrlib.inventory import ROOT_ID
-    from bzrlib.branch import gen_root_id
 
     branch.lock_read()
 
@@ -99,7 +40,6 @@
         history = branch.revision_history()
         revno = 0
         revcount = len(history)
-        mismatch_inv_id = []
 
         # for all texts checked, text_id -> sha1
         checked_texts = {}
@@ -143,9 +83,6 @@
                                     "by {%s}"
                                     % (rev_id, last_rev_id))
 
-            if rev.inventory_id != rev_id:
-                mismatch_inv_id.append(rev_id)
-
             ## TODO: Check all the required fields are present on the revision.
 
             if rev.inventory_sha1:
@@ -227,8 +164,3 @@
     if (missing_inventory_sha_cnt
         or missing_revision_sha_cnt):
         print '  (use "bzr upgrade" to fix them)'
-
-    if mismatch_inv_id:
-        print '%d revisions have mismatched inventory ids:' % len(mismatch_inv_id)
-        for rev_id in mismatch_inv_id:
-            print '  ', rev_id

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-07-29 17:19:16 +0000
+++ bzrlib/commands.py	2005-06-22 07:18:01 +0000
@@ -19,16 +19,17 @@
 import sys, os
 
 import bzrlib
-from bzrlib.trace import mutter, note, log_error, warning
+from bzrlib.trace import mutter, note, log_error
 from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError
-from bzrlib.branch import find_branch
-from bzrlib import BZRDIR
+from bzrlib.osutils import quotefn
+from bzrlib import Branch, Inventory, InventoryEntry, BZRDIR, \
+     format_date
 
 
 plugin_cmds = {}
 
 
-def register_command(cmd):
+def register_plugin_command(cmd):
     "Utility function to help register a command"
     global plugin_cmds
     k = cmd.__name__
@@ -51,91 +52,41 @@
     assert cmd.startswith("cmd_")
     return cmd[4:].replace('_','-')
 
-
 def _parse_revision_str(revstr):
-    """This handles a revision string -> revno.
-
-    This always returns a list.  The list will have one element for 
-
-    It supports integers directly, but everything else it
-    defers for passing to Branch.get_revision_info()
-
-    >>> _parse_revision_str('234')
-    [234]
-    >>> _parse_revision_str('234..567')
-    [234, 567]
-    >>> _parse_revision_str('..')
-    [None, None]
-    >>> _parse_revision_str('..234')
-    [None, 234]
-    >>> _parse_revision_str('234..')
-    [234, None]
-    >>> _parse_revision_str('234..456..789') # Maybe this should be an error
-    [234, 456, 789]
-    >>> _parse_revision_str('234....789') # Error?
-    [234, None, 789]
-    >>> _parse_revision_str('revid:test@other.com-234234')
-    ['revid:test@other.com-234234']
-    >>> _parse_revision_str('revid:test@other.com-234234..revid:test@other.com-234235')
-    ['revid:test@other.com-234234', 'revid:test@other.com-234235']
-    >>> _parse_revision_str('revid:test@other.com-234234..23')
-    ['revid:test@other.com-234234', 23]
-    >>> _parse_revision_str('date:2005-04-12')
-    ['date:2005-04-12']
-    >>> _parse_revision_str('date:2005-04-12 12:24:33')
-    ['date:2005-04-12 12:24:33']
-    >>> _parse_revision_str('date:2005-04-12T12:24:33')
-    ['date:2005-04-12T12:24:33']
-    >>> _parse_revision_str('date:2005-04-12,12:24:33')
-    ['date:2005-04-12,12:24:33']
-    >>> _parse_revision_str('-5..23')
-    [-5, 23]
-    >>> _parse_revision_str('-5')
-    [-5]
-    >>> _parse_revision_str('123a')
-    ['123a']
-    >>> _parse_revision_str('abc')
-    ['abc']
+    """This handles a revision string -> revno. 
+
+    There are several possibilities:
+
+        '234'       -> 234
+        '234:345'   -> [234, 345]
+        ':234'      -> [None, 234]
+        '234:'      -> [234, None]
+
+    In the future we will also support:
+        'uuid:blah-blah-blah'   -> ?
+        'hash:blahblahblah'     -> ?
+        potentially:
+        'tag:mytag'             -> ?
     """
-    import re
-    old_format_re = re.compile('\d*:\d*')
-    m = old_format_re.match(revstr)
-    if m:
-        warning('Colon separator for revision numbers is deprecated.'
-                ' Use .. instead')
-        revs = []
-        for rev in revstr.split(':'):
-            if rev:
-                revs.append(int(rev))
-            else:
-                revs.append(None)
-        return revs
-    revs = []
-    for x in revstr.split('..'):
-        if not x:
-            revs.append(None)
-        else:
-            try:
-                revs.append(int(x))
-            except ValueError:
-                revs.append(x)
+    if revstr.find(':') != -1:
+        revs = revstr.split(':')
+        if len(revs) > 2:
+            raise ValueError('More than 2 pieces not supported for --revision: %r' % revstr)
+
+        if not revs[0]:
+            revs[0] = None
+        else:
+            revs[0] = int(revs[0])
+
+        if not revs[1]:
+            revs[1] = None
+        else:
+            revs[1] = int(revs[1])
+    else:
+        revs = int(revstr)
     return revs
 
 
-def get_merge_type(typestring):
-    """Attempt to find the merge class/factory associated with a string."""
-    from merge import merge_types
-    try:
-        return merge_types[typestring][0]
-    except KeyError:
-        templ = '%s%%7s: %%s' % (' '*12)
-        lines = [templ % (f[0], f[1][1]) for f in merge_types.iteritems()]
-        type_list = '\n'.join(lines)
-        msg = "No known merge type %s. Supported types are:\n%s" %\
-            (typestring, type_list)
-        raise BzrCommandError(msg)
-    
-
 
 def _get_cmd_dict(plugins_override=True):
     d = {}
@@ -214,12 +165,9 @@
         assert isinstance(arguments, dict)
         cmdargs = options.copy()
         cmdargs.update(arguments)
-        if self.__doc__ == Command.__doc__:
-            from warnings import warn
-            warn("No help message set for %r" % self)
+        assert self.__doc__ != Command.__doc__, \
+               ("No help message set for %r" % self)
         self.status = self.run(**cmdargs)
-        if self.status is None:
-            self.status = 0
 
     
     def run(self):
@@ -349,27 +297,24 @@
     directory is shown.  Otherwise, only the status of the specified
     files or directories is reported.  If a directory is given, status
     is reported for everything inside that directory.
-
-    If a revision is specified, the changes since that revision are shown.
     """
     takes_args = ['file*']
-    takes_options = ['all', 'show-ids', 'revision']
+    takes_options = ['all', 'show-ids']
     aliases = ['st', 'stat']
     
     def run(self, all=False, show_ids=False, file_list=None):
         if file_list:
-            b = find_branch(file_list[0])
+            b = Branch(file_list[0])
             file_list = [b.relpath(x) for x in file_list]
             # special case: only one path was given and it's the root
             # of the branch
             if file_list == ['']:
                 file_list = None
         else:
-            b = find_branch('.')
-            
-        from bzrlib.status import show_status
-        show_status(b, show_unchanged=all, show_ids=show_ids,
-                    specific_files=file_list)
+            b = Branch('.')
+        import status
+        status.show_status(b, show_unchanged=all, show_ids=show_ids,
+                           specific_files=file_list)
 
 
 class cmd_cat_revision(Command):
@@ -379,8 +324,7 @@
     takes_args = ['revision_id']
     
     def run(self, revision_id):
-        from bzrlib.xml import pack_xml
-        pack_xml(find_branch('.').get_revision(revision_id), sys.stdout)
+        Branch('.').get_revision(revision_id).write_xml(sys.stdout)
 
 
 class cmd_revno(Command):
@@ -388,29 +332,7 @@
 
     This is equal to the number of revisions on this branch."""
     def run(self):
-        print find_branch('.').revno()
-
-class cmd_revision_info(Command):
-    """Show revision number and revision id for a given revision identifier.
-    """
-    hidden = True
-    takes_args = ['revision_info*']
-    takes_options = ['revision']
-    def run(self, revision=None, revision_info_list=None):
-        from bzrlib.branch import find_branch
-
-        revs = []
-        if revision is not None:
-            revs.extend(revision)
-        if revision_info_list is not None:
-            revs.extend(revision_info_list)
-        if len(revs) == 0:
-            raise BzrCommandError('You must supply a revision identifier')
-
-        b = find_branch('.')
-
-        for rev in revs:
-            print '%4d %s' % b.get_revision_info(rev)
+        print Branch('.').revno()
 
     
 class cmd_add(Command):
@@ -426,20 +348,19 @@
     whether already versioned or not, are searched for files or
     subdirectories that are neither versioned or ignored, and these
     are added.  This search proceeds recursively into versioned
-    directories.  If no names are given '.' is assumed.
+    directories.
 
-    Therefore simply saying 'bzr add' will version all files that
+    Therefore simply saying 'bzr add .' will version all files that
     are currently unknown.
 
     TODO: Perhaps adding a file whose directly is not versioned should
     recursively add that parent, rather than giving an error?
     """
-    takes_args = ['file*']
+    takes_args = ['file+']
     takes_options = ['verbose', 'no-recurse']
     
     def run(self, file_list, verbose=False, no_recurse=False):
-        from bzrlib.add import smart_add
-        smart_add(file_list, verbose, not no_recurse)
+        bzrlib.add.smart_add(file_list, verbose, not no_recurse)
 
 
 
@@ -451,12 +372,15 @@
     takes_args = ['dir+']
 
     def run(self, dir_list):
+        import os
+        import bzrlib.branch
+        
         b = None
         
         for d in dir_list:
             os.mkdir(d)
             if not b:
-                b = find_branch(d)
+                b = bzrlib.branch.Branch(d)
             b.add([d], verbose=True)
 
 
@@ -466,7 +390,7 @@
     hidden = True
     
     def run(self, filename):
-        print find_branch(filename).relpath(filename)
+        print Branch(filename).relpath(filename)
 
 
 
@@ -475,14 +399,11 @@
     takes_options = ['revision', 'show-ids']
     
     def run(self, revision=None, show_ids=False):
-        b = find_branch('.')
+        b = Branch('.')
         if revision == None:
             inv = b.read_working_inventory()
         else:
-            if len(revision) > 1:
-                raise BzrCommandError('bzr inventory --revision takes'
-                    ' exactly one revision identifier')
-            inv = b.get_revision_inventory(b.lookup_revision(revision[0]))
+            inv = b.get_revision_inventory(b.lookup_revision(revision))
 
         for path, entry in inv.entries():
             if show_ids:
@@ -501,7 +422,7 @@
     """
     takes_args = ['source$', 'dest']
     def run(self, source_list, dest):
-        b = find_branch('.')
+        b = Branch('.')
 
         b.move([b.relpath(s) for s in source_list], b.relpath(dest))
 
@@ -523,7 +444,7 @@
     takes_args = ['from_name', 'to_name']
     
     def run(self, from_name, to_name):
-        b = find_branch('.')
+        b = Branch('.')
         b.rename_one(b.relpath(from_name), b.relpath(to_name))
 
 
@@ -548,16 +469,14 @@
 
     def run(self, location=None):
         from bzrlib.merge import merge
-        import tempfile
-        from shutil import rmtree
         import errno
         
-        br_to = find_branch('.')
+        br_to = Branch('.')
         stored_loc = None
         try:
             stored_loc = br_to.controlfile("x-pull", "rb").read().rstrip('\n')
         except IOError, e:
-            if e.errno != errno.ENOENT:
+            if errno == errno.ENOENT:
                 raise
         if location is None:
             if stored_loc is None:
@@ -565,27 +484,18 @@
             else:
                 print "Using last location: %s" % stored_loc
                 location = stored_loc
-        cache_root = tempfile.mkdtemp()
-        from bzrlib.branch import DivergedBranches
+        from branch import find_branch, DivergedBranches
         br_from = find_branch(location)
         location = pull_loc(br_from)
         old_revno = br_to.revno()
         try:
-            from branch import find_cached_branch, DivergedBranches
-            br_from = find_cached_branch(location, cache_root)
-            location = pull_loc(br_from)
-            old_revno = br_to.revno()
-            try:
-                br_to.update_revisions(br_from)
-            except DivergedBranches:
-                raise BzrCommandError("These branches have diverged."
-                    "  Try merge.")
-                
-            merge(('.', -1), ('.', old_revno), check_clean=False)
-            if location != stored_loc:
-                br_to.controlfile("x-pull", "wb").write(location + "\n")
-        finally:
-            rmtree(cache_root)
+            br_to.update_revisions(br_from)
+        except DivergedBranches:
+            raise BzrCommandError("These branches have diverged.  Try merge.")
+            
+        merge(('.', -1), ('.', old_revno), check_clean=False)
+        if location != stored_loc:
+            br_to.controlfile("x-pull", "wb").write(location + "\n")
 
 
 
@@ -604,65 +514,44 @@
     def run(self, from_location, to_location=None, revision=None):
         import errno
         from bzrlib.merge import merge
-        from bzrlib.branch import DivergedBranches, NoSuchRevision, \
-             find_cached_branch, Branch
+        from branch import find_branch, DivergedBranches, NoSuchRevision
         from shutil import rmtree
-        from meta_store import CachedStore
-        import tempfile
-        cache_root = tempfile.mkdtemp()
-
-        if revision is None:
-            revision = [None]
-        elif len(revision) > 1:
-            raise BzrCommandError('bzr branch --revision takes exactly 1 revision value')
-
-        try:
-            try:
-                br_from = find_cached_branch(from_location, cache_root)
-            except OSError, e:
-                if e.errno == errno.ENOENT:
-                    raise BzrCommandError('Source location "%s" does not'
-                                          ' exist.' % to_location)
-                else:
-                    raise
-
-            if to_location is None:
-                to_location = os.path.basename(from_location.rstrip("/\\"))
-
-            try:
-                os.mkdir(to_location)
-            except OSError, e:
-                if e.errno == errno.EEXIST:
-                    raise BzrCommandError('Target directory "%s" already'
-                                          ' exists.' % to_location)
-                if e.errno == errno.ENOENT:
-                    raise BzrCommandError('Parent of "%s" does not exist.' %
-                                          to_location)
-                else:
-                    raise
-            br_to = Branch(to_location, init=True)
-
-            br_to.set_root_id(br_from.get_root_id())
-
-            if revision:
-                if revision[0] is None:
-                    revno = br_from.revno()
-                else:
-                    revno, rev_id = br_from.get_revision_info(revision[0])
-                try:
-                    br_to.update_revisions(br_from, stop_revision=revno)
-                except NoSuchRevision:
-                    rmtree(to_location)
-                    msg = "The branch %s has no revision %d." % (from_location,
-                                                                 revno)
-                    raise BzrCommandError(msg)
-            
-            merge((to_location, -1), (to_location, 0), this_dir=to_location,
-                  check_clean=False, ignore_zero=True)
-            from_location = pull_loc(br_from)
-            br_to.controlfile("x-pull", "wb").write(from_location + "\n")
-        finally:
-            rmtree(cache_root)
+        try:
+            br_from = find_branch(from_location)
+        except OSError, e:
+            if e.errno == errno.ENOENT:
+                raise BzrCommandError('Source location "%s" does not exist.' %
+                                      to_location)
+            else:
+                raise
+
+        if to_location is None:
+            to_location = os.path.basename(from_location.rstrip("/\\"))
+
+        try:
+            os.mkdir(to_location)
+        except OSError, e:
+            if e.errno == errno.EEXIST:
+                raise BzrCommandError('Target directory "%s" already exists.' %
+                                      to_location)
+            if e.errno == errno.ENOENT:
+                raise BzrCommandError('Parent of "%s" does not exist.' %
+                                      to_location)
+            else:
+                raise
+        br_to = Branch(to_location, init=True)
+
+        try:
+            br_to.update_revisions(br_from, stop_revision=revision)
+        except NoSuchRevision:
+            rmtree(to_location)
+            msg = "The branch %s has no revision %d." % (from_location,
+                                                         revision)
+            raise BzrCommandError(msg)
+        merge((to_location, -1), (to_location, 0), this_dir=to_location,
+              check_clean=False, ignore_zero=True)
+        from_location = pull_loc(br_from)
+        br_to.controlfile("x-pull", "wb").write(from_location + "\n")
 
 
 def pull_loc(branch):
@@ -685,7 +574,7 @@
     takes_args = ['dir?']
 
     def run(self, dir='.'):
-        b = find_branch(dir)
+        b = Branch(dir)
         old_inv = b.basis_tree().inventory
         new_inv = b.read_working_inventory()
 
@@ -702,6 +591,7 @@
     def run(self, branch=None):
         import info
 
+        from branch import find_branch
         b = find_branch(branch)
         info.show_info(b)
 
@@ -716,7 +606,7 @@
     takes_options = ['verbose']
     
     def run(self, file_list, verbose=False):
-        b = find_branch(file_list[0])
+        b = Branch(file_list[0])
         b.remove([b.relpath(f) for f in file_list], verbose=verbose)
 
 
@@ -730,7 +620,7 @@
     hidden = True
     takes_args = ['filename']
     def run(self, filename):
-        b = find_branch(filename)
+        b = Branch(filename)
         i = b.inventory.path2id(b.relpath(filename))
         if i == None:
             raise BzrError("%r is not a versioned file" % filename)
@@ -746,7 +636,7 @@
     hidden = True
     takes_args = ['filename']
     def run(self, filename):
-        b = find_branch(filename)
+        b = Branch(filename)
         inv = b.inventory
         fid = inv.path2id(b.relpath(filename))
         if fid == None:
@@ -759,14 +649,14 @@
     """Display list of revision ids on this branch."""
     hidden = True
     def run(self):
-        for patchid in find_branch('.').revision_history():
+        for patchid in Branch('.').revision_history():
             print patchid
 
 
 class cmd_directories(Command):
     """Display list of versioned directories in this branch."""
     def run(self):
-        for name, ie in find_branch('.').read_working_inventory().directories():
+        for name, ie in Branch('.').read_working_inventory().directories():
             if name == '':
                 print '.'
             else:
@@ -787,7 +677,6 @@
         bzr commit -m 'imported project'
     """
     def run(self):
-        from bzrlib.branch import Branch
         Branch('.', init=True)
 
 
@@ -821,6 +710,7 @@
 
     def run(self, revision=None, file_list=None, diff_options=None):
         from bzrlib.diff import show_diff
+        from bzrlib import find_branch
 
         if file_list:
             b = find_branch(file_list[0])
@@ -829,16 +719,9 @@
                 # just pointing to top-of-tree
                 file_list = None
         else:
-            b = find_branch('.')
-
-        # TODO: Make show_diff support taking 2 arguments
-        base_rev = None
-        if revision is not None:
-            if len(revision) != 1:
-                raise BzrCommandError('bzr diff --revision takes exactly one revision identifier')
-            base_rev = revision[0]
+            b = Branch('.')
     
-        show_diff(b, base_rev, specific_files=file_list,
+        show_diff(b, revision, specific_files=file_list,
                   external_diff_options=diff_options)
 
 
@@ -851,7 +734,7 @@
     TODO: Show files deleted since a previous revision, or between two revisions.
     """
     def run(self, show_ids=False):
-        b = find_branch('.')
+        b = Branch('.')
         old = b.basis_tree()
         new = b.working_tree()
 
@@ -872,13 +755,26 @@
     """List files modified in working tree."""
     hidden = True
     def run(self):
-        from bzrlib.diff import compare_trees
-
-        b = find_branch('.')
-        td = compare_trees(b.basis_tree(), b.working_tree())
-
-        for path, id, kind in td.modified:
-            print path
+        import statcache
+        b = Branch('.')
+        inv = b.read_working_inventory()
+        sc = statcache.update_cache(b, inv)
+        basis = b.basis_tree()
+        basis_inv = basis.inventory
+        
+        # We used to do this through iter_entries(), but that's slow
+        # when most of the files are unmodified, as is usually the
+        # case.  So instead we iterate by inventory entry, and only
+        # calculate paths as necessary.
+
+        for file_id in basis_inv:
+            cacheentry = sc.get(file_id)
+            if not cacheentry:                 # deleted
+                continue
+            ie = basis_inv[file_id]
+            if cacheentry[statcache.SC_SHA1] != ie.text_sha1:
+                path = inv.id2path(file_id)
+                print path
 
 
 
@@ -886,7 +782,7 @@
     """List files added in working tree."""
     hidden = True
     def run(self):
-        b = find_branch('.')
+        b = Branch('.')
         wt = b.working_tree()
         basis_inv = b.basis_tree().inventory
         inv = wt.inventory
@@ -908,6 +804,7 @@
     takes_args = ['filename?']
     def run(self, filename=None):
         """Print the branch root."""
+        from branch import find_branch
         b = find_branch(filename)
         print getattr(b, 'base', None) or getattr(b, 'baseurl')
 
@@ -919,25 +816,19 @@
     -r revision requests a specific revision, -r :end or -r begin: are
     also valid.
 
-    --message allows you to give a regular expression, which will be evaluated
-    so that only matching entries will be displayed.
-
     TODO: Make --revision support uuid: and hash: [future tag:] notation.
   
     """
 
     takes_args = ['filename?']
-    takes_options = ['forward', 'timezone', 'verbose', 'show-ids', 'revision','long', 'message']
+    takes_options = ['forward', 'timezone', 'verbose', 'show-ids', 'revision']
     
     def run(self, filename=None, timezone='original',
             verbose=False,
             show_ids=False,
             forward=False,
-            revision=None,
-            message=None,
-            long=False):
-        from bzrlib.branch import find_branch
-        from bzrlib.log import log_formatter, show_log
+            revision=None):
+        from bzrlib import show_log, find_branch
         import codecs
 
         direction = (forward and 'forward') or 'reverse'
@@ -953,21 +844,15 @@
             b = find_branch('.')
             file_id = None
 
-        if revision is None:
-            rev1 = None
-            rev2 = None
-        elif len(revision) == 1:
-            rev1 = rev2 = b.get_revision_info(revision[0])[0]
-        elif len(revision) == 2:
-            rev1 = b.get_revision_info(revision[0])[0]
-            rev2 = b.get_revision_info(revision[1])[0]
+        if revision == None:
+            revision = [None, None]
+        elif isinstance(revision, int):
+            revision = [revision, revision]
         else:
-            raise BzrCommandError('bzr log --revision takes one or two values.')
-
-        if rev1 == 0:
-            rev1 = None
-        if rev2 == 0:
-            rev2 = None
+            # pair of revisions?
+            pass
+            
+        assert len(revision) == 2
 
         mutter('encoding log as %r' % bzrlib.user_encoding)
 
@@ -975,23 +860,14 @@
         # in e.g. the default C locale.
         outf = codecs.getwriter(bzrlib.user_encoding)(sys.stdout, errors='replace')
 
-        if long:
-            log_format = 'long'
-        else:
-            log_format = 'short'
-        lf = log_formatter(log_format,
-                           show_ids=show_ids,
-                           to_file=outf,
-                           show_timezone=timezone)
-
-        show_log(b,
-                 lf,
-                 file_id,
+        show_log(b, file_id,
+                 show_timezone=timezone,
                  verbose=verbose,
+                 show_ids=show_ids,
+                 to_file=outf,
                  direction=direction,
-                 start_revision=rev1,
-                 end_revision=rev2,
-                 search=message)
+                 start_revision=revision[0],
+                 end_revision=revision[1])
 
 
 
@@ -1002,7 +878,7 @@
     hidden = True
     takes_args = ["filename"]
     def run(self, filename):
-        b = find_branch(filename)
+        b = Branch(filename)
         inv = b.read_working_inventory()
         file_id = inv.path2id(b.relpath(filename))
         for revno, revision_id, what in bzrlib.log.find_touching_revisions(b, file_id):
@@ -1016,7 +892,7 @@
     """
     hidden = True
     def run(self, revision=None, verbose=False):
-        b = find_branch('.')
+        b = Branch('.')
         if revision == None:
             tree = b.working_tree()
         else:
@@ -1040,8 +916,7 @@
 class cmd_unknowns(Command):
     """List unknown files."""
     def run(self):
-        from bzrlib.osutils import quotefn
-        for f in find_branch('.').unknowns():
+        for f in Branch('.').unknowns():
             print quotefn(f)
 
 
@@ -1069,7 +944,7 @@
         from bzrlib.atomicfile import AtomicFile
         import os.path
 
-        b = find_branch('.')
+        b = Branch('.')
         ifn = b.abspath('.bzrignore')
 
         if os.path.exists(ifn):
@@ -1109,7 +984,7 @@
 
     See also: bzr ignore"""
     def run(self):
-        tree = find_branch('.').working_tree()
+        tree = Branch('.').working_tree()
         for path, file_class, kind, file_id in tree.list_files():
             if file_class != 'I':
                 continue
@@ -1133,7 +1008,7 @@
         except ValueError:
             raise BzrCommandError("not a valid revision-number: %r" % revno)
 
-        print find_branch('.').lookup_revision(revno)
+        print Branch('.').lookup_revision(revno)
 
 
 class cmd_export(Command):
@@ -1142,35 +1017,18 @@
     If no revision is specified this exports the last committed revision.
 
     Format may be an "exporter" name, such as tar, tgz, tbz2.  If none is
-    given, try to find the format with the extension. If no extension
-    is found exports to a directory (equivalent to --format=dir).
-
-    Root may be the top directory for tar, tgz and tbz2 formats. If none
-    is given, the top directory will be the root name of the file."""
+    given, exports to a directory (equivalent to --format=dir)."""
     # TODO: list known exporters
     takes_args = ['dest']
-    takes_options = ['revision', 'format', 'root']
-    def run(self, dest, revision=None, format=None, root=None):
-        import os.path
-        b = find_branch('.')
-        if revision is None:
-            rev_id = b.last_patch()
+    takes_options = ['revision', 'format']
+    def run(self, dest, revision=None, format='dir'):
+        b = Branch('.')
+        if revision == None:
+            rh = b.revision_history()[-1]
         else:
-            if len(revision) != 1:
-                raise BzrError('bzr export --revision takes exactly 1 argument')
-            revno, rev_id = b.get_revision_info(revision[0])
-        t = b.revision_tree(rev_id)
-        root, ext = os.path.splitext(dest)
-        if not format:
-            if ext in (".tar",):
-                format = "tar"
-            elif ext in (".gz", ".tgz"):
-                format = "tgz"
-            elif ext in (".bz2", ".tbz2"):
-                format = "tbz2"
-            else:
-                format = "dir"
-        t.export(dest, format, root)
+            rh = b.lookup_revision(int(revision))
+        t = b.revision_tree(rh)
+        t.export(dest, format)
 
 
 class cmd_cat(Command):
@@ -1182,10 +1040,8 @@
     def run(self, filename, revision=None):
         if revision == None:
             raise BzrCommandError("bzr cat requires a revision number")
-        elif len(revision) != 1:
-            raise BzrCommandError("bzr cat --revision takes exactly one number")
-        b = find_branch('.')
-        b.print_file(b.relpath(filename), revision[0])
+        b = Branch('.')
+        b.print_file(b.relpath(filename), int(revision))
 
 
 class cmd_local_time_offset(Command):
@@ -1212,28 +1068,16 @@
     TODO: Strict commit that fails if there are unknown or deleted files.
     """
     takes_args = ['selected*']
-    takes_options = ['message', 'file', 'verbose', 'unchanged']
+    takes_options = ['message', 'file', 'verbose']
     aliases = ['ci', 'checkin']
 
-    def run(self, message=None, file=None, verbose=True, selected_list=None,
-            unchanged=False):
-        from bzrlib.errors import PointlessCommit
-        from bzrlib.osutils import get_text_message
+    def run(self, message=None, file=None, verbose=True, selected_list=None):
+        from bzrlib.commit import commit
 
         ## Warning: shadows builtin file()
         if not message and not file:
-            import cStringIO
-            stdout = sys.stdout
-            catcher = cStringIO.StringIO()
-            sys.stdout = catcher
-            cmd_status({"file_list":selected_list}, {})
-            info = catcher.getvalue()
-            sys.stdout = stdout
-            message = get_text_message(info)
-            
-            if message is None:
-                raise BzrCommandError("please specify a commit message",
-                                      ["use either --message or --file"])
+            raise BzrCommandError("please specify a commit message",
+                                  ["use either --message or --file"])
         elif message and file:
             raise BzrCommandError("please specify either --message or --file")
         
@@ -1241,17 +1085,8 @@
             import codecs
             message = codecs.open(file, 'rt', bzrlib.user_encoding).read()
 
-        b = find_branch('.')
-
-        try:
-            b.commit(message, verbose=verbose,
-                     specific_files=selected_list,
-                     allow_pointless=unchanged)
-        except PointlessCommit:
-            # FIXME: This should really happen before the file is read in;
-            # perhaps prepare the commit; get the message; then actually commit
-            raise BzrCommandError("no changes to commit",
-                                  ["use --unchanged to commit anyhow"])
+        b = Branch('.')
+        commit(b, message, verbose=verbose, specific_files=selected_list)
 
 
 class cmd_check(Command):
@@ -1266,30 +1101,9 @@
     takes_args = ['dir?']
 
     def run(self, dir='.'):
-        from bzrlib.check import check
-        check(find_branch(dir))
-
-
-
-class cmd_scan_cache(Command):
-    hidden = True
-    def run(self):
-        from bzrlib.hashcache import HashCache
-        import os
-
-        c = HashCache('.')
-        c.read()
-        c.scan()
-            
-        print '%6d stats' % c.stat_count
-        print '%6d in hashcache' % len(c._cache)
-        print '%6d files removed from cache' % c.removed_count
-        print '%6d hashes updated' % c.update_count
-        print '%6d files changed too recently to cache' % c.danger_count
-
-        if c.needs_write:
-            c.write()
-            
+        import bzrlib.check
+        bzrlib.check.check(Branch(dir))
+
 
 
 class cmd_upgrade(Command):
@@ -1302,7 +1116,7 @@
 
     def run(self, dir='.'):
         from bzrlib.upgrade import upgrade
-        upgrade(find_branch(dir))
+        upgrade(Branch(dir))
 
 
 
@@ -1320,10 +1134,9 @@
 class cmd_selftest(Command):
     """Run internal test suite"""
     hidden = True
-    takes_options = ['verbose']
-    def run(self, verbose=False):
+    def run(self):
         from bzrlib.selftest import selftest
-        return int(not selftest(verbose=verbose))
+        return int(not selftest())
 
 
 class cmd_version(Command):
@@ -1361,8 +1174,6 @@
     ['..', -1]
     >>> parse_spec("../f/@35")
     ['../f', 35]
-    >>> parse_spec('./@revid:john@arbash-meinel.com-20050711044610-3ca0327c6a222f67')
-    ['.', 'revid:john@arbash-meinel.com-20050711044610-3ca0327c6a222f67']
     """
     if spec is None:
         return [None, None]
@@ -1372,12 +1183,8 @@
         if parsed[1] == "":
             parsed[1] = -1
         else:
-            try:
-                parsed[1] = int(parsed[1])
-            except ValueError:
-                pass # We can allow stuff like ./@revid:blahblahblah
-            else:
-                assert parsed[1] >=0
+            parsed[1] = int(parsed[1])
+            assert parsed[1] >=0
     else:
         parsed = [spec, None]
     return parsed
@@ -1407,51 +1214,29 @@
     --force is given.
     """
     takes_args = ['other_spec', 'base_spec?']
-    takes_options = ['force', 'merge-type']
+    takes_options = ['force']
 
-    def run(self, other_spec, base_spec=None, force=False, merge_type=None):
+    def run(self, other_spec, base_spec=None, force=False):
         from bzrlib.merge import merge
-        from bzrlib.merge_core import ApplyMerge3
-        if merge_type is None:
-            merge_type = ApplyMerge3
         merge(parse_spec(other_spec), parse_spec(base_spec),
-              check_clean=(not force), merge_type=merge_type)
-
+              check_clean=(not force))
 
 
 class cmd_revert(Command):
-    """Restore selected files from a previous revision.
-    """
-    takes_args = ['file+']
-    def run(self, file_list):
-        from bzrlib.branch import find_branch
-        
-        if not file_list:
-            file_list = ['.']
-            
-        b = find_branch(file_list[0])
-
-        b.revert([b.relpath(f) for f in file_list])
-
-
-class cmd_merge_revert(Command):
     """Reverse all changes since the last commit.
 
-    Only versioned files are affected.  By default, any files that are changed
-    will be backed up first.  Backup files have a '~' appended to their name.
+    Only versioned files are affected.
+
+    TODO: Store backups of any files that will be reverted, so
+          that the revert can be undone.          
     """
-    takes_options = ['revision', 'no-backup']
+    takes_options = ['revision']
 
-    def run(self, revision=None, no_backup=False):
+    def run(self, revision=-1):
         from bzrlib.merge import merge
-        if revision is None:
-            revision = [-1]
-        elif len(revision) != 1:
-            raise BzrCommandError('bzr merge-revert --revision takes exactly 1 argument')
-        merge(('.', revision[0]), parse_spec('.'),
+        merge(('.', revision), parse_spec('.'),
               check_clean=False,
-              ignore_zero=True,
-              backup_files=not no_backup)
+              ignore_zero=True)
 
 
 class cmd_assert_fail(Command):
@@ -1473,22 +1258,15 @@
         help.help(topic)
 
 
-
-
-class cmd_plugins(Command):
-    """List plugins"""
+class cmd_update_stat_cache(Command):
+    """Update stat-cache mapping inodes to SHA-1 hashes.
+
+    For testing only."""
     hidden = True
     def run(self):
-        import bzrlib.plugin
-        from inspect import getdoc
-        from pprint import pprint
-        for plugin in bzrlib.plugin.all_plugins:
-            print plugin.__path__[0]
-            d = getdoc(plugin)
-            if d:
-                print '\t', d.split('\n')[0]
-
-        #pprint(bzrlib.plugin.all_plugins)
+        import statcache
+        b = Branch('.')
+        statcache.update_cache(b.base, b.read_working_inventory())
 
 
 
@@ -1512,12 +1290,7 @@
     'verbose':                None,
     'version':                None,
     'email':                  None,
-    'unchanged':              None,
     'update':                 None,
-    'long':                   None,
-    'root':                   str,
-    'no-backup':              None,
-    'merge-type':             get_merge_type,
     }
 
 SHORT_OPTIONS = {
@@ -1526,7 +1299,6 @@
     'm':                      'message',
     'r':                      'revision',
     'v':                      'verbose',
-    'l':                      'long',
 }
 
 
@@ -1547,13 +1319,15 @@
     >>> parse_args('commit --message=biter'.split())
     (['commit'], {'message': u'biter'})
     >>> parse_args('log -r 500'.split())
-    (['log'], {'revision': [500]})
-    >>> parse_args('log -r500..600'.split())
+    (['log'], {'revision': 500})
+    >>> parse_args('log -r500:600'.split())
     (['log'], {'revision': [500, 600]})
-    >>> parse_args('log -vr500..600'.split())
+    >>> parse_args('log -vr500:600'.split())
     (['log'], {'verbose': True, 'revision': [500, 600]})
-    >>> parse_args('log -rv500..600'.split()) #the r takes an argument
-    (['log'], {'revision': ['v500', 600]})
+    >>> parse_args('log -rv500:600'.split()) #the r takes an argument
+    Traceback (most recent call last):
+    ...
+    ValueError: invalid literal for int(): v500
     """
     args = []
     opts = {}
@@ -1693,28 +1467,28 @@
                     This is also a non-master option.
         --help      Run help and exit, also a non-master option (I think that should stay, though)
 
-    >>> argv, opts = _parse_master_args(['--test'])
+    >>> argv, opts = _parse_master_args(['bzr', '--test'])
     Traceback (most recent call last):
     ...
     BzrCommandError: Invalid master option: 'test'
-    >>> argv, opts = _parse_master_args(['--version', 'command'])
+    >>> argv, opts = _parse_master_args(['bzr', '--version', 'command'])
     >>> print argv
     ['command']
     >>> print opts['version']
     True
-    >>> argv, opts = _parse_master_args(['--profile', 'command', '--more-options'])
+    >>> argv, opts = _parse_master_args(['bzr', '--profile', 'command', '--more-options'])
     >>> print argv
     ['command', '--more-options']
     >>> print opts['profile']
     True
-    >>> argv, opts = _parse_master_args(['--no-plugins', 'command'])
+    >>> argv, opts = _parse_master_args(['bzr', '--no-plugins', 'command'])
     >>> print argv
     ['command']
     >>> print opts['no-plugins']
     True
     >>> print opts['profile']
     False
-    >>> argv, opts = _parse_master_args(['command', '--profile'])
+    >>> argv, opts = _parse_master_args(['bzr', 'command', '--profile'])
     >>> print argv
     ['command', '--profile']
     >>> print opts['profile']
@@ -1727,6 +1501,10 @@
         'help':False
     }
 
+    # This is the point where we could hook into argv[0] to determine
+    # what front-end is supposed to be run
+    # For now, we are just ignoring it.
+    cmd_name = argv.pop(0)
     for arg in argv[:]:
         if arg[:2] != '--': # at the first non-option, we return the rest
             break
@@ -1746,43 +1524,44 @@
 
     This is similar to main(), but without all the trappings for
     logging and error handling.  
-    
-    argv
-       The command-line arguments, without the program name.
-    
-    Returns a command status or raises an exception.
     """
     argv = [a.decode(bzrlib.user_encoding) for a in argv]
-
-    # some options like --builtin and --no-plugins have special effects
-    argv, master_opts = _parse_master_args(argv)
-    if not master_opts['no-plugins']:
-        from bzrlib.plugin import load_plugins
-        load_plugins()
-
-    args, opts = parse_args(argv)
-
-    if master_opts.get('help') or 'help' in opts:
-        from bzrlib.help import help
-        if argv:
-            help(argv[0])
-        else:
-            help()
-        return 0            
-        
-    if 'version' in opts:
-        show_version()
-        return 0
-    
-    if args and args[0] == 'builtin':
-        include_plugins=False
-        args = args[1:]
     
     try:
+        # some options like --builtin and --no-plugins have special effects
+        argv, master_opts = _parse_master_args(argv)
+        if 'no-plugins' not in master_opts:
+            bzrlib.load_plugins()
+
+        args, opts = parse_args(argv)
+
+        if master_opts['help']:
+            from bzrlib.help import help
+            if argv:
+                help(argv[0])
+            else:
+                help()
+            return 0            
+            
+        if 'help' in opts:
+            from bzrlib.help import help
+            if args:
+                help(args[0])
+            else:
+                help()
+            return 0
+        elif 'version' in opts:
+            show_version()
+            return 0
+        elif args and args[0] == 'builtin':
+            include_plugins=False
+            args = args[1:]
         cmd = str(args.pop(0))
     except IndexError:
-        print >>sys.stderr, "please try 'bzr help' for help"
+        import help
+        help.help()
         return 1
+          
 
     plugins_override = not (master_opts['builtin'])
     canonical_cmd, cmd_class = get_cmd_class(cmd, plugins_override=plugins_override)
@@ -1847,13 +1626,14 @@
 
 
 def main(argv):
+    import errno
     
-    bzrlib.trace.open_tracefile(argv)
+    bzrlib.open_tracefile(argv)
 
     try:
         try:
             try:
-                return run_bzr(argv[1:])
+                return run_bzr(argv)
             finally:
                 # do this here inside the exception wrappers to catch EPIPE
                 sys.stdout.flush()
@@ -1875,7 +1655,6 @@
             _report_exception('interrupted', quiet=True)
             return 2
         except Exception, e:
-            import errno
             quiet = False
             if (isinstance(e, IOError) 
                 and hasattr(e, 'errno')

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2005-07-22 19:44:09 +0000
+++ bzrlib/commit.py	2005-06-20 04:57:46 +0000
@@ -16,16 +16,13 @@
 
 
 
-# FIXME: "bzr commit doc/format" commits doc/format.txt!
-
 def commit(branch, message,
            timestamp=None,
            timezone=None,
            committer=None,
            verbose=True,
            specific_files=None,
-           rev_id=None,
-           allow_pointless=True):
+           rev_id=None):
     """Commit working copy as a new revision.
 
     The basic approach is to add all the file texts into the
@@ -42,9 +39,6 @@
     be robust against files disappearing, moving, etc.  So the
     whole thing is a bit hard.
 
-    This raises PointlessCommit if there are no changes, no new merges,
-    and allow_pointless  is false.
-
     timestamp -- if not None, seconds-since-epoch for a
          postdated/predated commit.
 
@@ -63,10 +57,9 @@
 
     from bzrlib.osutils import local_time_offset, username
     from bzrlib.branch import gen_file_id
-    from bzrlib.errors import BzrError, PointlessCommit
+    from bzrlib.errors import BzrError
     from bzrlib.revision import Revision, RevisionReference
     from bzrlib.trace import mutter, note
-    from bzrlib.xml import pack_xml
 
     branch.lock_write()
 
@@ -87,18 +80,12 @@
         if verbose:
             note('looking for changes...')
 
-        pending_merges = branch.pending_merges()
-
-        missing_ids, new_inv, any_changes = \
-                     _gather_commit(branch,
-                                    work_tree,
-                                    work_inv,
-                                    basis_inv,
-                                    specific_files,
-                                    verbose)
-
-        if not (any_changes or allow_pointless or pending_merges):
-            raise PointlessCommit()
+        missing_ids, new_inv = _gather_commit(branch,
+                                              work_tree,
+                                              work_inv,
+                                              basis_inv,
+                                              specific_files,
+                                              verbose)
 
         for file_id in missing_ids:
             # Any files that have been deleted are now removed from the
@@ -121,7 +108,7 @@
         inv_id = rev_id
 
         inv_tmp = tempfile.TemporaryFile()
-        pack_xml(new_inv, inv_tmp)
+        new_inv.write_xml(inv_tmp)
         inv_tmp.seek(0)
         branch.inventory_store.add(inv_tmp, inv_id)
         mutter('new inventory_id is {%s}' % inv_id)
@@ -151,16 +138,13 @@
                        inventory_sha1=inv_sha1,
                        revision_id=rev_id)
 
-        rev.parents = []
         precursor_id = branch.last_patch()
         if precursor_id:
             precursor_sha1 = branch.get_revision_sha1(precursor_id)
-            rev.parents.append(RevisionReference(precursor_id, precursor_sha1))
-        for merge_rev in pending_merges:
-            rev.parents.append(RevisionReference(merge_rev))            
+            rev.parents = [RevisionReference(precursor_id, precursor_sha1)]
 
         rev_tmp = tempfile.TemporaryFile()
-        pack_xml(rev, rev_tmp)
+        rev.write_xml(rev_tmp)
         rev_tmp.seek(0)
         branch.revision_store.add(rev_tmp, rev_id)
         mutter("new revision_id is {%s}" % rev_id)
@@ -177,8 +161,6 @@
 
         branch.append_revision(rev_id)
 
-        branch.set_pending_merges([])
-
         if verbose:
             note("commited r%d" % branch.revno())
     finally:
@@ -200,8 +182,6 @@
                    verbose):
     """Build inventory preparatory to commit.
 
-    Returns missing_ids, new_inv, any_changes.
-
     This adds any changed files into the text store, and sets their
     test-id, sha and size in the returned inventory appropriately.
 
@@ -211,16 +191,15 @@
         working inventory.
     """
     from bzrlib.inventory import Inventory
-    from bzrlib.osutils import isdir, isfile, sha_string, quotefn, \
+    from osutils import isdir, isfile, sha_string, quotefn, \
          local_time_offset, username, kind_marker, is_inside_any
     
-    from bzrlib.branch import gen_file_id
-    from bzrlib.errors import BzrError
-    from bzrlib.revision import Revision
+    from branch import gen_file_id
+    from errors import BzrError
+    from revision import Revision
     from bzrlib.trace import mutter, note
 
-    any_changes = False
-    inv = Inventory(work_inv.root.file_id)
+    inv = Inventory()
     missing_ids = []
     
     for path, entry in work_inv.iter_entries():
@@ -232,7 +211,6 @@
         mutter('commit prep file %s, id %r ' % (p, file_id))
 
         if specific_files and not is_inside_any(specific_files, path):
-            mutter('  skipping file excluded from commit')
             if basis_inv.has_id(file_id):
                 # carry over with previous state
                 inv.add(basis_inv[file_id].copy())
@@ -244,7 +222,6 @@
         if not work_tree.has_id(file_id):
             if verbose:
                 print('deleted %s%s' % (path, kind_marker(entry.kind)))
-                any_changes = True
             mutter("    file is missing, removing from inventory")
             missing_ids.append(file_id)
             continue
@@ -296,17 +273,14 @@
             marked = path + kind_marker(entry.kind)
             if not old_ie:
                 print 'added', marked
-                any_changes = True
             elif old_ie == entry:
                 pass                    # unchanged
             elif (old_ie.name == entry.name
                   and old_ie.parent_id == entry.parent_id):
                 print 'modified', marked
-                any_changes = True
             else:
                 print 'renamed', marked
-                any_changes = True
                         
-    return missing_ids, inv, any_changes
+    return missing_ids, inv
 
 

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2005-07-27 16:42:41 +0000
+++ bzrlib/diff.py	2005-06-10 06:22:11 +0000
@@ -19,10 +19,6 @@
 from errors import BzrError
 
 
-# TODO: Rather than building a changeset object, we should probably
-# invoke callbacks on an object.  That object can either accumulate a
-# list, write them out directly, etc etc.
-
 def internal_diff(old_label, oldlines, new_label, newlines, to_file):
     import difflib
     
@@ -42,6 +38,15 @@
     if not oldlines and not newlines:
         return
 
+    nonl = False
+
+    if oldlines and (oldlines[-1][-1] != '\n'):
+        oldlines[-1] += '\n'
+        nonl = True
+    if newlines and (newlines[-1][-1] != '\n'):
+        newlines[-1] += '\n'
+        nonl = True
+
     ud = difflib.unified_diff(oldlines, newlines,
                               fromfile=old_label, tofile=new_label)
 
@@ -54,10 +59,9 @@
         ud = list(ud)
         ud[2] = ud[2].replace('+1,0', '+0,0')
 
-    for line in ud:
-        to_file.write(line)
-        if not line.endswith('\n'):
-            to_file.write("\n\\ No newline at end of file\n")
+    to_file.writelines(ud)
+    if nonl:
+        print >>to_file, "\\ No newline at end of file"
     print >>to_file
 
 
@@ -263,10 +267,6 @@
     Files that are both modified and renamed are listed only in
     renamed, with the text_modified flag true.
 
-    Files are only considered renamed if their name has changed or
-    their parent directory has changed.  Renaming a directory
-    does not count as renaming all its contents.
-
     The lists are normally sorted when the delta is created.
     """
     def __init__(self):
@@ -276,18 +276,6 @@
         self.modified = []
         self.unchanged = []
 
-    def __eq__(self, other):
-        if not isinstance(other, TreeDelta):
-            return False
-        return self.added == other.added \
-               and self.removed == other.removed \
-               and self.renamed == other.renamed \
-               and self.modified == other.modified \
-               and self.unchanged == other.unchanged
-
-    def __ne__(self, other):
-        return not (self == other)
-
     def __repr__(self):
         return "TreeDelta(added=%r, removed=%r, renamed=%r, modified=%r," \
             " unchanged=%r)" % (self.added, self.removed, self.renamed,
@@ -349,7 +337,7 @@
 
 
 
-def compare_trees(old_tree, new_tree, want_unchanged=False, specific_files=None):
+def compare_trees(old_tree, new_tree, want_unchanged, specific_files=None):
     """Describe changes from one tree to another.
 
     Returns a TreeDelta with details of added, modified, renamed, and
@@ -380,11 +368,8 @@
 
     for file_id in old_tree:
         if file_id in new_tree:
-            old_ie = old_inv[file_id]
-            new_ie = new_inv[file_id]
-
-            kind = old_ie.kind
-            assert kind == new_ie.kind
+            kind = old_inv.get_file_kind(file_id)
+            assert kind == new_inv.get_file_kind(file_id)
             
             assert kind in ('file', 'directory', 'symlink', 'root_directory'), \
                    'invalid file kind %r' % kind
@@ -392,9 +377,12 @@
             if kind == 'root_directory':
                 continue
             
+            old_path = old_inv.id2path(file_id)
+            new_path = new_inv.id2path(file_id)
+
             if specific_files:
-                if (not is_inside_any(specific_files, old_inv.id2path(file_id)) 
-                    and not is_inside_any(specific_files, new_inv.id2path(file_id))):
+                if (not is_inside_any(specific_files, old_path) 
+                    and not is_inside_any(specific_files, new_path)):
                     continue
 
             if kind == 'file':
@@ -410,16 +398,13 @@
             # the same and the parents are unchanged all the way up.
             # May not be worthwhile.
             
-            if (old_ie.name != new_ie.name
-                or old_ie.parent_id != new_ie.parent_id):
-                delta.renamed.append((old_inv.id2path(file_id),
-                                      new_inv.id2path(file_id),
-                                      file_id, kind,
+            if old_path != new_path:
+                delta.renamed.append((old_path, new_path, file_id, kind,
                                       text_modified))
             elif text_modified:
-                delta.modified.append((new_inv.id2path(file_id), file_id, kind))
+                delta.modified.append((new_path, file_id, kind))
             elif want_unchanged:
-                delta.unchanged.append((new_inv.id2path(file_id), file_id, kind))
+                delta.unchanged.append((new_path, file_id, kind))
         else:
             kind = old_inv.get_file_kind(file_id)
             old_path = old_inv.id2path(file_id)

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2005-07-11 03:40:02 +0000
+++ bzrlib/errors.py	2005-06-17 07:28:53 +0000
@@ -39,10 +39,6 @@
     pass
 
 
-class NotVersionedError(BzrError):
-    """Specified object is not versioned."""
-
-
 class BadFileKindError(BzrError):
     """Specified file is of a kind that cannot be added.
 
@@ -66,7 +62,3 @@
             Exception.__init__(self, e)
         else:
             Exception.__init__(self)
-
-
-class PointlessCommit(Exception):
-    """Commit failed because nothing was changed."""

=== removed file 'bzrlib/hashcache.py'
--- bzrlib/hashcache.py	2005-07-22 18:49:46 +0000
+++ bzrlib/hashcache.py	1970-01-01 00:00:00 +0000
@@ -1,260 +0,0 @@
-# (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-# TODO: Up-front, stat all files in order and remove those which are deleted or 
-# out-of-date.  Don't actually re-read them until they're needed.  That ought 
-# to bring all the inodes into core so that future stats to them are fast, and 
-# it preserves the nice property that any caller will always get up-to-date
-# data except in unavoidable cases.
-
-# TODO: Perhaps return more details on the file to avoid statting it
-# again: nonexistent, file type, size, etc
-
-
-
-CACHE_HEADER = "### bzr hashcache v5\n"
-
-import os, stat, time
-
-from bzrlib.osutils import sha_file
-from bzrlib.trace import mutter, warning
-
-
-
-def _fingerprint(abspath):
-    try:
-        fs = os.lstat(abspath)
-    except OSError:
-        # might be missing, etc
-        return None
-
-    if stat.S_ISDIR(fs.st_mode):
-        return None
-
-    # we discard any high precision because it's not reliable; perhaps we
-    # could do better on some systems?
-    return (fs.st_size, long(fs.st_mtime),
-            long(fs.st_ctime), fs.st_ino, fs.st_dev)
-
-
-class HashCache(object):
-    """Cache for looking up file SHA-1.
-
-    Files are considered to match the cached value if the fingerprint
-    of the file has not changed.  This includes its mtime, ctime,
-    device number, inode number, and size.  This should catch
-    modifications or replacement of the file by a new one.
-
-    This may not catch modifications that do not change the file's
-    size and that occur within the resolution window of the
-    timestamps.  To handle this we specifically do not cache files
-    which have changed since the start of the present second, since
-    they could undetectably change again.
-
-    This scheme may fail if the machine's clock steps backwards.
-    Don't do that.
-
-    This does not canonicalize the paths passed in; that should be
-    done by the caller.
-
-    _cache
-        Indexed by path, points to a two-tuple of the SHA-1 of the file.
-        and its fingerprint.
-
-    stat_count
-        number of times files have been statted
-
-    hit_count
-        number of times files have been retrieved from the cache, avoiding a
-        re-read
-        
-    miss_count
-        number of misses (times files have been completely re-read)
-    """
-    needs_write = False
-
-    def __init__(self, basedir):
-        self.basedir = basedir
-        self.hit_count = 0
-        self.miss_count = 0
-        self.stat_count = 0
-        self.danger_count = 0
-        self.removed_count = 0
-        self.update_count = 0
-        self._cache = {}
-
-
-    def cache_file_name(self):
-        return os.sep.join([self.basedir, '.bzr', 'stat-cache'])
-
-
-
-
-    def clear(self):
-        """Discard all cached information.
-
-        This does not reset the counters."""
-        if self._cache:
-            self.needs_write = True
-            self._cache = {}
-
-
-    def scan(self):
-        """Scan all files and remove entries where the cache entry is obsolete.
-        
-        Obsolete entries are those where the file has been modified or deleted
-        since the entry was inserted.        
-        """
-        prep = [(ce[1][3], path, ce) for (path, ce) in self._cache.iteritems()]
-        prep.sort()
-        
-        for inum, path, cache_entry in prep:
-            abspath = os.sep.join([self.basedir, path])
-            fp = _fingerprint(abspath)
-            self.stat_count += 1
-            
-            cache_fp = cache_entry[1]
-    
-            if (not fp) or (cache_fp != fp):
-                # not here or not a regular file anymore
-                self.removed_count += 1
-                self.needs_write = True
-                del self._cache[path]
-
-
-
-    def get_sha1(self, path):
-        """Return the sha1 of a file.
-        """
-        abspath = os.sep.join([self.basedir, path])
-        self.stat_count += 1
-        file_fp = _fingerprint(abspath)
-        
-        if not file_fp:
-            # not a regular file or not existing
-            if path in self._cache:
-                self.removed_count += 1
-                self.needs_write = True
-                del self._cache[path]
-            return None        
-
-        if path in self._cache:
-            cache_sha1, cache_fp = self._cache[path]
-        else:
-            cache_sha1, cache_fp = None, None
-
-        if cache_fp == file_fp:
-            self.hit_count += 1
-            return cache_sha1
-        
-        self.miss_count += 1
-        digest = sha_file(file(abspath, 'rb', buffering=65000))
-
-        now = int(time.time())
-        if file_fp[1] >= now or file_fp[2] >= now:
-            # changed too recently; can't be cached.  we can
-            # return the result and it could possibly be cached
-            # next time.
-            self.danger_count += 1 
-            if cache_fp:
-                self.removed_count += 1
-                self.needs_write = True
-                del self._cache[path]
-        else:
-            self.update_count += 1
-            self.needs_write = True
-            self._cache[path] = (digest, file_fp)
-        
-        return digest
-        
-
-
-
-    def write(self):
-        """Write contents of cache to file."""
-        from atomicfile import AtomicFile
-
-        outf = AtomicFile(self.cache_file_name(), 'wb')
-        try:
-            print >>outf, CACHE_HEADER,
-
-            for path, c  in self._cache.iteritems():
-                assert '//' not in path, path
-                outf.write(path.encode('utf-8'))
-                outf.write('// ')
-                print >>outf, c[0],     # hex sha1
-                for fld in c[1]:
-                    print >>outf, "%d" % fld,
-                print >>outf
-
-            outf.commit()
-            self.needs_write = False
-        finally:
-            if not outf.closed:
-                outf.abort()
-        
-
-
-    def read(self):
-        """Reinstate cache from file.
-
-        Overwrites existing cache.
-
-        If the cache file has the wrong version marker, this just clears 
-        the cache."""
-        self._cache = {}
-
-        fn = self.cache_file_name()
-        try:
-            inf = file(fn, 'rb', buffering=65000)
-        except IOError, e:
-            mutter("failed to open %s: %s" % (fn, e))
-            return
-
-
-        hdr = inf.readline()
-        if hdr != CACHE_HEADER:
-            mutter('cache header marker not found at top of %s; discarding cache'
-                   % fn)
-            return
-
-        for l in inf:
-            pos = l.index('// ')
-            path = l[:pos].decode('utf-8')
-            if path in self._cache:
-                warning('duplicated path %r in cache' % path)
-                continue
-
-            pos += 3
-            fields = l[pos:].split(' ')
-            if len(fields) != 6:
-                warning("bad line in hashcache: %r" % l)
-                continue
-
-            sha1 = fields[0]
-            if len(sha1) != 40:
-                warning("bad sha1 in hashcache: %r" % sha1)
-                continue
-
-            fp = tuple(map(long, fields[1:]))
-
-            self._cache[path] = (sha1, fp)
-
-        self.needs_write = False
-           
-
-
-        

=== removed file 'bzrlib/intset.py'
--- bzrlib/intset.py	2005-07-17 18:26:45 +0000
+++ bzrlib/intset.py	1970-01-01 00:00:00 +0000
@@ -1,221 +0,0 @@
-#! /usr/bin/python
-
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-# Author: Martin Pool <mbp@canonical.com>
-
-
-# Somewhat surprisingly, it turns out that this is much slower than
-# simply storing the ints in a set() type.  Python's performance model
-# is very different to that of C.
-
-
-class IntSet(Exception):
-    """Faster set-like class storing only whole numbers.
-
-    Despite the name this stores long integers happily, but negative
-    values are not allowed.
-
-    >>> a = IntSet([0, 2, 5])
-    >>> bool(a)
-    True
-    >>> 2 in a
-    True
-    >>> 4 in a
-    False
-    >>> a.add(4)
-    >>> 4 in a
-    True
-
-    >>> b = IntSet()
-    >>> not b
-    True
-    >>> b.add(10)
-    >>> 10 in a
-    False
-    >>> a.update(b)
-    >>> 10 in a
-    True
-    >>> a.update(range(5))
-    >>> 3 in a
-    True
-
-    Being a set, duplicates are ignored:
-    >>> a = IntSet()
-    >>> a.add(10)
-    >>> a.add(10)
-    >>> 10 in a
-    True
-    >>> list(a)
-    [10]
-    
-    """
-    __slots__ = ['_val']
-
-    def __init__(self, values=None, bitmask=0L):
-        """Create a new intset.
-
-        values
-            If specified, an initial collection of values.
-        """
-        self._val = bitmask
-        if values != None:
-            self.update(values)
-
-
-    def __nonzero__(self):
-        """IntSets are false if empty, otherwise True.
-
-        >>> bool(IntSet())
-        False
-        
-        >>> bool(IntSet([0]))
-        True
-        """
-        return bool(self._val)
-
-
-    def __len__(self):
-        """Number of elements in set.
-
-        >>> len(IntSet(xrange(20000)))
-        20000
-        """
-        v = self._val
-        c = 0
-        while v:
-            if v & 1:
-                c += 1
-            v = v >> 1
-        return c
-
-
-    def __and__(self, other):
-        """Set intersection.
-
-        >>> a = IntSet(range(10))
-        >>> len(a)
-        10
-        >>> b = a & a
-        >>> b == a
-        True
-        >>> a = a & IntSet([5, 7, 11, 13])
-        >>> list(a)
-        [5, 7]
-        """
-        if not isinstance(other, IntSet):
-            raise NotImplementedError(type(other))
-        return IntSet(bitmask=(self._val & other._val))
-
-
-    def __or__(self, other):
-        """Set union.
-
-        >>> a = IntSet(range(10)) | IntSet([5, 15, 25])
-        >>> len(a)
-        12
-        """
-        if not isinstance(other, IntSet):
-            raise NotImplementedError(type(other))
-        return IntSet(bitmask=(self._val | other._val))        
-
-
-    def __eq__(self, other):
-        """Comparison.
-
-        >>> IntSet(range(3)) == IntSet([2, 0, 1])
-        True
-        """
-        if isinstance(other, IntSet):
-            return self._val == other._val
-        else:
-            return False
-
-
-    def __ne__(self, other):
-        return not self.__eq__(other)
-
-
-    def __contains__(self, i):
-        assert i >= 0
-        return self._val & (1L << i)
-
-
-    def __iter__(self):
-        """Return contents of set.
-
-        >>> list(IntSet())
-        []
-        >>> list(IntSet([0, 1, 5, 7]))
-        [0, 1, 5, 7]
-        """
-        v = self._val
-        o = 0
-        # XXX: This is a bit slow
-        while v:
-            if v & 1:
-                yield o
-            v = v >> 1
-            o = o + 1
-
-        
-    def update(self, to_add):
-        """Add all the values from the sequence or intset to_add"""
-        if isinstance(to_add, IntSet):
-            self._val |= to_add._val
-        else:
-            for i in to_add:
-                assert i >= 0
-                self._val |= (1L << i)
-
-
-    def add(self, to_add):
-        assert 0 <= to_add
-        self._val |= (1L << to_add)
-
-
-    def remove(self, to_remove):
-        """Remove one value from the set.
-
-        Raises KeyError if the value is not present.
-
-        >>> a = IntSet([10])
-        >>> a.remove(9)
-        Traceback (most recent call last):
-          File "/usr/lib/python2.4/doctest.py", line 1243, in __run
-            compileflags, 1) in test.globs
-          File "<doctest __main__.IntSet.remove[1]>", line 1, in ?
-            a.remove(9)
-        KeyError: 9
-        >>> a.remove(10)
-        >>> not a
-        True
-        """
-        assert 0 <= to_remove
-        m = 1L << to_remove
-        if not self._val & m:
-            raise KeyError(to_remove)
-        self._val ^= m
-        
-        
-            
-    
-
-if __name__ == '__main__':
-    import doctest
-    doctest.testmod()
-    

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2005-07-22 19:32:46 +0000
+++ bzrlib/inventory.py	2005-06-17 07:28:53 +0000
@@ -22,13 +22,19 @@
 
 import sys, os.path, types, re
 
+try:
+    from cElementTree import Element, ElementTree, SubElement
+except ImportError:
+    from elementtree.ElementTree import Element, ElementTree, SubElement
+
+from bzrlib.xml import XMLMixin
+from bzrlib.errors import BzrError, BzrCheckError
+
 import bzrlib
-from bzrlib.errors import BzrError, BzrCheckError
-
 from bzrlib.osutils import uuid, quotefn, splitpath, joinpath, appendpath
 from bzrlib.trace import mutter
 
-class InventoryEntry(object):
+class InventoryEntry(XMLMixin):
     """Description of a versioned file.
 
     An InventoryEntry has the following fields, which are also
@@ -92,9 +98,9 @@
     # TODO: split InventoryEntry into subclasses for files,
     # directories, etc etc.
 
-    __slots__ = ['text_sha1', 'text_size', 'file_id', 'name', 'kind',
-                 'text_id', 'parent_id', 'children', ]
-
+    text_sha1 = None
+    text_size = None
+    
     def __init__(self, file_id, name, kind, parent_id, text_id=None):
         """Create an InventoryEntry
         
@@ -113,9 +119,6 @@
         if '/' in name or '\\' in name:
             raise BzrCheckError('InventoryEntry name %r is invalid' % name)
         
-        self.text_sha1 = None
-        self.text_size = None
-    
         self.file_id = file_id
         self.name = name
         self.kind = kind
@@ -157,8 +160,6 @@
     
     def to_element(self):
         """Convert to XML element"""
-        from bzrlib.xml import Element
-        
         e = Element('entry')
 
         e.set('name', self.name)
@@ -247,7 +248,7 @@
 
 
 
-class Inventory(object):
+class Inventory(XMLMixin):
     """Inventory of versioned files in a tree.
 
     This describes which file_id is present at each point in the tree,
@@ -265,6 +266,9 @@
     inserted, other than through the Inventory API.
 
     >>> inv = Inventory()
+    >>> inv.write_xml(sys.stdout)
+    <inventory>
+    </inventory>
     >>> inv.add(InventoryEntry('123-123', 'hello.c', 'file', ROOT_ID))
     >>> inv['123-123'].name
     'hello.c'
@@ -280,10 +284,14 @@
 
     >>> [x[0] for x in inv.iter_entries()]
     ['hello.c']
-    >>> inv = Inventory('TREE_ROOT-12345678-12345678')
-    >>> inv.add(InventoryEntry('123-123', 'hello.c', 'file', ROOT_ID))
+    
+    >>> inv.write_xml(sys.stdout)
+    <inventory>
+    <entry file_id="123-123" kind="file" name="hello.c" />
+    </inventory>
+
     """
-    def __init__(self, root_id=ROOT_ID):
+    def __init__(self):
         """Create or read an inventory.
 
         If a working directory is specified, the inventory is read
@@ -293,11 +301,7 @@
         The inventory is created with a default root directory, with
         an id of None.
         """
-        # We are letting Branch(init=True) create a unique inventory
-        # root id. Rather than generating a random one here.
-        #if root_id is None:
-        #    root_id = bzrlib.branch.gen_file_id('TREE_ROOT')
-        self.root = RootEntry(root_id)
+        self.root = RootEntry(ROOT_ID)
         self._byid = {self.root.file_id: self.root}
 
 
@@ -409,9 +413,6 @@
         if entry.file_id in self._byid:
             raise BzrError("inventory already contains entry with id {%s}" % entry.file_id)
 
-        if entry.parent_id == ROOT_ID or entry.parent_id is None:
-            entry.parent_id = self.root.file_id
-
         try:
             parent = self._byid[entry.parent_id]
         except KeyError:
@@ -429,21 +430,15 @@
         """Add entry from a path.
 
         The immediate parent must already be versioned"""
-        from bzrlib.errors import NotVersionedError
-        
         parts = bzrlib.osutils.splitpath(relpath)
         if len(parts) == 0:
             raise BzrError("cannot re-add root of inventory")
 
         if file_id == None:
-            from bzrlib.branch import gen_file_id
-            file_id = gen_file_id(relpath)
-
-        parent_path = parts[:-1]
-        parent_id = self.path2id(parent_path)
-        if parent_id == None:
-            raise NotVersionedError(parent_path)
-
+            file_id = bzrlib.branch.gen_file_id(relpath)
+
+        parent_id = self.path2id(parts[:-1])
+        assert parent_id != None
         ie = InventoryEntry(file_id, parts[-1],
                             kind=kind, parent_id=parent_id)
         return self.add(ie)
@@ -477,12 +472,8 @@
 
     def to_element(self):
         """Convert to XML Element"""
-        from bzrlib.xml import Element
-        
         e = Element('inventory')
         e.text = '\n'
-        if self.root.file_id not in (None, ROOT_ID):
-            e.set('file_id', self.root.file_id)
         for path, ie in self.iter_entries():
             e.append(ie.to_element())
         return e
@@ -490,7 +481,7 @@
 
     def from_element(cls, elt):
         """Construct from XML Element
-        
+
         >>> inv = Inventory()
         >>> inv.add(InventoryEntry('foo.c-123981239', 'foo.c', 'file', ROOT_ID))
         >>> elt = inv.to_element()
@@ -498,15 +489,10 @@
         >>> inv2 == inv
         True
         """
-        # XXXX: doctest doesn't run this properly under python2.3
         assert elt.tag == 'inventory'
-        root_id = elt.get('file_id') or ROOT_ID
-        o = cls(root_id)
+        o = cls()
         for e in elt:
-            ie = InventoryEntry.from_element(e)
-            if ie.parent_id == ROOT_ID:
-                ie.parent_id = root_id
-            o.add(ie)
+            o.add(InventoryEntry.from_element(e))
         return o
         
     from_element = classmethod(from_element)
@@ -568,7 +554,7 @@
         """Return as a list the path to file_id."""
 
         # get all names, skipping root
-        p = [self._byid[fid].name for fid in self.get_idpath(file_id)[1:]]
+        p = [self[fid].name for fid in self.get_idpath(file_id)[1:]]
         return os.sep.join(p)
             
 

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2005-07-21 12:01:14 +0000
+++ bzrlib/lock.py	2005-06-10 07:32:36 +0000
@@ -198,13 +198,13 @@
                         fpos = os.lseek(fn, 0,0)
                         os.lseek(fn, 0,0)
 
-                    if flags & _msvc_FileLock.LOCK_SH:
-                        if flags & _msvc_FileLock.LOCK_NB:
+                    if flags & self.LOCK_SH:
+                        if flags & self.LOCK_NB:
                             lock_mode = msvcrt.LK_NBLCK
                         else:
                             lock_mode = msvcrt.LK_LOCK
-                    elif flags & _msvc_FileLock.LOCK_EX:
-                        if flags & _msvc_FileLock.LOCK_NB:
+                    elif flags & self.LOCK_EX:
+                        if flags & self.LOCK_NB:
                             lock_mode = msvcrt.LK_NBRLCK
                         else:
                             lock_mode = msvcrt.LK_RLCK

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2005-07-16 00:07:40 +0000
+++ bzrlib/log.py	2005-06-20 01:59:26 +0000
@@ -84,25 +84,34 @@
 
 
 def show_log(branch,
-             lf,
              specific_fileid=None,
+             show_timezone='original',
              verbose=False,
+             show_ids=False,
+             to_file=None,
              direction='reverse',
              start_revision=None,
-             end_revision=None,
-             search=None):
+             end_revision=None):
     """Write out human-readable log of commits to this branch.
 
-    lf
-        LogFormatter object to show the output.
-
     specific_fileid
         If true, list only the commits affecting the specified
         file, rather than all commits.
 
+    show_timezone
+        'original' (committer's timezone),
+        'utc' (universal time), or
+        'local' (local user's timezone)
+
     verbose
         If true show added/changed/deleted/renamed files.
 
+    show_ids
+        If true, show revision and file ids.
+
+    to_file
+        File to send log to; by default stdout.
+
     direction
         'reverse' (default) is latest to earliest;
         'forward' is earliest to latest.
@@ -113,28 +122,19 @@
     end_revision
         If not None, only show revisions <= end_revision
     """
-    from bzrlib.osutils import format_date
-    from bzrlib.errors import BzrCheckError
-    from bzrlib.textui import show_status
-    
-    from warnings import warn
+    from osutils import format_date
+    from errors import BzrCheckError
+    from textui import show_status
 
-    if not isinstance(lf, LogFormatter):
-        warn("not a LogFormatter instance: %r" % lf)
 
     if specific_fileid:
         mutter('get log for file_id %r' % specific_fileid)
 
-    if search is not None:
-        import re
-        searchRE = re.compile(search, re.IGNORECASE)
-    else:
-        searchRE = None
+    if to_file == None:
+        import sys
+        to_file = sys.stdout
 
     which_revs = branch.enum_history(direction)
-    which_revs = [x for x in which_revs if (
-            (start_revision is None or x[0] >= start_revision)
-            and (end_revision is None or x[0] <= end_revision))]
 
     if not (verbose or specific_fileid):
         # no need to know what changed between revisions
@@ -142,19 +142,24 @@
     elif direction == 'reverse':
         with_deltas = deltas_for_log_reverse(branch, which_revs)
     else:        
-        with_deltas = deltas_for_log_forward(branch, which_revs)
+        raise NotImplementedError("sorry, verbose forward logs not done yet")
 
     for revno, rev, delta in with_deltas:
         if specific_fileid:
             if not delta.touches_file_id(specific_fileid):
                 continue
 
+        if start_revision is not None and revno < start_revision:
+            continue
+
+        if end_revision is not None and revno > end_revision:
+            continue
+        
         if not verbose:
             # although we calculated it, throw it away without display
             delta = None
-
-        if searchRE is None or searchRE.search(rev.message):
-            lf.show(revno, rev, delta)
+            
+        show_one_log(revno, rev, delta, show_ids, to_file, show_timezone)
 
 
 
@@ -184,127 +189,34 @@
         if last_revno:
             yield last_revno, last_revision, compare_trees(this_tree, last_tree, False)
 
-        this_tree = EmptyTree(branch.get_root_id())
-
         last_revno = revno
         last_revision = this_revision
         last_tree = this_tree
 
     if last_revno:
-        if last_revno == 1:
-            this_tree = EmptyTree(branch.get_root_id())
-        else:
-            this_revno = last_revno - 1
-            this_revision_id = branch.revision_history()[this_revno]
-            this_tree = branch.revision_tree(this_revision_id)
+        this_tree = EmptyTree()
         yield last_revno, last_revision, compare_trees(this_tree, last_tree, False)
 
 
-def deltas_for_log_forward(branch, which_revs):
-    """Compute deltas for display in forward log.
-
-    Given a sequence of (revno, revision_id) pairs, return
-    (revno, rev, delta).
-
-    The delta is from the given revision to the next one in the
-    sequence, which makes sense if the log is being displayed from
-    newest to oldest.
-    """
-    from tree import EmptyTree
-    from diff import compare_trees
-
-    last_revno = last_revision_id = last_tree = None
-    prev_tree = EmptyTree(branch.get_root_id())
-
-    for revno, revision_id in which_revs:
-        this_tree = branch.revision_tree(revision_id)
-        this_revision = branch.get_revision(revision_id)
-
-        if not last_revno:
-            if revno == 1:
-                last_tree = EmptyTree(branch.get_root_id())
-            else:
-                last_revno = revno - 1
-                last_revision_id = branch.revision_history()[last_revno]
-                last_tree = branch.revision_tree(last_revision_id)
-
-        yield revno, this_revision, compare_trees(last_tree, this_tree, False)
-
-        last_revno = revno
-        last_revision = this_revision
-        last_tree = this_tree
-
-
-class LogFormatter(object):
-    """Abstract class to display log messages."""
-    def __init__(self, to_file, show_ids=False, show_timezone=False):
-        self.to_file = to_file
-        self.show_ids = show_ids
-        self.show_timezone = show_timezone
-        
-
-
-
-
-
-class LongLogFormatter(LogFormatter):
-    def show(self, revno, rev, delta):
-        from osutils import format_date
-
-        to_file = self.to_file
-
-        print >>to_file,  '-' * 60
-        print >>to_file,  'revno:', revno
-        if self.show_ids:
-            print >>to_file,  'revision-id:', rev.revision_id
-        print >>to_file,  'committer:', rev.committer
-        print >>to_file,  'timestamp: %s' % (format_date(rev.timestamp, rev.timezone or 0,
-                                             self.show_timezone))
-
-        print >>to_file,  'message:'
-        if not rev.message:
-            print >>to_file,  '  (no message)'
-        else:
-            for l in rev.message.split('\n'):
-                print >>to_file,  '  ' + l
-
-        if delta != None:
-            delta.show(to_file, self.show_ids)
-
-
-
-class ShortLogFormatter(LogFormatter):
-    def show(self, revno, rev, delta):
-        from bzrlib.osutils import format_date
-
-        to_file = self.to_file
-
-        print >>to_file, "%5d %s\t%s" % (revno, rev.committer,
-                format_date(rev.timestamp, rev.timezone or 0,
-                            self.show_timezone))
-        if self.show_ids:
-            print >>to_file,  '      revision-id:', rev.revision_id
-        if not rev.message:
-            print >>to_file,  '      (no message)'
-        else:
-            for l in rev.message.split('\n'):
-                print >>to_file,  '      ' + l
-
-        if delta != None:
-            delta.show(to_file, self.show_ids)
-        print
-
-
-
-FORMATTERS = {'long': LongLogFormatter,
-              'short': ShortLogFormatter,
-              }
-
-
-def log_formatter(name, *args, **kwargs):
-    from bzrlib.errors import BzrCommandError
+
+
+def show_one_log(revno, rev, delta, show_ids, to_file, show_timezone):
+    from osutils import format_date
     
-    try:
-        return FORMATTERS[name](*args, **kwargs)
-    except IndexError:
-        raise BzrCommandError("unknown log formatter: %r" % name)
+    print >>to_file,  '-' * 60
+    print >>to_file,  'revno:', revno
+    if show_ids:
+        print >>to_file,  'revision-id:', rev.revision_id
+    print >>to_file,  'committer:', rev.committer
+    print >>to_file,  'timestamp: %s' % (format_date(rev.timestamp, rev.timezone or 0,
+                                         show_timezone))
+
+    print >>to_file,  'message:'
+    if not rev.message:
+        print >>to_file,  '  (no message)'
+    else:
+        for l in rev.message.split('\n'):
+            print >>to_file,  '  ' + l
+
+    if delta != None:
+        delta.show(to_file, show_ids)

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2005-07-29 17:19:16 +0000
+++ bzrlib/merge.py	2005-06-06 11:53:29 +0000
@@ -1,6 +1,6 @@
-from merge_core import merge_flex, ApplyMerge3, BackupBeforeChange
+from merge_core import merge_flex
 from changeset import generate_changeset, ExceptionConflictHandler
-from changeset import Inventory, Diff3Merge
+from changeset import Inventory
 from bzrlib import find_branch
 import bzrlib.osutils
 from bzrlib.errors import BzrCommandError
@@ -80,12 +80,6 @@
         moved_path = self.add_suffix(target, ".moved")
         self.conflict("Moved existing %s to %s" % (target, moved_path))
 
-    def rmdir_non_empty(self, filename):
-        """Handle the case where the dir to be removed still has contents"""
-        self.conflict("Directory %s not removed because it is not empty"\
-            % filename)
-        return "skip"
-
     def finalize(self):
         if not self.ignore_zero:
             print "%d conflicts encountered.\n" % self.conflicts
@@ -127,6 +121,8 @@
 def inventory_map(tree):
     inventory = {}
     for file_id in tree.inventory:
+        if not file_exists(tree, file_id):
+            continue
         path = abspath(tree, file_id)
         inventory[path] = SourceFile(path, file_id)
     return inventory
@@ -146,8 +142,6 @@
         self.cached = {}
 
     def readonly_path(self, id):
-        if id not in self.tree:
-            return None
         if self.root is not None:
             return self.tree.abspath(self.tree.id2path(id))
         else:
@@ -165,7 +159,7 @@
 
 def merge(other_revision, base_revision,
           check_clean=True, ignore_zero=False,
-          this_dir=None, backup_files=False, merge_type=ApplyMerge3):
+          this_dir=None):
     """Merge changes into a tree.
 
     base_revision
@@ -201,8 +195,7 @@
             base_revision = ['.', base_revno]
         base_branch, base_tree = get_tree(base_revision, tempdir, "base")
         merge_inner(this_branch, other_tree, base_tree, tempdir, 
-                    ignore_zero=ignore_zero, backup_files=backup_files, 
-                    merge_type=merge_type)
+                    ignore_zero=ignore_zero)
     finally:
         shutil.rmtree(tempdir)
 
@@ -232,14 +225,7 @@
 
 
 def merge_inner(this_branch, other_tree, base_tree, tempdir, 
-                ignore_zero=False, merge_type=ApplyMerge3, backup_files=False):
-
-    def merge_factory(base_file, other_file):
-        contents_change = merge_type(base_file, other_file)
-        if backup_files:
-            contents_change = BackupBeforeChange(contents_change)
-        return contents_change
-
+                ignore_zero=False):
     this_tree = get_tree((this_branch.base, None), tempdir, "this")[1]
 
     def get_inventory(tree):
@@ -248,8 +234,7 @@
     inv_changes = merge_flex(this_tree, base_tree, other_tree,
                              generate_cset_optimized, get_inventory,
                              MergeConflictHandler(base_tree.root,
-                                                  ignore_zero=ignore_zero),
-                             merge_factory=merge_factory)
+                                                  ignore_zero=ignore_zero))
 
     adjust_ids = []
     for id, path in inv_changes.iteritems():
@@ -303,8 +288,3 @@
     assert len(new_inventory_list) == len(old_entries) + insertions - deletions
     new_inventory_list.sort()
     return new_inventory_list
-
-merge_types = {     "merge3": (ApplyMerge3, "Native diff3-style merge"), 
-                     "diff3": (Diff3Merge,  "Merge using external diff3")
-              }
-

=== removed file 'bzrlib/merge3.py'
--- bzrlib/merge3.py	2005-07-06 04:09:02 +0000
+++ bzrlib/merge3.py	1970-01-01 00:00:00 +0000
@@ -1,383 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-# mbp: "you know that thing where cvs gives you conflict markers?"
-# s: "i hate that."
-
-
-
-def intersect(ra, rb):
-    """Given two ranges return the range where they intersect or None.
-
-    >>> intersect((0, 10), (0, 6))
-    (0, 6)
-    >>> intersect((0, 10), (5, 15))
-    (5, 10)
-    >>> intersect((0, 10), (10, 15))
-    >>> intersect((0, 9), (10, 15))
-    >>> intersect((0, 9), (7, 15))
-    (7, 9)
-    """
-    assert ra[0] <= ra[1]
-    assert rb[0] <= rb[1]
-    
-    sa = max(ra[0], rb[0])
-    sb = min(ra[1], rb[1])
-    if sa < sb:
-        return sa, sb
-    else:
-        return None
-
-
-def compare_range(a, astart, aend, b, bstart, bend):
-    """Compare a[astart:aend] == b[bstart:bend], without slicing.
-    """
-    if (aend-astart) != (bend-bstart):
-        return False
-    for ia, ib in zip(xrange(astart, aend), xrange(bstart, bend)):
-        if a[ia] != b[ib]:
-            return False
-    else:
-        return True
-        
-
-
-
-class Merge3(object):
-    """3-way merge of texts.
-
-    Given BASE, OTHER, THIS, tries to produce a combined text
-    incorporating the changes from both BASE->OTHER and BASE->THIS.
-    All three will typically be sequences of lines."""
-    def __init__(self, base, a, b):
-        self.base = base
-        self.a = a
-        self.b = b
-        from difflib import SequenceMatcher
-        self.a_ops = SequenceMatcher(None, base, a).get_opcodes()
-        self.b_ops = SequenceMatcher(None, base, b).get_opcodes()
-
-
-
-    def merge_lines(self,
-                    name_a=None,
-                    name_b=None,
-                    start_marker='<<<<<<<<',
-                    mid_marker='========',
-                    end_marker='>>>>>>>>',
-                    show_base=False):
-        """Return merge in cvs-like form.
-        """
-        if name_a:
-            start_marker = start_marker + ' ' + name_a
-        if name_b:
-            end_marker = end_marker + ' ' + name_b
-            
-        for t in self.merge_regions():
-            what = t[0]
-            if what == 'unchanged':
-                for i in range(t[1], t[2]):
-                    yield self.base[i]
-            elif what == 'a' or what == 'same':
-                for i in range(t[1], t[2]):
-                    yield self.a[i]
-            elif what == 'b':
-                for i in range(t[1], t[2]):
-                    yield self.b[i]
-            elif what == 'conflict':
-                yield start_marker + '\n'
-                for i in range(t[3], t[4]):
-                    yield self.a[i]
-                yield mid_marker + '\n'
-                for i in range(t[5], t[6]):
-                    yield self.b[i]
-                yield end_marker + '\n'
-            else:
-                raise ValueError(what)
-        
-        
-
-
-
-    def merge_annotated(self):
-        """Return merge with conflicts, showing origin of lines.
-
-        Most useful for debugging merge.        
-        """
-        for t in self.merge_regions():
-            what = t[0]
-            if what == 'unchanged':
-                for i in range(t[1], t[2]):
-                    yield 'u | ' + self.base[i]
-            elif what == 'a' or what == 'same':
-                for i in range(t[1], t[2]):
-                    yield what[0] + ' | ' + self.a[i]
-            elif what == 'b':
-                for i in range(t[1], t[2]):
-                    yield 'b | ' + self.b[i]
-            elif what == 'conflict':
-                yield '<<<<\n'
-                for i in range(t[3], t[4]):
-                    yield 'A | ' + self.a[i]
-                yield '----\n'
-                for i in range(t[5], t[6]):
-                    yield 'B | ' + self.b[i]
-                yield '>>>>\n'
-            else:
-                raise ValueError(what)
-        
-        
-
-
-
-    def merge_groups(self):
-        """Yield sequence of line groups.  Each one is a tuple:
-
-        'unchanged', lines
-             Lines unchanged from base
-
-        'a', lines
-             Lines taken from a
-
-        'same', lines
-             Lines taken from a (and equal to b)
-
-        'b', lines
-             Lines taken from b
-
-        'conflict', base_lines, a_lines, b_lines
-             Lines from base were changed to either a or b and conflict.
-        """
-        for t in self.merge_regions():
-            what = t[0]
-            if what == 'unchanged':
-                yield what, self.base[t[1]:t[2]]
-            elif what == 'a' or what == 'same':
-                yield what, self.a[t[1]:t[2]]
-            elif what == 'b':
-                yield what, self.b[t[1]:t[2]]
-            elif what == 'conflict':
-                yield (what,
-                       self.base[t[1]:t[2]],
-                       self.a[t[3]:t[4]],
-                       self.b[t[5]:t[6]])
-            else:
-                raise ValueError(what)
-
-
-    def merge_regions(self):
-        """Return sequences of matching and conflicting regions.
-
-        This returns tuples, where the first value says what kind we
-        have:
-
-        'unchanged', start, end
-             Take a region of base[start:end]
-
-        'same', astart, aend
-             b and a are different from base but give the same result
-
-        'a', start, end
-             Non-clashing insertion from a[start:end]
-
-        Method is as follows:
-
-        The two sequences align only on regions which match the base
-        and both descendents.  These are found by doing a two-way diff
-        of each one against the base, and then finding the
-        intersections between those regions.  These "sync regions"
-        are by definition unchanged in both and easily dealt with.
-
-        The regions in between can be in any of three cases:
-        conflicted, or changed on only one side.
-        """
-
-        # section a[0:ia] has been disposed of, etc
-        iz = ia = ib = 0
-        
-        for zmatch, zend, amatch, aend, bmatch, bend in self.find_sync_regions():
-            #print 'match base [%d:%d]' % (zmatch, zend)
-            
-            matchlen = zend - zmatch
-            assert matchlen >= 0
-            assert matchlen == (aend - amatch)
-            assert matchlen == (bend - bmatch)
-            
-            len_a = amatch - ia
-            len_b = bmatch - ib
-            len_base = zmatch - iz
-            assert len_a >= 0
-            assert len_b >= 0
-            assert len_base >= 0
-
-            #print 'unmatched a=%d, b=%d' % (len_a, len_b)
-
-            if len_a or len_b:
-                # try to avoid actually slicing the lists
-                equal_a = compare_range(self.a, ia, amatch,
-                                        self.base, iz, zmatch)
-                equal_b = compare_range(self.b, ib, bmatch,
-                                        self.base, iz, zmatch)
-                same = compare_range(self.a, ia, amatch,
-                                     self.b, ib, bmatch)
-
-                if same:
-                    yield 'same', ia, amatch
-                elif equal_a and not equal_b:
-                    yield 'b', ib, bmatch
-                elif equal_b and not equal_a:
-                    yield 'a', ia, amatch
-                elif not equal_a and not equal_b:
-                    yield 'conflict', iz, zmatch, ia, amatch, ib, bmatch
-                else:
-                    raise AssertionError("can't handle a=b=base but unmatched")
-
-                ia = amatch
-                ib = bmatch
-            iz = zmatch
-
-            # if the same part of the base was deleted on both sides
-            # that's OK, we can just skip it.
-
-                
-            if matchlen > 0:
-                assert ia == amatch
-                assert ib == bmatch
-                assert iz == zmatch
-                
-                yield 'unchanged', zmatch, zend
-                iz = zend
-                ia = aend
-                ib = bend
-        
-
-        
-    def find_sync_regions(self):
-        """Return a list of sync regions, where both descendents match the base.
-
-        Generates a list of (base1, base2, a1, a2, b1, b2).  There is
-        always a zero-length sync region at the end of all the files.
-        """
-        from difflib import SequenceMatcher
-
-        ia = ib = 0
-        amatches = SequenceMatcher(None, self.base, self.a).get_matching_blocks()
-        bmatches = SequenceMatcher(None, self.base, self.b).get_matching_blocks()
-        len_a = len(amatches)
-        len_b = len(bmatches)
-
-        sl = []
-
-        while ia < len_a and ib < len_b:
-            abase, amatch, alen = amatches[ia]
-            bbase, bmatch, blen = bmatches[ib]
-
-            # there is an unconflicted block at i; how long does it
-            # extend?  until whichever one ends earlier.
-            i = intersect((abase, abase+alen), (bbase, bbase+blen))
-            if i:
-                intbase = i[0]
-                intend = i[1]
-                intlen = intend - intbase
-
-                # found a match of base[i[0], i[1]]; this may be less than
-                # the region that matches in either one
-                assert intlen <= alen
-                assert intlen <= blen
-                assert abase <= intbase
-                assert bbase <= intbase
-
-                asub = amatch + (intbase - abase)
-                bsub = bmatch + (intbase - bbase)
-                aend = asub + intlen
-                bend = bsub + intlen
-
-                assert self.base[intbase:intend] == self.a[asub:aend], \
-                       (self.base[intbase:intend], self.a[asub:aend])
-
-                assert self.base[intbase:intend] == self.b[bsub:bend]
-
-                sl.append((intbase, intend,
-                           asub, aend,
-                           bsub, bend))
-
-            # advance whichever one ends first in the base text
-            if (abase + alen) < (bbase + blen):
-                ia += 1
-            else:
-                ib += 1
-            
-        intbase = len(self.base)
-        abase = len(self.a)
-        bbase = len(self.b)
-        sl.append((intbase, intbase, abase, abase, bbase, bbase))
-
-        return sl
-
-
-
-    def find_unconflicted(self):
-        """Return a list of ranges in base that are not conflicted."""
-        from difflib import SequenceMatcher
-
-        import re
-
-        # don't sync-up on lines containing only blanks or pounds
-        junk_re = re.compile(r'^[ \t#]*$')
-        
-        am = SequenceMatcher(junk_re.match, self.base, self.a).get_matching_blocks()
-        bm = SequenceMatcher(junk_re.match, self.base, self.b).get_matching_blocks()
-
-        unc = []
-
-        while am and bm:
-            # there is an unconflicted block at i; how long does it
-            # extend?  until whichever one ends earlier.
-            a1 = am[0][0]
-            a2 = a1 + am[0][2]
-            b1 = bm[0][0]
-            b2 = b1 + bm[0][2]
-            i = intersect((a1, a2), (b1, b2))
-            if i:
-                unc.append(i)
-
-            if a2 < b2:
-                del am[0]
-            else:
-                del bm[0]
-                
-        return unc
-
-
-def main(argv):
-    # as for diff3 and meld the syntax is "MINE BASE OTHER"
-    a = file(argv[1], 'rt').readlines()
-    base = file(argv[2], 'rt').readlines()
-    b = file(argv[3], 'rt').readlines()
-
-    m3 = Merge3(base, a, b)
-
-    #for sr in m3.find_sync_regions():
-    #    print sr
-
-    # sys.stdout.writelines(m3.merge_lines(name_a=argv[1], name_b=argv[3]))
-    sys.stdout.writelines(m3.merge_annotated())
-
-
-if __name__ == '__main__':
-    import sys
-    sys.exit(main(sys.argv))

=== modified file 'bzrlib/merge_core.py'
--- bzrlib/merge_core.py	2005-07-28 18:46:35 +0000
+++ bzrlib/merge_core.py	2005-06-06 04:17:53 +0000
@@ -1,73 +1,6 @@
 import changeset
 from changeset import Inventory, apply_changeset, invert_dict
 import os.path
-from osutils import backup_file
-from merge3 import Merge3
-
-class ApplyMerge3:
-    """Contents-change wrapper around merge3.Merge3"""
-    def __init__(self, base_file, other_file):
-        self.base_file = base_file
-        self.other_file = other_file
- 
-    def __eq__(self, other):
-        if not isinstance(other, ApplyMerge3):
-            return False
-        return (self.base_file == other.base_file and 
-                self.other_file == other.other_file)
-
-    def __ne__(self, other):
-        return not (self == other)
-
-
-    def apply(self, filename, conflict_handler, reverse=False):
-        new_file = filename+".new" 
-        if not reverse:
-            base = self.base_file
-            other = self.other_file
-        else:
-            base = self.other_file
-            other = self.base_file
-        m3 = Merge3(file(base, "rb").readlines(), 
-                    file(filename, "rb").readlines(), 
-                    file(other, "rb").readlines())
-
-        new_conflicts = False
-        output_file = file(new_file, "wb")
-        start_marker = "!START OF MERGE CONFLICT!" + "I HOPE THIS IS UNIQUE"
-        for line in m3.merge_lines(name_a = "TREE", name_b = "MERGE-SOURCE", 
-                       start_marker=start_marker):
-            if line.startswith(start_marker):
-                new_conflicts = True
-                output_file.write(line.replace(start_marker, '<<<<<<<<'))
-            else:
-                output_file.write(line)
-        output_file.close()
-        if not new_conflicts:
-            os.chmod(new_file, os.stat(filename).st_mode)
-            os.rename(new_file, filename)
-            return
-        else:
-            conflict_handler.merge_conflict(new_file, filename, base, other)
-
-
-class BackupBeforeChange:
-    """Contents-change wrapper to back up file first"""
-    def __init__(self, contents_change):
-        self.contents_change = contents_change
- 
-    def __eq__(self, other):
-        if not isinstance(other, BackupBeforeChange):
-            return False
-        return (self.contents_change == other.contents_change)
-
-    def __ne__(self, other):
-        return not (self == other)
-
-    def apply(self, filename, conflict_handler, reverse=False):
-        backup_file(filename)
-        self.contents_change.apply(filename, conflict_handler, reverse)
-
 
 class ThreewayInventory(object):
     def __init__(self, this_inventory, base_inventory, other_inventory):
@@ -85,7 +18,7 @@
         
 
 def merge_flex(this, base, other, changeset_function, inventory_function,
-               conflict_handler, merge_factory):
+               conflict_handler):
     this_inventory = inventory_function(this)
     base_inventory = inventory_function(base)
     other_inventory = inventory_function(other)
@@ -94,7 +27,7 @@
                                   make_inv(other_inventory))
     cset = changeset_function(base, other, base_inventory, other_inventory)
     new_cset = make_merge_changeset(cset, inventory, this, base, other, 
-                                    conflict_handler, merge_factory)
+                                    conflict_handler)
     result = apply_changeset(new_cset, invert_invent(this_inventory),
                              this.root, conflict_handler, False)
     conflict_handler.finalize()
@@ -103,7 +36,7 @@
     
 
 def make_merge_changeset(cset, inventory, this, base, other, 
-                         conflict_handler, merge_factory):
+                         conflict_handler=None):
     new_cset = changeset.Changeset()
     def get_this_contents(id):
         path = os.path.join(this.root, inventory.this.get_path(id))
@@ -115,24 +48,55 @@
     for entry in cset.entries.itervalues():
         if entry.is_boring():
             new_cset.add_entry(entry)
+        elif entry.is_creation(False):
+            if inventory.this.get_path(entry.id) is None:
+                new_cset.add_entry(entry)
+            else:
+                this_contents = get_this_contents(entry.id)
+                other_contents = entry.contents_change.new_contents
+                if other_contents == this_contents:
+                    boring_entry = changeset.ChangesetEntry(entry.id, 
+                                                            entry.new_parent, 
+                                                            entry.new_path)
+                    new_cset.add_entry(boring_entry)
+                else:
+                    conflict_handler.contents_conflict(this_contents, 
+                                                       other_contents)
+
+        elif entry.is_deletion(False):
+            if inventory.this.get_path(entry.id) is None:
+                boring_entry = changeset.ChangesetEntry(entry.id, entry.parent, 
+                                                        entry.path)
+                new_cset.add_entry(boring_entry)
+            elif entry.contents_change is not None:
+                this_contents = get_this_contents(entry.id) 
+                base_contents = entry.contents_change.old_contents
+                if base_contents == this_contents:
+                    new_cset.add_entry(entry)
+                else:
+                    entry_path = inventory.this.get_path(entry.id)
+                    conflict_handler.rem_contents_conflict(entry_path,
+                                                           this_contents, 
+                                                           base_contents)
+
+            else:
+                new_cset.add_entry(entry)
         else:
-            new_entry = make_merged_entry(entry, inventory, conflict_handler)
-            new_contents = make_merged_contents(entry, this, base, other, 
-                                                inventory, conflict_handler, 
-                                                merge_factory)
-            new_entry.contents_change = new_contents
-            new_entry.metadata_change = make_merged_metadata(entry, base, other)
-            new_cset.add_entry(new_entry)
-
+            entry = get_merge_entry(entry, inventory, base, other, 
+                                    conflict_handler)
+            if entry is not None:
+                new_cset.add_entry(entry)
     return new_cset
 
-def make_merged_entry(entry, inventory, conflict_handler):
-    from bzrlib.trace import mutter
+
+def get_merge_entry(entry, inventory, base, other, conflict_handler):
     this_name = inventory.this.get_name(entry.id)
     this_parent = inventory.this.get_parent(entry.id)
     this_dir = inventory.this.get_dir(entry.id)
     if this_dir is None:
         this_dir = ""
+    if this_name is None:
+        return conflict_handler.merge_missing(entry.id, inventory)
 
     base_name = inventory.base.get_name(entry.id)
     base_parent = inventory.base.get_parent(entry.id)
@@ -144,8 +108,7 @@
     other_dir = inventory.base.get_dir(entry.id)
     if other_dir is None:
         other_dir = ""
-    mutter("Dirs: this, base, other %r %r %r" % (this_dir, base_dir, other_dir))
-    mutter("Names: this, base, other %r %r %r" % (this_name, base_name, other_name))
+
     if base_name == other_name:
         old_name = this_name
         new_name = this_name
@@ -170,67 +133,24 @@
             old_dir = this_dir
             new_parent = other_parent
             new_dir = other_dir
-    if old_name is not None and old_parent is not None:
-        old_path = os.path.join(old_dir, old_name)
-    else:
-        old_path = None
-    new_entry = changeset.ChangesetEntry(entry.id, old_parent, old_path)
-    if new_name is not None and new_parent is not None:
+    old_path = os.path.join(old_dir, old_name)
+    new_entry = changeset.ChangesetEntry(entry.id, old_parent, old_name)
+    if new_name is not None or new_parent is not None:
         new_entry.new_path = os.path.join(new_dir, new_name)
     else:
         new_entry.new_path = None
     new_entry.new_parent = new_parent
-    mutter(repr(new_entry))
+
+    base_path = base.readonly_path(entry.id)
+    other_path = other.readonly_path(entry.id)
+    
+    if entry.contents_change is not None:
+        new_entry.contents_change = changeset.Diff3Merge(base_path, other_path)
+    if entry.metadata_change is not None:
+        new_entry.metadata_change = PermissionsMerge(base_path, other_path)
+
     return new_entry
 
-
-def make_merged_contents(entry, this, base, other, inventory, conflict_handler,
-                         merge_factory):
-    contents = entry.contents_change
-    if contents is None:
-        return None
-    this_path = this.readonly_path(entry.id)
-    def make_merge():
-        if this_path is None:
-            return conflict_handler.missing_for_merge(entry.id, inventory)
-        base_path = base.readonly_path(entry.id)
-        other_path = other.readonly_path(entry.id)    
-        return merge_factory(base_path, other_path)
-
-    if isinstance(contents, changeset.PatchApply):
-        return make_merge()
-    if isinstance(contents, changeset.ReplaceContents):
-        if contents.old_contents is None and contents.new_contents is None:
-            return None
-        if contents.new_contents is None:
-            if this_path is not None and os.path.exists(this_path):
-                return contents
-            else:
-                return None
-        elif contents.old_contents is None:
-            if this_path is None or not os.path.exists(this_path):
-                return contents
-            else:
-                this_contents = file(this_path, "rb").read()
-                if this_contents == contents.new_contents:
-                    return None
-                else:
-                    other_path = other.readonly_path(entry.id)    
-                    conflict_handler.new_contents_conflict(this_path, 
-                                                           other_path)
-        elif isinstance(contents.old_contents, changeset.FileCreate) and \
-            isinstance(contents.new_contents, changeset.FileCreate):
-            return make_merge()
-        else:
-            raise Exception("Unhandled merge scenario")
-
-def make_merged_metadata(entry, base, other):
-    if entry.metadata_change is not None:
-        base_path = base.readonly_path(entry.id)
-        other_path = other.readonly_path(entry.id)    
-        return PermissionsMerge(base_path, other_path)
-    
-
 class PermissionsMerge(object):
     def __init__(self, base_path, other_path):
         self.base_path = base_path
@@ -276,10 +196,6 @@
         os.chmod(self.abs_path(path), mode)
         self.inventory[id] = path
 
-    def remove_file(self, id):
-        os.unlink(self.full_path(id))
-        del self.inventory[id]
-
     def add_dir(self, id, parent, name, mode):
         path = self.child_path(parent, name)
         full_path = self.abs_path(path)
@@ -292,14 +208,7 @@
         return os.path.join(self.dir, path)
 
     def full_path(self, id):
-        try:
-            tree_path = self.inventory[id]
-        except KeyError:
-            return None
-        return self.abs_path(tree_path)
-
-    def readonly_path(self, id):
-        return self.full_path(id)
+        return self.abs_path(self.inventory[id])
 
     def change_path(self, id, path):
         new = os.path.join(self.dir, self.inventory[id])
@@ -329,22 +238,6 @@
         path = self.get_cset_path(parent, name)
         self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
 
-    def remove_file(self, id, base=False, this=False, other=False):
-        for option, tree in ((base, self.base), (this, self.this), 
-                             (other, self.other)):
-            if option:
-                tree.remove_file(id)
-            if other or base:
-                change = self.cset.entries[id].contents_change
-                assert isinstance(change, changeset.ReplaceContents)
-                if other:
-                    change.new_contents=None
-                if base:
-                    change.old_contents=None
-                if change.old_contents is None and change.new_contents is None:
-                    change = None
-
-
     def add_dir(self, id, parent, name, mode):
         path = self.get_cset_path(parent, name)
         self.base.add_dir(id, parent, name, mode)
@@ -431,66 +324,19 @@
     def change_perms_tree(self, id, tree, mode):
         os.chmod(tree.full_path(id), mode)
 
-    def merge_changeset(self, merge_factory):
+    def merge_changeset(self):
         all_inventory = ThreewayInventory(Inventory(self.this.inventory),
                                           Inventory(self.base.inventory), 
                                           Inventory(self.other.inventory))
         conflict_handler = changeset.ExceptionConflictHandler(self.this.dir)
-        return make_merge_changeset(self.cset, all_inventory, self.this,
-                                    self.base, self.other, conflict_handler,
-                                    merge_factory)
-
-    def apply_inv_change(self, inventory_change, orig_inventory):
-        orig_inventory_by_path = {}
-        for file_id, path in orig_inventory.iteritems():
-            orig_inventory_by_path[path] = file_id
-
-        def parent_id(file_id):
-            try:
-                parent_dir = os.path.dirname(orig_inventory[file_id])
-            except:
-                print file_id
-                raise
-            if parent_dir == "":
-                return None
-            return orig_inventory_by_path[parent_dir]
-        
-        def new_path(file_id):
-            if inventory_change.has_key(file_id):
-                return inventory_change[file_id]
-            else:
-                parent = parent_id(file_id)
-                if parent is None:
-                    return orig_inventory[file_id]
-                dirname = new_path(parent)
-                return os.path.join(dirname, orig_inventory[file_id])
-
-        new_inventory = {}
-        for file_id in orig_inventory.iterkeys():
-            path = new_path(file_id)
-            if path is None:
-                continue
-            new_inventory[file_id] = path
-
-        for file_id, path in inventory_change.iteritems():
-            if orig_inventory.has_key(file_id):
-                continue
-            new_inventory[file_id] = path
-        return new_inventory
-
-        
-
+        return make_merge_changeset(self.cset, all_inventory, self.this.dir,
+                                    self.base.dir, self.other.dir, 
+                                    conflict_handler)
     def apply_changeset(self, cset, conflict_handler=None, reverse=False):
-        inventory_change = changeset.apply_changeset(cset,
-                                                     self.this.inventory,
-                                                     self.this.dir,
-                                                     conflict_handler, reverse)
-        self.this.inventory =  self.apply_inv_change(inventory_change, 
-                                                     self.this.inventory)
-
-                    
-        
-
+        self.this.inventory = \
+            changeset.apply_changeset(cset, self.this.inventory,
+                                      self.this.dir, conflict_handler,
+                                      reverse)
         
     def cleanup(self):
         shutil.rmtree(self.dir)
@@ -506,7 +352,7 @@
         builder.change_name("2", base="name4")
         builder.add_file("3", "0", "name5", "hello3", 0755)
         builder.change_name("3", this="name6")
-        cset = builder.merge_changeset(ApplyMerge3)
+        cset = builder.merge_changeset()
         assert(cset.entries["2"].is_boring())
         assert(cset.entries["1"].name == "name1")
         assert(cset.entries["1"].new_name == "name2")
@@ -525,7 +371,7 @@
         builder.add_file("1", "0", "name1", "hello1", 0644)
         builder.change_name("1", other="name2", this="name3")
         self.assertRaises(changeset.RenameConflict, 
-                          builder.merge_changeset, ApplyMerge3)
+                          builder.merge_changeset)
         builder.cleanup()
         
     def test_file_moves(self):
@@ -542,7 +388,7 @@
         assert(Inventory(builder.this.inventory).get_parent("4") == "2")
         builder.change_parent("5", base="2")
         assert(Inventory(builder.base.inventory).get_parent("5") == "2")
-        cset = builder.merge_changeset(ApplyMerge3)
+        cset = builder.merge_changeset()
         for id in ("1", "2", "4", "5"):
             assert(cset.entries[id].is_boring())
         assert(cset.entries["3"].parent == "1")
@@ -557,37 +403,11 @@
         builder.add_file("4", "1", "file1", "hello1", 0644)
         builder.change_parent("4", other="2", this="3")
         self.assertRaises(changeset.MoveConflict, 
-                          builder.merge_changeset, ApplyMerge3)
+                          builder.merge_changeset)
         builder.cleanup()
 
     def test_contents_merge(self):
-        """Test merge3 merging"""
-        self.do_contents_test(ApplyMerge3)
-
-    def test_contents_merge2(self):
-        """Test diff3 merging"""
-        self.do_contents_test(changeset.Diff3Merge)
-
-    def test_contents_merge3(self):
-        """Test diff3 merging"""
-        def backup_merge(base_file, other_file):
-            return BackupBeforeChange(ApplyMerge3(base_file, other_file))
-        builder = self.contents_test_success(backup_merge)
-        def backup_exists(file_id):
-            return os.path.exists(builder.this.full_path(file_id)+"~")
-        assert backup_exists("1")
-        assert backup_exists("2")
-        assert not backup_exists("3")
-        builder.cleanup()
-
-    def do_contents_test(self, merge_factory):
-        """Test merging with specified ContentsChange factory"""
-        builder = self.contents_test_success(merge_factory)
-        builder.cleanup()
-        self.contents_test_conflicts(merge_factory)
-
-    def contents_test_success(self, merge_factory):
-        from inspect import isclass
+        """Test diff3 merging"""
         builder = MergeBuilder()
         builder.add_file("1", "0", "name1", "text1", 0755)
         builder.change_contents("1", other="text4")
@@ -595,13 +415,12 @@
         builder.change_contents("2", base="text5")
         builder.add_file("3", "0", "name5", "text3", 0744)
         builder.change_contents("3", this="text6")
-        cset = builder.merge_changeset(merge_factory)
+        cset = builder.merge_changeset()
         assert(cset.entries["1"].contents_change is not None)
-        if isclass(merge_factory):
-            assert(isinstance(cset.entries["1"].contents_change,
-                          merge_factory))
-            assert(isinstance(cset.entries["2"].contents_change,
-                          merge_factory))
+        assert(isinstance(cset.entries["1"].contents_change,
+                          changeset.Diff3Merge))
+        assert(isinstance(cset.entries["2"].contents_change,
+                          changeset.Diff3Merge))
         assert(cset.entries["3"].is_boring())
         builder.apply_changeset(cset)
         assert(file(builder.this.full_path("1"), "rb").read() == "text4" )
@@ -609,33 +428,16 @@
         assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
         assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
         assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
-        return builder
+        builder.cleanup()
 
-    def contents_test_conflicts(self, merge_factory):
         builder = MergeBuilder()
         builder.add_file("1", "0", "name1", "text1", 0755)
         builder.change_contents("1", other="text4", this="text3")
-        cset = builder.merge_changeset(merge_factory)
+        cset = builder.merge_changeset()
         self.assertRaises(changeset.MergeConflict, builder.apply_changeset,
                           cset)
         builder.cleanup()
 
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4", base="text3")
-        builder.remove_file("1", base=True)
-        self.assertRaises(changeset.NewContentsConflict,
-                          builder.merge_changeset, merge_factory)
-        builder.cleanup()
-
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4", base="text3")
-        builder.remove_file("1", this=True)
-        self.assertRaises(changeset.MissingForMerge, builder.merge_changeset, 
-                          merge_factory)
-        builder.cleanup()
-
     def test_perms_merge(self):
         builder = MergeBuilder()
         builder.add_file("1", "0", "name1", "text1", 0755)
@@ -644,7 +446,7 @@
         builder.change_perms("2", base=0655)
         builder.add_file("3", "0", "name3", "text3", 0755)
         builder.change_perms("3", this=0655)
-        cset = builder.merge_changeset(ApplyMerge3)
+        cset = builder.merge_changeset()
         assert(cset.entries["1"].metadata_change is not None)
         assert(isinstance(cset.entries["1"].metadata_change,
                           PermissionsMerge))
@@ -659,7 +461,7 @@
         builder = MergeBuilder()
         builder.add_file("1", "0", "name1", "text1", 0755)
         builder.change_perms("1", other=0655, base=0555)
-        cset = builder.merge_changeset(ApplyMerge3)
+        cset = builder.merge_changeset()
         self.assertRaises(changeset.MergePermissionConflict, 
                      builder.apply_changeset, cset)
         builder.cleanup()

=== removed file 'bzrlib/meta_store.py'
--- bzrlib/meta_store.py	2005-06-27 01:36:22 +0000
+++ bzrlib/meta_store.py	1970-01-01 00:00:00 +0000
@@ -1,41 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from trace import mutter
-from bzrlib.store import ImmutableStore
-
-class CachedStore:
-    """A store that caches data locally, to avoid repeated downloads.
-    The precacache method should be used to avoid server round-trips for
-    every piece of data.
-    """
-    def __init__(self, store, cache_dir):
-        self.source_store = store
-        self.cache_store = ImmutableStore(cache_dir)
-
-    def __getitem__(self, id):
-        mutter("Cache add %s" % id)
-        if id not in self.cache_store:
-            self.cache_store.add(self.source_store[id], id)
-        return self.cache_store[id]
-
-    def prefetch(self, ids):
-        """Copy a series of ids into the cache, before they are used.
-        For remote stores that support pipelining or async downloads, this can
-        increase speed considerably.
-        """
-        mutter("Prefetch of ids %s" % ",".join(ids))
-        self.cache_store.copy_multi(self.source_store, ids)

=== modified file 'bzrlib/newinventory.py'
--- bzrlib/newinventory.py	2005-07-11 07:33:45 +0000
+++ bzrlib/newinventory.py	2005-06-17 07:28:53 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from xml import ElementTree, Element
+from cElementTree import Element, ElementTree, SubElement
 
 
 def write_inventory(inv, f):
@@ -139,6 +139,6 @@
     root_el = inv_el[0]
     assert root_el.tag == 'root_directory'
 
-    inv = Inventory(inv_el.get('file_id'))
+    inv = Inventory()
     for el in root_el:
         descend(inv.root, el)

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2005-07-23 13:59:30 +0000
+++ bzrlib/osutils.py	2005-06-17 07:28:53 +0000
@@ -38,19 +38,13 @@
 
 
 _QUOTE_RE = re.compile(r'([^a-zA-Z0-9.,:/_~-])')
-
-_SLASH_RE = re.compile(r'[\\/]+')
-
 def quotefn(f):
-    """Return a quoted filename filename
-
-    This previously used backslash quoting, but that works poorly on
-    Windows."""
-    # TODO: I'm not really sure this is the best format either.x
-    if _QUOTE_RE.search(f):
-        return '"' + f + '"'
-    else:
-        return f
+    """Return shell-quoted filename"""
+    ## We could be a bit more terse by using double-quotes etc
+    f = _QUOTE_RE.sub(r'\\\1', f)
+    if f[0] == '~':
+        f[0:1] = r'\~' 
+    return f
 
 
 def file_kind(f):
@@ -77,44 +71,6 @@
 
 
 
-def backup_file(fn):
-    """Copy a file to a backup.
-
-    Backups are named in GNU-style, with a ~ suffix.
-
-    If the file is already a backup, it's not copied.
-    """
-    import os
-    if fn[-1] == '~':
-        return
-    bfn = fn + '~'
-
-    inf = file(fn, 'rb')
-    try:
-        content = inf.read()
-    finally:
-        inf.close()
-    
-    outf = file(bfn, 'wb')
-    try:
-        outf.write(content)
-    finally:
-        outf.close()
-
-def rename(path_from, path_to):
-    """Basically the same as os.rename() just special for win32"""
-    if sys.platform == 'win32':
-        try:
-            os.remove(path_to)
-        except OSError, e:
-            if e.errno != e.ENOENT:
-                raise
-    os.rename(path_from, path_to)
-
-
-
-
-
 def isdir(f):
     """True if f is an accessible directory."""
     try:
@@ -134,34 +90,16 @@
 
 def is_inside(dir, fname):
     """True if fname is inside dir.
-    
-    The parameters should typically be passed to os.path.normpath first, so
-    that . and .. and repeated slashes are eliminated, and the separators
-    are canonical for the platform.
-    
-    >>> is_inside('src', 'src/foo.c')
-    True
-    >>> is_inside('src', 'srccontrol')
-    False
-    >>> is_inside('src', 'src/a/a/a/foo.c')
-    True
-    >>> is_inside('foo.c', 'foo.c')
-    True
     """
-    # XXX: Most callers of this can actually do something smarter by 
-    # looking at the inventory
-
-    if dir == fname:
-        return True
-    
-    if dir[-1] != os.sep:
-        dir += os.sep
-    
-    return fname.startswith(dir)
+    return os.path.commonprefix([dir, fname]) == dir
 
 
 def is_inside_any(dir_list, fname):
     """True if fname is inside any of given dirs."""
+    # quick scan for perfect match
+    if fname in dir_list:
+        return True
+    
     for dirname in dir_list:
         if is_inside(dirname, fname):
             return True
@@ -446,100 +384,3 @@
         if not ignore_errors:
             raise BzrError('command failed')
 
-
-def _read_config_value(name):
-    """Read a config value from the file ~/.bzr.conf/<name>
-    Return None if the file does not exist"""
-    try:
-        f = file(os.path.join(config_dir(), name), "r")
-        return f.read().decode(bzrlib.user_encoding).rstrip("\r\n")
-    except IOError, e:
-        if e.errno == errno.ENOENT:
-            return None
-        raise
-
-
-def _get_editor():
-    """Return a sequence of possible editor binaries for the current platform"""
-    e = _read_config_value("editor")
-    if e is not None:
-        yield e
-        
-    if os.name == "windows":
-        yield "notepad.exe"
-    elif os.name == "posix":
-        try:
-            yield os.environ["EDITOR"]
-        except KeyError:
-            yield "/usr/bin/vi"
-
-
-def _run_editor(filename):
-    """Try to execute an editor to edit the commit message. Returns True on success,
-    False on failure"""
-    for e in _get_editor():
-        x = os.spawnvp(os.P_WAIT, e, (e, filename))
-        if x == 0:
-            return True
-        elif x == 127:
-            continue
-        else:
-            break
-    raise BzrError("Could not start any editor. Please specify $EDITOR or use ~/.bzr.conf/editor")
-    return False
-                          
-
-def get_text_message(infotext, ignoreline = "default"):
-    import tempfile
-    
-    if ignoreline == "default":
-        ignoreline = "-- This line and the following will be ignored --"
-        
-    try:
-        tmp_fileno, msgfilename = tempfile.mkstemp()
-        msgfile = os.close(tmp_fileno)
-        if infotext is not None and infotext != "":
-            hasinfo = True
-            msgfile = file(msgfilename, "w")
-            msgfile.write("\n\n%s\n\n%s" % (ignoreline, infotext))
-            msgfile.close()
-        else:
-            hasinfo = False
-
-        if not _run_editor(msgfilename):
-            return None
-        
-        started = False
-        msg = []
-        lastline, nlines = 0, 0
-        for line in file(msgfilename, "r"):
-            stripped_line = line.strip()
-            # strip empty line before the log message starts
-            if not started:
-                if stripped_line != "":
-                    started = True
-                else:
-                    continue
-            # check for the ignore line only if there
-            # is additional information at the end
-            if hasinfo and stripped_line == ignoreline:
-                break
-            nlines += 1
-            # keep track of the last line that had some content
-            if stripped_line != "":
-                lastline = nlines
-            msg.append(line)
-            
-        if len(msg) == 0:
-            return None
-        # delete empty lines at the end
-        del msg[lastline:]
-        # add a newline at the end, if needed
-        if not msg[-1].endswith("\n"):
-            return "%s%s" % ("".join(msg), "\n")
-        else:
-            return "".join(msg)
-    finally:
-        # delete the msg file in any case
-        try: os.unlink(msgfilename)
-        except IOError: pass

=== modified file 'bzrlib/patch.py'
--- bzrlib/patch.py	2005-07-26 15:25:58 +0000
+++ bzrlib/patch.py	2005-05-15 02:36:04 +0000
@@ -1,20 +1,10 @@
 import os
-from subprocess import Popen, PIPE
+import popen2
 """
 Diff and patch functionality
 """
 __docformat__ = "restructuredtext"
 
-def write_to_cmd(args, input=""):
-    process = Popen(args, bufsize=len(input), stdin=PIPE, stdout=PIPE,
-                    stderr=PIPE, close_fds=True)
-    stdout, stderr = process.communicate(input)
-    status = process.wait()
-    if status < 0:
-        raise Exception("%s killed by signal %i" (args[0], -status))
-    return stdout, stderr, status
-    
-
 def patch(patch_contents, filename, output_filename=None, reverse=False):
     """Apply a patch to a file, to produce another output file.  This is should
     be suitable for our limited purposes.
@@ -36,7 +26,10 @@
     if output_filename is not None:
         args.extend(("-o", output_filename))
     args.append(filename)
-    stdout, stderr, status = write_to_cmd(args, patch_contents)
+    process = popen2.Popen3(args, bufsize=len(patch_contents))
+    process.tochild.write(patch_contents)
+    process.tochild.close()
+    status = os.WEXITSTATUS(process.wait())
     return status 
 
 
@@ -56,7 +49,11 @@
     if orig_label is not None and mod_label is not None:
         args.extend(("-L", orig_label, "-L", mod_label))
     args.extend(("--", orig_file, "-"))
-    patch, stderr, status = write_to_cmd(args, mod_str)
+    process = popen2.Popen3(args, bufsize=len(mod_str))
+    process.tochild.write(mod_str)
+    process.tochild.close()
+    patch = process.fromchild.read()
+    status = os.WEXITSTATUS(process.wait())
     if status == 0:
         return None
     else:
@@ -70,8 +67,11 @@
     add_label(args, "ANCESTOR")
     add_label(args, "MERGE-SOURCE")
     args.extend((mine_path, older_path, yours_path))
-    output, stderr, status = write_to_cmd(args)
+    process = popen2.Popen4(args)
+    process.tochild.close()
+    output = process.fromchild.read()
+    status = os.WEXITSTATUS(process.wait())
     if status not in (0, 1):
-        raise Exception(stderr)
+        raise Exception(output)
     file(out_file, "wb").write(output)
     return status

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2005-07-22 22:31:40 +0000
+++ bzrlib/plugin.py	2005-06-22 06:59:55 +0000
@@ -22,45 +22,27 @@
 # commands, import bzrlib.commands and add your new command to the
 # plugin_cmds variable.
 
-
-import os
-from bzrlib.osutils import config_dir
-DEFAULT_PLUGIN_PATH = os.path.join(config_dir(), 'plugins')
-
-all_plugins = []
-_loaded = False
+import sys, os, imp
+try:
+    set
+except NameError:
+    from sets import Set as set         # python2.3
+from bzrlib.trace import log_error
+
+
+DEFAULT_PLUGIN_PATH = '~/.bzr.conf/plugins'
 
 
 def load_plugins():
-    """
-    Find all python plugins and load them.
-
-    Loading a plugin means importing it into the python interpreter.
-    The plugin is expected to make calls to register commands when
-    it's loaded (or perhaps access other hooks in future.)
-
-    A list of plugs is stored in bzrlib.plugin.all_plugins for future
-    reference.
-
-    The environment variable BZR_PLUGIN_PATH is considered a delimited
-    set of paths to look through. Each entry is searched for *.py
-    files (and whatever other extensions are used in the platform,
-    such as *.pyd).
-    """
-
-    global all_plugins, _loaded
-    if _loaded:
-        # People can make sure plugins are loaded, they just won't be twice
-        return
-        #raise BzrError("plugins already initialized")
-    _loaded = True
-
-    import sys, os, imp
-    
-    from bzrlib.trace import log_error, mutter, log_exception
-    from bzrlib.errors import BzrError
-
-    bzrpath = os.environ.get('BZR_PLUGIN_PATH', DEFAULT_PLUGIN_PATH)
+    """Find all python files which are plugins, and load them
+
+    The environment variable BZR_PLUGIN_PATH is considered a delimited set of
+    paths to look through. Each entry is searched for *.py files (and whatever
+    other extensions are used in the platform, such as *.pyd).
+    """
+    bzrpath = os.environ.get('BZR_PLUGIN_PATH')
+    if not bzrpath:
+        bzrpath = os.path.expanduser(DEFAULT_PLUGIN_PATH)
 
     # The problem with imp.get_suffixes() is that it doesn't include
     # .pyo which is technically valid
@@ -71,9 +53,8 @@
     suffixes.append(('.pyo', 'rb', imp.PY_COMPILED))
     package_entries = ['__init__.py', '__init__.pyc', '__init__.pyo']
     for d in bzrpath.split(os.pathsep):
-        # going through them one by one allows different plugins with the same
+        # going trough them one by one allows different plugins with the same
         # filename in different directories in the path
-        mutter('looking for plugins in %s' % d)
         if not d:
             continue
         plugin_names = set()
@@ -98,7 +79,6 @@
                         break
                 else:
                     continue
-            mutter('add plugin name %s' % f)
             plugin_names.add(f)
 
         plugin_names = list(plugin_names)
@@ -106,16 +86,12 @@
         for name in plugin_names:
             try:
                 plugin_info = imp.find_module(name, [d])
-                mutter('load plugin %r' % (plugin_info,))
                 try:
                     plugin = imp.load_module('bzrlib.plugin.' + name,
                                              *plugin_info)
-                    all_plugins.append(plugin)
                 finally:
                     if plugin_info[0] is not None:
                         plugin_info[0].close()
             except Exception, e:
-                log_error('Unable to load plugin %r from %r' % (name, d))
-                log_error(str(e))
-                log_exception()
+                log_error('Unable to load plugin: %r from %r\n%s' % (name, d, e))
 

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2005-07-22 23:06:25 +0000
+++ bzrlib/progress.py	2005-06-17 07:34:04 +0000
@@ -16,7 +16,10 @@
 #    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-"""Simple text-mode progress indicator.
+"""
+Simple text-mode progress indicator.
+
+Everyone loves ascii art!
 
 To display an indicator, create a ProgressBar object.  Call it,
 passing Progress objects indicating the current state.  When done,
@@ -26,19 +29,18 @@
 not to clutter log files.
 """
 
+# TODO: remove functions in favour of keeping everything in one class
+
 # TODO: should be a global option e.g. --silent that disables progress
 # indicators, preferably without needing to adjust all code that
 # potentially calls them.
 
-# TODO: If not on a tty perhaps just print '......' for the benefit of IDEs, etc
-
-# TODO: Optionally show elapsed time instead/as well as ETA; nicer
-# when the rate is unpredictable
+# TODO: Perhaps don't write updates faster than a certain rate, say
+# 5/second.
 
 
 import sys
 import time
-import os
 
 
 def _width():
@@ -49,6 +51,7 @@
     TODO: Is there anything that gets a better update when the window
           is resized while the program is running?
     """
+    import os
     try:
         return int(os.environ['COLUMNS'])
     except (IndexError, KeyError, ValueError):
@@ -60,6 +63,7 @@
         return False
     if not f.isatty():
         return False
+    import os
     if os.environ.get('TERM') == 'dumb':
         # e.g. emacs compile window
         return False
@@ -67,61 +71,7 @@
 
 
 
-def ProgressBar(to_file=sys.stderr, **kwargs):
-    """Abstract factory"""
-    if _supports_progress(to_file):
-        return TTYProgressBar(to_file=to_file, **kwargs)
-    else:
-        return DotsProgressBar(to_file=to_file, **kwargs)
-    
-    
-class _BaseProgressBar(object):
-    def __init__(self,
-                 to_file=sys.stderr,
-                 show_pct=False,
-                 show_spinner=False,
-                 show_eta=True,
-                 show_bar=True,
-                 show_count=True):
-        object.__init__(self)
-        self.to_file = to_file
- 
-        self.last_msg = None
-        self.last_cnt = None
-        self.last_total = None
-        self.show_pct = show_pct
-        self.show_spinner = show_spinner
-        self.show_eta = show_eta
-        self.show_bar = show_bar
-        self.show_count = show_count
-        
-        
-    
-class DotsProgressBar(_BaseProgressBar):
-    def __init__(self, **kwargs):
-        _BaseProgressBar.__init__(self, **kwargs)
-        self.last_msg = None
-        self.need_nl = False
-        
-    def tick(self):
-        self.update()
-        
-    def update(self, msg=None, current_cnt=None, total_cnt=None):
-        if msg and msg != self.last_msg:
-            if self.need_nl:
-                self.to_file.write('\n')
-            
-            self.to_file.write(msg + ': ')
-            self.last_msg = msg
-        self.need_nl = True
-        self.to_file.write('.')
-        
-    def clear(self):
-        if self.need_nl:
-            self.to_file.write('\n')
-        
-    
-class TTYProgressBar(_BaseProgressBar):
+class ProgressBar(object):
     """Progress bar display object.
 
     Several options are available to control the display.  These can
@@ -144,29 +94,30 @@
     SPIN_CHARS = r'/-\|'
     MIN_PAUSE = 0.1 # seconds
 
-
-    def __init__(self, **kwargs):
-        _BaseProgressBar.__init__(self, **kwargs)
+    start_time = None
+    last_update = None
+    
+    def __init__(self,
+                 to_file=sys.stderr,
+                 show_pct=False,
+                 show_spinner=False,
+                 show_eta=True,
+                 show_bar=True,
+                 show_count=True):
+        object.__init__(self)
+        self.to_file = to_file
+        self.suppressed = not _supports_progress(self.to_file)
         self.spin_pos = 0
-        self.width = _width()
-        self.start_time = None
-        self.last_update = None
-    
-
-    def throttle(self):
-        """Return True if the bar was updated too recently"""
-        now = time.time()
-        if self.start_time is None:
-            self.start_time = self.last_update = now
-            return False
-        else:
-            interval = now - self.last_update
-            if interval > 0 and interval < self.MIN_PAUSE:
-                return True
-
-        self.last_update = now
-        return False
-        
+ 
+        self.last_msg = None
+        self.last_cnt = None
+        self.last_total = None
+        self.show_pct = show_pct
+        self.show_spinner = show_spinner
+        self.show_eta = show_eta
+        self.show_bar = show_bar
+        self.show_count = show_count
+
 
     def tick(self):
         self.update(self.last_msg, self.last_cnt, self.last_total)
@@ -175,15 +126,26 @@
 
     def update(self, msg, current_cnt=None, total_cnt=None):
         """Update and redraw progress bar."""
+        if self.suppressed:
+            return
 
         # save these for the tick() function
         self.last_msg = msg
         self.last_cnt = current_cnt
         self.last_total = total_cnt
             
-        if self.throttle():
-            return 
+        now = time.time()
+        if self.start_time is None:
+            self.start_time = now
+        else:
+            interval = now - self.last_update
+            if interval > 0 and interval < self.MIN_PAUSE:
+                return
+
+        self.last_update = now
         
+        width = _width()
+
         if total_cnt:
             assert current_cnt <= total_cnt
         if current_cnt:
@@ -223,7 +185,7 @@
 
         if self.show_bar:
             # progress bar, if present, soaks up all remaining space
-            cols = self.width - 1 - len(msg) - len(spin_str) - len(pct_str) \
+            cols = width - 1 - len(msg) - len(spin_str) - len(pct_str) \
                    - len(eta_str) - len(count_str) - 3
 
             if total_cnt:
@@ -244,13 +206,16 @@
 
         m = spin_str + bar_str + msg + count_str + pct_str + eta_str
 
-        assert len(m) < self.width
-        self.to_file.write('\r' + m.ljust(self.width - 1))
+        assert len(m) < width
+        self.to_file.write('\r' + m.ljust(width - 1))
         #self.to_file.flush()
             
 
-    def clear(self):        
-        self.to_file.write('\r%s\r' % (' ' * (self.width - 1)))
+    def clear(self):
+        if self.suppressed:
+            return
+        
+        self.to_file.write('\r%s\r' % (' ' * (_width() - 1)))
         #self.to_file.flush()        
     
 
@@ -300,18 +265,7 @@
 
 
 def demo():
-    sleep = time.sleep
-    
-    print 'dumb-terminal test:'
-    pb = DotsProgressBar()
-    for i in range(100):
-        pb.update('Leoparden', i, 99)
-        sleep(0.1)
-    sleep(1.5)
-    pb.clear()
-    sleep(1.5)
-    
-    print 'smart-terminal test:'
+    from time import sleep
     pb = ProgressBar(show_pct=True, show_bar=True, show_spinner=False)
     for i in range(100):
         pb.update('Elephanten', i, 99)
@@ -319,7 +273,6 @@
     sleep(2)
     pb.clear()
     sleep(1)
-
     print 'done!'
 
 if __name__ == "__main__":

=== modified file 'bzrlib/remotebranch.py'
--- bzrlib/remotebranch.py	2005-06-28 11:14:41 +0000
+++ bzrlib/remotebranch.py	2005-06-01 03:16:18 +0000
@@ -143,12 +143,11 @@
         pl = len(self.baseurl)
         return path[pl:].lstrip('/')
 
-
     def get_revision(self, revision_id):
-        from bzrlib.revision import Revision
-        from bzrlib.xml import unpack_xml
-        revf = self.revision_store[revision_id]
-        r = unpack_xml(Revision, revf)
+        from revision import Revision
+        revf = get_url(self.baseurl + '/.bzr/revision-store/' + revision_id,
+                       True)
+        r = Revision.read_xml(revf)
         if r.revision_id != revision_id:
             raise BzrCheckError('revision stored as {%s} actually contains {%s}'
                                 % (revision_id, r.revision_id))
@@ -170,4 +169,62 @@
         return get_url(p, compressed=True)
     
 
+def simple_walk():
+    """For experimental purposes, traverse many parts of a remote branch"""
+    from revision import Revision
+    from branch import Branch
+    from inventory import Inventory
+
+    got_invs = {}
+    got_texts = {}
+
+    print 'read history'
+    history = get_url('/.bzr/revision-history').readlines()
+    num_revs = len(history)
+    for i, rev_id in enumerate(history):
+        rev_id = rev_id.rstrip()
+        print 'read revision %d/%d' % (i, num_revs)
+
+        # python gzip needs a seekable file (!!) but the HTTP response
+        # isn't, so we need to buffer it
+
+        rev_f = get_url('/.bzr/revision-store/%s' % rev_id,
+                        compressed=True)
+
+        rev = Revision.read_xml(rev_f)
+        print rev.message
+        inv_id = rev.inventory_id
+        if inv_id not in got_invs:
+            print 'get inventory %s' % inv_id
+            inv_f = get_url('/.bzr/inventory-store/%s' % inv_id,
+                            compressed=True)
+            inv = Inventory.read_xml(inv_f)
+            print '%4d inventory entries' % len(inv)
+
+            for path, ie in inv.iter_entries():
+                text_id = ie.text_id
+                if text_id == None:
+                    continue
+                if text_id in got_texts:
+                    continue
+                print '  fetch %s text {%s}' % (path, text_id)
+                text_f = get_url('/.bzr/text-store/%s' % text_id,
+                                 compressed=True)
+                got_texts[text_id] = True
+
+            got_invs.add[inv_id] = True
+
+        print '----'
+
+
+def try_me():
+    BASE_URL = 'http://bazaar-ng.org/bzr/bzr.dev/'
+    b = RemoteBranch(BASE_URL)
+    ## print '\n'.join(b.revision_history())
+    from log import show_log
+    show_log(b)
+
+
+if __name__ == '__main__':
+    try_me()
     

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2005-07-04 11:57:18 +0000
+++ bzrlib/revision.py	2005-06-20 04:58:12 +0000
@@ -17,7 +17,17 @@
 
 
 
-class RevisionReference(object):
+from xml import XMLMixin
+
+try:
+    from cElementTree import Element, ElementTree, SubElement
+except ImportError:
+    from elementtree.ElementTree import Element, ElementTree, SubElement
+
+from errors import BzrError
+
+
+class RevisionReference:
     """
     Reference to a stored revision.
 
@@ -25,7 +35,7 @@
     """
     revision_id = None
     revision_sha1 = None
-    def __init__(self, revision_id, revision_sha1=None):
+    def __init__(self, revision_id, revision_sha1):
         if revision_id == None \
            or isinstance(revision_id, basestring):
             self.revision_id = revision_id
@@ -41,7 +51,7 @@
                 
 
 
-class Revision(object):
+class Revision(XMLMixin):
     """Single revision on a branch.
 
     Revisions may know their revision_hash, but only once they've been
@@ -49,6 +59,9 @@
     into the file it describes.
 
     After bzr 0.0.5 revisions are allowed to have multiple parents.
+    To support old clients this is written out in a slightly redundant
+    form: the first parent as the predecessor.  This will eventually
+    be dropped.
 
     parents
         List of parent revisions, each is a RevisionReference.
@@ -65,14 +78,38 @@
         self.__dict__.update(args)
         self.parents = []
 
+    def _get_precursor(self):
+        from warnings import warn
+        warn("Revision.precursor is deprecated", stacklevel=2)
+        if self.parents:
+            return self.parents[0].revision_id
+        else:
+            return None
+
+
+    def _get_precursor_sha1(self):
+        from warnings import warn
+        warn("Revision.precursor_sha1 is deprecated", stacklevel=2)
+        if self.parents:
+            return self.parents[0].revision_sha1
+        else:
+            return None    
+
+
+    def _fail(self):
+        raise Exception("can't assign to precursor anymore")
+
+
+    precursor = property(_get_precursor, _fail, _fail)
+    precursor_sha1 = property(_get_precursor_sha1, _fail, _fail)
+
+
 
     def __repr__(self):
         return "<Revision id %s>" % self.revision_id
 
         
     def to_element(self):
-        from bzrlib.xml import Element, SubElement
-        
         root = Element('revision',
                        committer = self.committer,
                        timestamp = '%.9f' % self.timestamp,
@@ -89,6 +126,15 @@
         msg.tail = '\n'
 
         if self.parents:
+            # first parent stored as precursor for compatability with 0.0.5 and
+            # earlier
+            pr = self.parents[0]
+            assert pr.revision_id
+            root.set('precursor', pr.revision_id)
+            if pr.revision_sha1:
+                root.set('precursor_sha1', pr.revision_sha1)
+                
+        if self.parents:
             pelts = SubElement(root, 'parents')
             pelts.tail = pelts.text = '\n'
             for rr in self.parents:
@@ -113,8 +159,6 @@
 def unpack_revision(elt):
     """Convert XML element into Revision object."""
     # <changeset> is deprecated...
-    from bzrlib.errors import BzrError
-    
     if elt.tag not in ('revision', 'changeset'):
         raise BzrError("unexpected tag in revision file: %r" % elt)
 
@@ -130,7 +174,12 @@
 
     pelts = elt.find('parents')
 
-    if pelts:
+    if precursor:
+        # revisions written prior to 0.0.5 have a single precursor
+        # give as an attribute
+        rev_ref = RevisionReference(precursor, precursor_sha1)
+        rev.parents.append(rev_ref)
+    elif pelts:
         for p in pelts:
             assert p.tag == 'revision_ref', \
                    "bad parent node tag %r" % p.tag
@@ -138,33 +187,8 @@
                                         p.get('revision_sha1'))
             rev.parents.append(rev_ref)
 
-        if precursor:
-            # must be consistent
-            prec_parent = rev.parents[0].revision_id
-            assert prec_parent == precursor
-    elif precursor:
-        # revisions written prior to 0.0.5 have a single precursor
-        # give as an attribute
-        rev_ref = RevisionReference(precursor, precursor_sha1)
-        rev.parents.append(rev_ref)
-
     v = elt.get('timezone')
     rev.timezone = v and int(v)
 
     rev.message = elt.findtext('message') # text of <message>
     return rev
-
-
-
-REVISION_ID_RE = None
-
-def validate_revision_id(rid):
-    """Check rid is syntactically valid for a revision id."""
-    global REVISION_ID_RE
-    if not REVISION_ID_RE:
-        import re
-        REVISION_ID_RE = re.compile('[\w.-]+@[\w.-]+--?\d+--?[0-9a-f]+\Z')
-
-    if not REVISION_ID_RE.match(rid):
-        raise ValueError("malformed revision-id %r" % rid)
-    

=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-07-27 16:42:41 +0000
+++ bzrlib/selftest/__init__.py	2005-06-22 06:37:20 +0000
@@ -15,77 +15,216 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from testsweet import TestBase, run_suite, InTempDir
-
-MODULES_TO_TEST = []
-MODULES_TO_DOCTEST = []
-
-def selftest(verbose=False):
+from unittest import TestResult, TestCase
+
+try:
+    import shutil
+    from subprocess import call, Popen, PIPE
+except ImportError, e:
+    sys.stderr.write("testbzr: sorry, this test suite requires the subprocess module\n"
+                     "this is shipped with python2.4 and available separately for 2.3\n")
+    raise
+
+
+class CommandFailed(Exception):
+    pass
+
+
+class TestBase(TestCase):
+    """Base class for bzr test cases.
+
+    Just defines some useful helper functions; doesn't actually test
+    anything.
+    """
+    
+    # TODO: Special methods to invoke bzr, so that we can run it
+    # through a specified Python intepreter
+
+    OVERRIDE_PYTHON = None # to run with alternative python 'python'
+    BZRPATH = 'bzr'
+    
+
+    def formcmd(self, cmd):
+        if isinstance(cmd, basestring):
+            cmd = cmd.split()
+
+        if cmd[0] == 'bzr':
+            cmd[0] = self.BZRPATH
+            if self.OVERRIDE_PYTHON:
+                cmd.insert(0, self.OVERRIDE_PYTHON)
+
+        self.log('$ %r' % cmd)
+
+        return cmd
+
+
+    def runcmd(self, cmd, retcode=0):
+        """Run one command and check the return code.
+
+        Returns a tuple of (stdout,stderr) strings.
+
+        If a single string is based, it is split into words.
+        For commands that are not simple space-separated words, please
+        pass a list instead."""
+        cmd = self.formcmd(cmd)
+
+        self.log('$ ' + ' '.join(cmd))
+        actual_retcode = call(cmd, stdout=self.TEST_LOG, stderr=self.TEST_LOG)
+
+        if retcode != actual_retcode:
+            raise CommandFailed("test failed: %r returned %d, expected %d"
+                                % (cmd, actual_retcode, retcode))
+
+
+    def backtick(self, cmd, retcode=0):
+        cmd = self.formcmd(cmd)
+        child = Popen(cmd, stdout=PIPE, stderr=self.TEST_LOG)
+        outd, errd = child.communicate()
+        self.log(outd)
+        actual_retcode = child.wait()
+
+        outd = outd.replace('\r', '')
+
+        if retcode != actual_retcode:
+            raise CommandFailed("test failed: %r returned %d, expected %d"
+                                % (cmd, actual_retcode, retcode))
+
+        return outd
+
+
+
+
+    def log(self, msg):
+        """Log a message to a progress file"""
+        print >>self.TEST_LOG, msg
+               
+
+class InTempDir(TestBase):
+    """Base class for tests run in a temporary branch."""
+    def setUp(self):
+        import os
+        self.test_dir = os.path.join(self.TEST_ROOT, self.__class__.__name__)
+        os.mkdir(self.test_dir)
+        os.chdir(self.test_dir)
+        
+    def tearDown(self):
+        import os
+        os.chdir(self.TEST_ROOT)
+
+
+
+
+
+class _MyResult(TestResult):
+    """
+    Custom TestResult.
+
+    No special behaviour for now.
+    """
+    def startTest(self, test):
+        print str(test).ljust(60),
+        TestResult.startTest(self, test)
+
+    def stopTest(self, test):
+        # print
+        TestResult.stopTest(self, test)
+
+
+    def addError(self, test, err):
+        print 'ERROR'
+        TestResult.addError(self, test, err)
+
+    def addFailure(self, test, err):
+        print 'FAILURE'
+        TestResult.addFailure(self, test, err)
+
+    def addSuccess(self, test):
+        print 'OK'
+        TestResult.addSuccess(self, test)
+
+
+
+def selftest():
     from unittest import TestLoader, TestSuite
-    import bzrlib, bzrlib.store, bzrlib.inventory, bzrlib.branch
-    import bzrlib.osutils, bzrlib.commands, bzrlib.merge3, bzrlib.plugin
-    global MODULES_TO_TEST, MODULES_TO_DOCTEST
-
+    import bzrlib
     import bzrlib.selftest.whitebox
     import bzrlib.selftest.blackbox
-    import bzrlib.selftest.versioning
-    import bzrlib.selftest.testmerge3
-    import bzrlib.selftest.testhashcache
-    import bzrlib.selftest.testrevisionnamespaces
-    import bzrlib.selftest.testbranch
-    import bzrlib.selftest.teststatus
-    import bzrlib.selftest.testinv
-    import bzrlib.selftest.testdiff
-    import bzrlib.merge_core
     from doctest import DocTestSuite
     import os
     import shutil
     import time
-    import sys
-    import unittest
-
-    for m in (bzrlib.store, bzrlib.inventory, bzrlib.branch,
-              bzrlib.osutils, bzrlib.commands, bzrlib.merge3):
-        if m not in MODULES_TO_DOCTEST:
-            MODULES_TO_DOCTEST.append(m)
-    
-    # ugly ugly!
-    for m in (bzrlib.selftest.whitebox,
-              bzrlib.selftest.versioning,
-              bzrlib.selftest.testinv,
-              bzrlib.selftest.testmerge3,
-              bzrlib.selftest.testhashcache,
-              bzrlib.selftest.teststatus,
-              bzrlib.selftest.blackbox,
-              bzrlib.selftest.testhashcache,
-              bzrlib.selftest.testrevisionnamespaces,
-              bzrlib.selftest.testbranch,
-              bzrlib.selftest.testdiff,
-              ):
-        if m not in MODULES_TO_TEST:
-            MODULES_TO_TEST.append(m)
-
-
-    TestBase.BZRPATH = os.path.join(os.path.realpath(os.path.dirname(bzrlib.__path__[0])), 'bzr')
-    print '%-30s %s' % ('bzr binary', TestBase.BZRPATH)
-
-    print
+
+    _setup_test_log()
+    _setup_test_dir()
 
     suite = TestSuite()
-
-    for m in MODULES_TO_TEST:
-         suite.addTest(TestLoader().loadTestsFromModule(m))
-
-    for m in (MODULES_TO_DOCTEST):
+    tl = TestLoader()
+
+    for m in bzrlib.selftest.whitebox, :
+        suite.addTest(tl.loadTestsFromModule(m))
+
+    suite.addTest(bzrlib.selftest.blackbox.suite())
+
+    for m in bzrlib.store, bzrlib.inventory, bzrlib.branch, bzrlib.osutils, \
+            bzrlib.commands:
         suite.addTest(DocTestSuite(m))
 
-    for p in bzrlib.plugin.all_plugins:
-        if hasattr(p, 'test_suite'):
-            suite.addTest(p.test_suite())
-
-    suite.addTest(unittest.makeSuite(bzrlib.merge_core.MergeTest, 'test_'))
-
-    return run_suite(suite, 'testbzr', verbose=verbose)
-
-
-
+    result = _MyResult()
+    suite.run(result)
+
+    _show_results(result)
+
+    return result.wasSuccessful()
+
+
+def _setup_test_log():
+    import time
+    import os
+    
+    log_filename = os.path.abspath('testbzr.log')
+    TestBase.TEST_LOG = open(log_filename, 'wt', buffering=1) # line buffered
+
+    print >>TestBase.TEST_LOG, "bzr tests run at " + time.ctime()
+    print '%-30s %s' % ('test log', log_filename)
+
+
+def _setup_test_dir():
+    import os
+    import shutil
+    
+    TestBase.ORIG_DIR = os.getcwdu()
+    TestBase.TEST_ROOT = os.path.abspath("testbzr.tmp")
+
+    print '%-30s %s' % ('running tests in', TestBase.TEST_ROOT)
+
+    if os.path.exists(TestBase.TEST_ROOT):
+        shutil.rmtree(TestBase.TEST_ROOT)
+    os.mkdir(TestBase.TEST_ROOT)
+    os.chdir(TestBase.TEST_ROOT)
+
+    # make a fake bzr directory there to prevent any tests propagating
+    # up onto the source directory's real branch
+    os.mkdir(os.path.join(TestBase.TEST_ROOT, '.bzr'))
+
+    
+
+def _show_results(result):
+     for case, tb in result.errors:
+         _show_test_failure('ERROR', case, tb)
+
+     for case, tb in result.failures:
+         _show_test_failure('FAILURE', case, tb)
+         
+     print
+     print '%4d tests run' % result.testsRun
+     print '%4d errors' % len(result.errors)
+     print '%4d failures' % len(result.failures)
+
+
+
+def _show_test_failure(kind, case, tb):
+     print (kind + '! ').ljust(60, '-')
+     print case
+     print tb
+     print ''.ljust(60, '-')
+    

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-07-15 13:43:54 +0000
+++ bzrlib/selftest/blackbox.py	2005-06-22 06:37:43 +0000
@@ -31,127 +31,62 @@
 from unittest import TestCase
 from bzrlib.selftest import TestBase, InTempDir
 
-
-
-class ExternalBase(InTempDir):
-    def runbzr(self, args, retcode=0):
-        try:
-            import shutil
-            from subprocess import call
-        except ImportError, e:
-            _need_subprocess()
-            raise
-
-        if isinstance(args, basestring):
-            args = args.split()
-            
-        return self.runcmd(['python', self.BZRPATH,] + args,
-                           retcode=retcode)
-
-
-
-class TestVersion(ExternalBase):
+class TestVersion(TestBase):
     def runTest(self):
         # output is intentionally passed through to stdout so that we
         # can see the version being tested
-        self.runbzr(['version'])
-
-
-
-class HelpCommands(ExternalBase):
+        self.runcmd(['bzr', 'version'])
+
+
+
+class HelpCommands(TestBase):
     def runTest(self):
-        self.runbzr('--help')
-        self.runbzr('help')
-        self.runbzr('help commands')
-        self.runbzr('help help')
-        self.runbzr('commit -h')
-
-
-class InitBranch(ExternalBase):
+        self.runcmd('bzr --help')
+        self.runcmd('bzr help')
+        self.runcmd('bzr help commands')
+        self.runcmd('bzr help help')
+        self.runcmd('bzr commit -h')
+
+
+class InitBranch(InTempDir):
     def runTest(self):
         import os
-        self.runbzr(['init'])
-
-
-
-class UserIdentity(ExternalBase):
+        self.runcmd(['bzr', 'init'])
+
+
+
+class UserIdentity(InTempDir):
     def runTest(self):
         # this should always identify something, if only "john@localhost"
-        self.runbzr("whoami")
-        self.runbzr("whoami --email")
+        self.runcmd("bzr whoami")
+        self.runcmd("bzr whoami --email")
         self.assertEquals(self.backtick("bzr whoami --email").count('@'),
                           1)
 
 
-class InvalidCommands(ExternalBase):
-    def runTest(self):
-        self.runbzr("pants", retcode=1)
-        self.runbzr("--pants off", retcode=1)
-        self.runbzr("diff --message foo", retcode=1)
-
-
-
-class EmptyCommit(ExternalBase):
-    def runTest(self):
-        self.runbzr("init")
-        self.build_tree(['hello.txt'])
-        self.runbzr("commit -m empty", retcode=1)
-        self.runbzr("add hello.txt")
-        self.runbzr("commit -m added")
-
-
-
-class IgnorePatterns(ExternalBase):
-    def runTest(self):
-        from bzrlib.branch import Branch
-        
-        b = Branch('.', init=True)
-        self.assertEquals(list(b.unknowns()), [])
-
-        file('foo.tmp', 'wt').write('tmp files are ignored')
-        self.assertEquals(list(b.unknowns()), [])
-        assert self.backtick('bzr unknowns') == ''
-
-        file('foo.c', 'wt').write('int main() {}')
-        self.assertEquals(list(b.unknowns()), ['foo.c'])
-        assert self.backtick('bzr unknowns') == 'foo.c\n'
-
-        self.runbzr(['add', 'foo.c'])
-        assert self.backtick('bzr unknowns') == ''
-
-        # 'ignore' works when creating the .bzignore file
-        file('foo.blah', 'wt').write('blah')
-        self.assertEquals(list(b.unknowns()), ['foo.blah'])
-        self.runbzr('ignore *.blah')
-        self.assertEquals(list(b.unknowns()), [])
-        assert file('.bzrignore', 'rb').read() == '*.blah\n'
-
-        # 'ignore' works when then .bzrignore file already exists
-        file('garh', 'wt').write('garh')
-        self.assertEquals(list(b.unknowns()), ['garh'])
-        assert self.backtick('bzr unknowns') == 'garh\n'
-        self.runbzr('ignore garh')
-        self.assertEquals(list(b.unknowns()), [])
-        assert file('.bzrignore', 'rb').read() == '*.blah\ngarh\n'
-        
-
-
-
-class OldTests(ExternalBase):
+class InvalidCommands(InTempDir):
+    def runTest(self):
+        self.runcmd("bzr pants", retcode=1)
+        self.runcmd("bzr --pants off", retcode=1)
+        self.runcmd("bzr diff --message foo", retcode=1)
+
+
+
+class OldTests(InTempDir):
     # old tests moved from ./testbzr
     def runTest(self):
         from os import chdir, mkdir
         from os.path import exists
         import os
 
-        runbzr = self.runbzr
+        runcmd = self.runcmd
         backtick = self.backtick
         progress = self.log
 
         progress("basic branch creation")
-        mkdir('branch1')
+        runcmd(['mkdir', 'branch1'])
         chdir('branch1')
-        runbzr('init')
+        runcmd('bzr init')
 
         self.assertEquals(backtick('bzr root').rstrip(),
                           os.path.join(self.test_dir, 'branch1'))
@@ -163,7 +98,7 @@
         f.close()
 
         out = backtick("bzr unknowns")
-        self.assertEquals(out, 'test.txt\n')
+        assert out == 'test.txt\n'
 
         out = backtick("bzr status")
         assert out == 'unknown:\n  test.txt\n'
@@ -198,43 +133,43 @@
                        "  test.txt\n")
 
         progress("command help")
-        runbzr("help st")
-        runbzr("help")
-        runbzr("help commands")
-        runbzr("help slartibartfast", 1)
+        runcmd("bzr help st")
+        runcmd("bzr help")
+        runcmd("bzr help commands")
+        runcmd("bzr help slartibartfast", 1)
 
         out = backtick("bzr help ci")
         out.index('aliases: ')
 
         progress("can't rename unversioned file")
-        runbzr("rename test.txt new-test.txt", 1)
+        runcmd("bzr rename test.txt new-test.txt", 1)
 
         progress("adding a file")
 
-        runbzr("add test.txt")
+        runcmd("bzr add test.txt")
         assert backtick("bzr unknowns") == ''
         assert backtick("bzr status --all") == ("added:\n"
                                                 "  test.txt\n")
 
         progress("rename newly-added file")
-        runbzr("rename test.txt hello.txt")
+        runcmd("bzr rename test.txt hello.txt")
         assert os.path.exists("hello.txt")
         assert not os.path.exists("test.txt")
 
         assert backtick("bzr revno") == '0\n'
 
         progress("add first revision")
-        runbzr(['commit', '-m', 'add first revision'])
+        runcmd(["bzr", "commit", "-m", 'add first revision'])
 
         progress("more complex renames")
         os.mkdir("sub1")
-        runbzr("rename hello.txt sub1", 1)
-        runbzr("rename hello.txt sub1/hello.txt", 1)
-        runbzr("move hello.txt sub1", 1)
+        runcmd("bzr rename hello.txt sub1", 1)
+        runcmd("bzr rename hello.txt sub1/hello.txt", 1)
+        runcmd("bzr move hello.txt sub1", 1)
 
-        runbzr("add sub1")
-        runbzr("rename sub1 sub2")
-        runbzr("move hello.txt sub2")
+        runcmd("bzr add sub1")
+        runcmd("bzr rename sub1 sub2")
+        runcmd("bzr move hello.txt sub2")
         assert backtick("bzr relpath sub2/hello.txt") == os.path.join("sub2", "hello.txt\n")
 
         assert exists("sub2")
@@ -242,31 +177,31 @@
         assert not exists("sub1")
         assert not exists("hello.txt")
 
-        runbzr(['commit', '-m', 'commit with some things moved to subdirs'])
+        runcmd(['bzr', 'commit', '-m', 'commit with some things moved to subdirs'])
 
         mkdir("sub1")
-        runbzr('add sub1')
-        runbzr('move sub2/hello.txt sub1')
+        runcmd('bzr add sub1')
+        runcmd('bzr move sub2/hello.txt sub1')
         assert not exists('sub2/hello.txt')
         assert exists('sub1/hello.txt')
-        runbzr('move sub2 sub1')
+        runcmd('bzr move sub2 sub1')
         assert not exists('sub2')
         assert exists('sub1/sub2')
 
-        runbzr(['commit', '-m', 'rename nested subdirectories'])
+        runcmd(['bzr', 'commit', '-m', 'rename nested subdirectories'])
 
         chdir('sub1/sub2')
         self.assertEquals(backtick('bzr root')[:-1],
                           os.path.join(self.test_dir, 'branch1'))
-        runbzr('move ../hello.txt .')
+        runcmd('bzr move ../hello.txt .')
         assert exists('./hello.txt')
         assert backtick('bzr relpath hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
         assert backtick('bzr relpath ../../sub1/sub2/hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
-        runbzr(['commit', '-m', 'move to parent directory'])
+        runcmd(['bzr', 'commit', '-m', 'move to parent directory'])
         chdir('..')
         assert backtick('bzr relpath sub2/hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
 
-        runbzr('move sub2/hello.txt .')
+        runcmd('bzr move sub2/hello.txt .')
         assert exists('hello.txt')
 
         f = file('hello.txt', 'wt')
@@ -277,35 +212,29 @@
         f.write('this is my new commit\n')
         f.close()
 
-        runbzr('commit -F msg.tmp')
+        runcmd('bzr commit -F msg.tmp')
 
         assert backtick('bzr revno') == '5\n'
-        runbzr('export -r 5 export-5.tmp')
-        runbzr('export export.tmp')
-
-        runbzr('log')
-        runbzr('log -v')
-        runbzr('log -v --forward')
-        runbzr('log -m', retcode=1)
-        log_out = backtick('bzr log -m commit')
-        assert "this is my new commit" in log_out
-        assert "rename nested" not in log_out
-        assert 'revision-id' not in log_out
-        assert 'revision-id' in backtick('bzr log --show-ids -m commit')
+        runcmd('bzr export -r 5 export-5.tmp')
+        runcmd('bzr export export.tmp')
+
+        runcmd('bzr log')
+        runcmd('bzr log -v')
+
 
 
         progress("file with spaces in name")
         mkdir('sub directory')
         file('sub directory/file with spaces ', 'wt').write('see how this works\n')
-        runbzr('add .')
-        runbzr('diff')
-        runbzr('commit -m add-spaces')
-        runbzr('check')
-
-        runbzr('log')
-        runbzr('log --forward')
-
-        runbzr('info')
+        runcmd('bzr add .')
+        runcmd('bzr diff')
+        runcmd('bzr commit -m add-spaces')
+        runcmd('bzr check')
+
+        runcmd('bzr log')
+        runcmd('bzr log --forward')
+
+        runcmd('bzr info')
 
 
 
@@ -315,35 +244,26 @@
         chdir('..')
         chdir('..')
         progress('branch')
-        assert os.path.exists('branch1')
-        assert not os.path.exists('branch2')
         # Can't create a branch if it already exists
-        runbzr('branch branch1', retcode=1)
+        runcmd('bzr branch branch1', retcode=1)
         # Can't create a branch if its parent doesn't exist
-        runbzr('branch /unlikely/to/exist', retcode=1)
-        runbzr('branch branch1 branch2')
-        assert exists('branch2')
-        assert exists('branch2/sub1')
-        assert exists('branch2/sub1/hello.txt')
-        
-        runbzr('branch --revision 0 branch1 branch3')
-        assert not exists('branch3/sub1/hello.txt')
-        runbzr('branch --revision 0..3 branch1 branch4', retcode=1)
+        runcmd('bzr branch /unlikely/to/exist', retcode=1)
+        runcmd('bzr branch branch1 branch2')
 
         progress("pull")
         chdir('branch1')
-        runbzr('pull', retcode=1)
-        runbzr('pull ../branch2')
+        runcmd('bzr pull', retcode=1)
+        runcmd('bzr pull ../branch2')
         chdir('.bzr')
-        runbzr('pull')
-        runbzr('commit --unchanged -m empty')
-        runbzr('pull')
+        runcmd('bzr pull')
+        runcmd('bzr commit -m empty')
+        runcmd('bzr pull')
         chdir('../../branch2')
-        runbzr('pull')
-        runbzr('commit --unchanged -m empty')
+        runcmd('bzr pull')
+        runcmd('bzr commit -m empty')
         chdir('../branch1')
-        runbzr('commit --unchanged -m empty')
-        runbzr('pull', retcode=1)
+        runcmd('bzr commit -m empty')
+        runcmd('bzr pull', retcode=1)
         chdir ('..')
 
         progress('status after remove')
@@ -359,50 +279,88 @@
         #     at /vrac/python/bazaar-ng/bzrlib/diff.py:286 in compare_trees()
         #     see ~/.bzr.log for debug information
         chdir('status-after-remove')
-        runbzr('init')
+        runcmd('bzr init')
         file('a', 'w').write('foo')
-        runbzr('add a')
-        runbzr(['commit', '-m', 'add a'])
-        runbzr('remove a')
-        runbzr('status')
-
-        chdir('..')
+        runcmd('bzr add a')
+        runcmd(['bzr', 'commit', '-m', 'add a'])
+        runcmd('bzr remove a')
+        runcmd('bzr status')
+
+        chdir('..')
+
+        progress('ignore patterns')
+        mkdir('ignorebranch')
+        chdir('ignorebranch')
+        runcmd('bzr init')
+        assert backtick('bzr unknowns') == ''
+
+        file('foo.tmp', 'wt').write('tmp files are ignored')
+        assert backtick('bzr unknowns') == ''
+
+        file('foo.c', 'wt').write('int main() {}')
+        assert backtick('bzr unknowns') == 'foo.c\n'
+        runcmd('bzr add foo.c')
+        assert backtick('bzr unknowns') == ''
+
+        # 'ignore' works when creating the .bzignore file
+        file('foo.blah', 'wt').write('blah')
+        assert backtick('bzr unknowns') == 'foo.blah\n'
+        runcmd('bzr ignore *.blah')
+        assert backtick('bzr unknowns') == ''
+        assert file('.bzrignore', 'rb').read() == '*.blah\n'
+
+        # 'ignore' works when then .bzrignore file already exists
+        file('garh', 'wt').write('garh')
+        assert backtick('bzr unknowns') == 'garh\n'
+        runcmd('bzr ignore garh')
+        assert backtick('bzr unknowns') == ''
+        assert file('.bzrignore', 'rb').read() == '*.blah\ngarh\n'
+
+        chdir('..')
+
 
 
 
         progress("recursive and non-recursive add")
         mkdir('no-recurse')
         chdir('no-recurse')
-        runbzr('init')
+        runcmd('bzr init')
         mkdir('foo')
         fp = os.path.join('foo', 'test.txt')
         f = file(fp, 'w')
         f.write('hello!\n')
         f.close()
-        runbzr('add --no-recurse foo')
-        runbzr('file-id foo')
-        runbzr('file-id ' + fp, 1)      # not versioned yet
-        runbzr('commit -m add-dir-only')
-
-        self.runbzr('file-id ' + fp, 1)      # still not versioned 
-
-        self.runbzr('add foo')
-        self.runbzr('file-id ' + fp)
-        self.runbzr('commit -m add-sub-file')
+        runcmd('bzr add --no-recurse foo')
+        runcmd('bzr file-id foo')
+        runcmd('bzr file-id ' + fp, 1)      # not versioned yet
+        runcmd('bzr commit -m add-dir-only')
+
+        runcmd('bzr file-id ' + fp, 1)      # still not versioned 
+
+        runcmd('bzr add foo')
+        runcmd('bzr file-id ' + fp)
+        runcmd('bzr commit -m add-sub-file')
 
         chdir('..')
 
 
 
-class RevertCommand(ExternalBase):
-    def runTest(self):
-        self.runbzr('init')
-
-        file('hello', 'wt').write('foo')
-        self.runbzr('add hello')
-        self.runbzr('commit -m setup hello')
+    
         
-        file('hello', 'wt').write('bar')
-        self.runbzr('revert hello')
-        self.check_file_contents('hello', 'foo')
-
+
+
+# lists all tests from this module in the best order to run them.  we
+# do it this way rather than just discovering them all because it
+# allows us to test more basic functions first where failures will be
+# easiest to understand.
+
+def suite():
+    from unittest import TestSuite
+    s = TestSuite()
+    s.addTests([TestVersion(),
+                InitBranch(),
+                HelpCommands(),
+                UserIdentity(),
+                InvalidCommands(),
+                OldTests()])
+    return s

=== removed file 'bzrlib/selftest/plugins.py'
--- bzrlib/selftest/plugins.py	2005-06-22 07:57:56 +0000
+++ bzrlib/selftest/plugins.py	1970-01-01 00:00:00 +0000
@@ -1,86 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Tests for plugins"""
-
-# NOT RUN YET
-
-
-
-
-
-
-
-from bzrlib.selftest import InTempDir
-
-
-def PluginTest(InTempDir):
-    """Create an external plugin and test loading."""
-    def runTest(self):
-        import os
-        
-        orig_help = self.backtick('bzr help commands') # No plugins yet
-        os.mkdir('plugin_test')
-        f = open(os.path.join('plugin_test', 'myplug.py'), 'wt')
-        f.write(PLUGIN_TEXT)
-        f.close()
-
-        newhelp = backtick('bzr help commands')
-        assert newhelp.startswith('You have been overridden\n')
-        # We added a line, but the rest should work
-        assert newhelp[25:] == help
-
-        assert backtick('bzr commit -m test') == "I'm sorry dave, you can't do that\n"
-
-        shutil.rmtree('plugin_test')
-
-
-
-
-PLUGIN_TEXT = \
-"""import bzrlib, bzrlib.commands
-class cmd_myplug(bzrlib.commands.Command):
-    '''Just a simple test plugin.'''
-    aliases = ['mplg']
-    def run(self):
-        print 'Hello from my plugin'
-""")
-    f.close()
-
-    os.environ['BZRPLUGINPATH'] = os.path.abspath('plugin_test')
-    help = backtick('bzr help commands')
-    assert help.find('myplug') != -1
-    assert help.find('Just a simple test plugin.') != -1
-
-
-    assert backtick('bzr myplug') == 'Hello from my plugin\n'
-    assert backtick('bzr mplg') == 'Hello from my plugin\n'
-
-    f = open(os.path.join('plugin_test', 'override.py'), 'wb')
-    f.write("""import bzrlib, bzrlib.commands
-class cmd_commit(bzrlib.commands.cmd_commit):
-    '''Commit changes into a new revision.'''
-    def run(self, *args, **kwargs):
-        print "I'm sorry dave, you can't do that"
-
-class cmd_help(bzrlib.commands.cmd_help):
-    '''Show help on a command or other topic.'''
-    def run(self, *args, **kwargs):
-        print "You have been overridden"
-        bzrlib.commands.cmd_help.run(self, *args, **kwargs)
-
-    """

=== removed file 'bzrlib/selftest/testbranch.py'
--- bzrlib/selftest/testbranch.py	2005-07-11 07:05:34 +0000
+++ bzrlib/selftest/testbranch.py	1970-01-01 00:00:00 +0000
@@ -1,35 +0,0 @@
-# (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.selftest import InTempDir
-
-
-
-class TestAppendRevisions(InTempDir):
-    """Test appending more than one revision"""
-    def runTest(self):
-        from bzrlib.branch import Branch
-        br = Branch(".", init=True)
-        br.append_revision("rev1")
-        self.assertEquals(br.revision_history(), ["rev1",])
-        br.append_revision("rev2", "rev3")
-        self.assertEquals(br.revision_history(), ["rev1", "rev2", "rev3"])
-        
-
-
-TEST_CLASSES = [
-    TestAppendRevisions,
-    ]

=== removed file 'bzrlib/selftest/testdiff.py'
--- bzrlib/selftest/testdiff.py	2005-07-27 16:44:44 +0000
+++ bzrlib/selftest/testdiff.py	1970-01-01 00:00:00 +0000
@@ -1,61 +0,0 @@
-from bzrlib.selftest import TestBase
-from bzrlib.diff import internal_diff
-from cStringIO import StringIO
-def udiff_lines(old, new):
-    output = StringIO()
-    internal_diff('old', old, 'new', new, output)
-    output.seek(0, 0)
-    return output.readlines()
-
-def check_patch(lines):
-    assert len(lines) > 1, \
-        "Not enough lines for a file header for patch:\n%s" % "".join(lines)
-    assert lines[0].startswith ('---'), \
-        'No orig line for patch:\n%s' % "".join(lines)
-    assert lines[1].startswith ('+++'), \
-        'No mod line for patch:\n%s' % "".join(lines)
-    assert len(lines) > 2, \
-        "No hunks for patch:\n%s" % "".join(lines)
-    assert lines[2].startswith('@@'),\
-        "No hunk header for patch:\n%s" % "".join(lines)
-    assert '@@' in lines[2][2:], \
-        "Unterminated hunk header for patch:\n%s" % "".join(lines)
-
-class AddNL(TestBase):
-    """
-    diff generates a valid diff for patches that add a newline
-    """
-    def runTest(self):
-        lines = udiff_lines(['boo'], ['boo\n'])
-        check_patch(lines)
-        assert lines[4] == '\\ No newline at end of file\n', \
-            "expected no-nl, got %r" % lines[4]
-
-
-class AddNL2(TestBase):
-    """
-    diff generates a valid diff for patches that change last line and add a
-    newline
-    """
-    def runTest(self):
-        lines = udiff_lines(['boo'], ['goo\n'])
-        check_patch(lines)
-        assert lines[4] == '\\ No newline at end of file\n', \
-            "expected no-nl, got %r" % lines[4]
-
-class RemoveNL(TestBase):
-    """
-    diff generates a valid diff for patches that change last line and add a
-    newline
-    """
-    def runTest(self):
-        lines = udiff_lines(['boo\n'], ['boo'])
-        check_patch(lines)
-        assert lines[5] == '\\ No newline at end of file\n', \
-            "expected no-nl, got %r" % lines[5]
-
-TEST_CLASSES = [
-    AddNL, 
-    AddNL2, 
-    RemoveNL,
-]

=== removed file 'bzrlib/selftest/testhashcache.py'
--- bzrlib/selftest/testhashcache.py	2005-07-08 06:54:58 +0000
+++ bzrlib/selftest/testhashcache.py	1970-01-01 00:00:00 +0000
@@ -1,119 +0,0 @@
-# (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.selftest import InTempDir
-
-
-
-def sha1(t):
-    import sha
-    return sha.new(t).hexdigest()
-
-
-def pause():
-    import time
-    # allow it to stabilize
-    start = int(time.time())
-    while int(time.time()) == start:
-        time.sleep(0.2)
-    
-
-
-class TestHashCache(InTempDir):
-    """Functional tests for hashcache"""
-    def runTest(self):
-        from bzrlib.hashcache import HashCache
-        import os
-        import time
-
-        # make a dummy bzr directory just to hold the cache
-        os.mkdir('.bzr')
-        hc = HashCache('.')
-
-        file('foo', 'wb').write('hello')
-        os.mkdir('subdir')
-        pause()
-
-        self.assertEquals(hc.get_sha1('foo'),
-                          'aaf4c61ddcc5e8a2dabede0f3b482cd9aea9434d')
-        self.assertEquals(hc.miss_count, 1)
-        self.assertEquals(hc.hit_count, 0)
-
-        # check we hit without re-reading
-        self.assertEquals(hc.get_sha1('foo'),
-                          'aaf4c61ddcc5e8a2dabede0f3b482cd9aea9434d')
-        self.assertEquals(hc.miss_count, 1)
-        self.assertEquals(hc.hit_count, 1)
-
-        # check again without re-reading
-        self.assertEquals(hc.get_sha1('foo'),
-                          'aaf4c61ddcc5e8a2dabede0f3b482cd9aea9434d')
-        self.assertEquals(hc.miss_count, 1)
-        self.assertEquals(hc.hit_count, 2)
-
-        # write new file and make sure it is seen
-        file('foo', 'wb').write('goodbye')
-        pause()
-        self.assertEquals(hc.get_sha1('foo'),
-                          '3c8ec4874488f6090a157b014ce3397ca8e06d4f')
-        self.assertEquals(hc.miss_count, 2)
-
-        # quickly write new file of same size and make sure it is seen
-        # this may rely on detection of timestamps that are too close
-        # together to be safe
-        file('foo', 'wb').write('g00dbye')
-        self.assertEquals(hc.get_sha1('foo'),
-                          sha1('g00dbye'))
-
-        file('foo2', 'wb').write('other file')
-        self.assertEquals(hc.get_sha1('foo2'), sha1('other file'))
-
-        os.remove('foo2')
-        self.assertEquals(hc.get_sha1('foo2'), None)
-
-        file('foo2', 'wb').write('new content')
-        self.assertEquals(hc.get_sha1('foo2'), sha1('new content'))
-
-        self.assertEquals(hc.get_sha1('subdir'), None)
-
-        # it's likely neither are cached at the moment because they 
-        # changed recently, but we can't be sure
-        pause()
-
-        # should now be safe to cache it if we reread them
-        self.assertEquals(hc.get_sha1('foo'), sha1('g00dbye'))
-        self.assertEquals(len(hc._cache), 1)
-        self.assertEquals(hc.get_sha1('foo2'), sha1('new content'))
-        self.assertEquals(len(hc._cache), 2)
-
-        # write out, read back in and check that we don't need to
-        # re-read any files
-        hc.write()
-        del hc
-
-        hc = HashCache('.')
-        hc.read()
-
-        self.assertEquals(len(hc._cache), 2)
-        self.assertEquals(hc.get_sha1('foo'), sha1('g00dbye'))
-        self.assertEquals(hc.hit_count, 1)
-        self.assertEquals(hc.miss_count, 0)
-        self.assertEquals(hc.get_sha1('foo2'), sha1('new content'))
-
-        
-
-        
-

=== removed file 'bzrlib/selftest/testinv.py'
--- bzrlib/selftest/testinv.py	2005-07-23 00:18:14 +0000
+++ bzrlib/selftest/testinv.py	1970-01-01 00:00:00 +0000
@@ -1,53 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.selftest import TestBase
-
-from bzrlib.inventory import Inventory, InventoryEntry
-
-
-class TestIsWithin(TestBase):
-    def runTest(self):
-        from bzrlib.osutils import is_inside_any
-        
-        for dirs, fn in [(['src', 'doc'], 'src/foo.c'),
-                         (['src'], 'src/foo.c'),
-                         (['src'], 'src'),
-                         ]:
-            self.assert_(is_inside_any(dirs, fn))
-            
-        for dirs, fn in [(['src'], 'srccontrol'),
-                         (['src'], 'srccontrol/foo')]:
-            self.assertFalse(is_inside_any(dirs, fn))
-            
-            
-            
-class TestInventoryIds(TestBase):
-    def runTest(self):
-        """Test detection of files within selected directories."""
-        inv = Inventory()
-        
-        for args in [('src', 'directory', 'src-id'), 
-                     ('doc', 'directory', 'doc-id'), 
-                     ('src/hello.c', 'file'),
-                     ('src/bye.c', 'file', 'bye-id'),
-                     ('Makefile', 'file')]:
-            inv.add_path(*args)
-            
-        self.assertEqual(inv.path2id('src'), 'src-id')
-        self.assertEqual(inv.path2id('src/bye.c'), 'bye-id')
-        
-        self.assert_('src-id' in inv)

=== removed file 'bzrlib/selftest/testmerge3.py'
--- bzrlib/selftest/testmerge3.py	2005-07-06 05:24:29 +0000
+++ bzrlib/selftest/testmerge3.py	1970-01-01 00:00:00 +0000
@@ -1,362 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-from bzrlib.selftest import InTempDir, TestBase
-from bzrlib.merge3 import Merge3
-
-
-
-
-
-class NoChanges(TestBase):
-    """No conflicts because nothing changed"""
-    def runTest(self):
-        m3 = Merge3(['aaa', 'bbb'],
-                    ['aaa', 'bbb'],
-                    ['aaa', 'bbb'])
-
-        self.assertEquals(m3.find_unconflicted(),
-                          [(0, 2)])
-
-        self.assertEquals(list(m3.find_sync_regions()),
-                          [(0, 2,
-                            0, 2,
-                            0, 2),
-                           (2,2, 2,2, 2,2)])
-
-        self.assertEquals(list(m3.merge_regions()),
-                          [('unchanged', 0, 2)])
-
-        self.assertEquals(list(m3.merge_groups()),
-                          [('unchanged', ['aaa', 'bbb'])])
-
-
-class FrontInsert(TestBase):
-    def runTest(self):
-        m3 = Merge3(['zz'],
-                    ['aaa', 'bbb', 'zz'],
-                    ['zz'])
-
-        # todo: should use a sentinal at end as from get_matching_blocks
-        # to match without zz
-        self.assertEquals(list(m3.find_sync_regions()),
-                          [(0,1, 2,3, 0,1),
-                           (1,1, 3,3, 1,1),])
-
-        self.assertEquals(list(m3.merge_regions()),
-                          [('a', 0, 2),
-                           ('unchanged', 0, 1)])
-
-        self.assertEquals(list(m3.merge_groups()),
-                          [('a', ['aaa', 'bbb']),
-                           ('unchanged', ['zz'])])
-        
-    
-
-class NullInsert(TestBase):
-    def runTest(self):
-        m3 = Merge3([],
-                    ['aaa', 'bbb'],
-                    [])
-
-        # todo: should use a sentinal at end as from get_matching_blocks
-        # to match without zz
-        self.assertEquals(list(m3.find_sync_regions()),
-                          [(0,0, 2,2, 0,0)])
-
-        self.assertEquals(list(m3.merge_regions()),
-                          [('a', 0, 2)])
-
-        self.assertEquals(list(m3.merge_lines()),
-                          ['aaa', 'bbb'])
-        
-    
-
-class NoConflicts(TestBase):
-    """No conflicts because only one side changed"""
-    def runTest(self):
-        m3 = Merge3(['aaa', 'bbb'],
-                    ['aaa', '111', 'bbb'],
-                    ['aaa', 'bbb'])
-
-        self.assertEquals(m3.find_unconflicted(),
-                          [(0, 1), (1, 2)])
-
-        self.assertEquals(list(m3.find_sync_regions()),
-                          [(0,1, 0,1, 0,1),
-                           (1,2, 2,3, 1,2),
-                           (2,2, 3,3, 2,2),])
-
-        self.assertEquals(list(m3.merge_regions()),
-                          [('unchanged', 0, 1),
-                           ('a', 1, 2),
-                           ('unchanged', 1, 2),])
-
-
-
-class AppendA(TestBase):
-    def runTest(self):
-        m3 = Merge3(['aaa\n', 'bbb\n'],
-                    ['aaa\n', 'bbb\n', '222\n'],
-                    ['aaa\n', 'bbb\n'])
-
-        self.assertEquals(''.join(m3.merge_lines()),
-                          'aaa\nbbb\n222\n')
-
-class AppendB(TestBase):
-    def runTest(self):
-        m3 = Merge3(['aaa\n', 'bbb\n'],
-                    ['aaa\n', 'bbb\n'],
-                    ['aaa\n', 'bbb\n', '222\n'])
-
-        self.assertEquals(''.join(m3.merge_lines()),
-                          'aaa\nbbb\n222\n')
-
-class AppendAgreement(TestBase):
-    def runTest(self):
-        m3 = Merge3(['aaa\n', 'bbb\n'],
-                    ['aaa\n', 'bbb\n', '222\n'],
-                    ['aaa\n', 'bbb\n', '222\n'])
-
-        self.assertEquals(''.join(m3.merge_lines()),
-                          'aaa\nbbb\n222\n')
-
-class AppendClash(TestBase):
-    def runTest(self):
-        m3 = Merge3(['aaa\n', 'bbb\n'],
-                    ['aaa\n', 'bbb\n', '222\n'],
-                    ['aaa\n', 'bbb\n', '333\n'])
-
-        ml = m3.merge_lines(name_a='a',
-                            name_b='b',
-                            start_marker='<<',
-                            mid_marker='--',
-                            end_marker='>>')
-        self.assertEquals(''.join(ml),
-'''\
-aaa
-bbb
-<< a
-222
---
-333
->> b
-''')
-
-
-class InsertAgreement(TestBase):
-    def runTest(self):
-        m3 = Merge3(['aaa\n', 'bbb\n'],
-                    ['aaa\n', '222\n', 'bbb\n'],
-                    ['aaa\n', '222\n', 'bbb\n'])
-
-        ml = m3.merge_lines(name_a='a',
-                            name_b='b',
-                            start_marker='<<',
-                            mid_marker='--',
-                            end_marker='>>')
-        self.assertEquals(''.join(m3.merge_lines()),
-                          'aaa\n222\nbbb\n')
-
-
-
-
-class InsertClash(TestBase):
-    """Both try to insert lines in the same place."""
-    def runTest(self):
-        m3 = Merge3(['aaa\n', 'bbb\n'],
-                    ['aaa\n', '111\n', 'bbb\n'],
-                    ['aaa\n', '222\n', 'bbb\n'])
-
-        self.assertEquals(m3.find_unconflicted(),
-                          [(0, 1), (1, 2)])
-
-        self.assertEquals(list(m3.find_sync_regions()),
-                          [(0,1, 0,1, 0,1),
-                           (1,2, 2,3, 2,3),
-                           (2,2, 3,3, 3,3),])
-
-        self.assertEquals(list(m3.merge_regions()),
-                          [('unchanged', 0,1),
-                           ('conflict', 1,1, 1,2, 1,2),
-                           ('unchanged', 1,2)])
-
-        self.assertEquals(list(m3.merge_groups()),
-                          [('unchanged', ['aaa\n']),
-                           ('conflict', [], ['111\n'], ['222\n']),
-                           ('unchanged', ['bbb\n']),
-                           ])
-
-        ml = m3.merge_lines(name_a='a',
-                            name_b='b',
-                            start_marker='<<',
-                            mid_marker='--',
-                            end_marker='>>')
-        self.assertEquals(''.join(ml),
-'''aaa
-<< a
-111
---
-222
->> b
-bbb
-''')
-
-
-
-class ReplaceClash(TestBase):
-    """Both try to insert lines in the same place."""
-    def runTest(self):
-        m3 = Merge3(['aaa', '000', 'bbb'],
-                    ['aaa', '111', 'bbb'],
-                    ['aaa', '222', 'bbb'])
-
-        self.assertEquals(m3.find_unconflicted(),
-                          [(0, 1), (2, 3)])
-
-        self.assertEquals(list(m3.find_sync_regions()),
-                          [(0,1, 0,1, 0,1),
-                           (2,3, 2,3, 2,3),
-                           (3,3, 3,3, 3,3),])
-
-
-
-class ReplaceMulti(TestBase):
-    """Replacement with regions of different size."""
-    def runTest(self):
-        m3 = Merge3(['aaa', '000', '000', 'bbb'],
-                    ['aaa', '111', '111', '111', 'bbb'],
-                    ['aaa', '222', '222', '222', '222', 'bbb'])
-
-        self.assertEquals(m3.find_unconflicted(),
-                          [(0, 1), (3, 4)])
-
-
-        self.assertEquals(list(m3.find_sync_regions()),
-                          [(0,1, 0,1, 0,1),
-                           (3,4, 4,5, 5,6),
-                           (4,4, 5,5, 6,6),])
-
-        
-        
-
-
-
-
-def split_lines(t):
-    from cStringIO import StringIO
-    return StringIO(t).readlines()
-
-
-
-############################################################
-# test case from the gnu diffutils manual
-
-# common base
-TZU = split_lines("""     The Nameless is the origin of Heaven and Earth;
-     The named is the mother of all things.
-     
-     Therefore let there always be non-being,
-       so we may see their subtlety,
-     And let there always be being,
-       so we may see their outcome.
-     The two are the same,
-     But after they are produced,
-       they have different names.
-     They both may be called deep and profound.
-     Deeper and more profound,
-     The door of all subtleties!
-""")
-
-LAO = split_lines("""     The Way that can be told of is not the eternal Way;
-     The name that can be named is not the eternal name.
-     The Nameless is the origin of Heaven and Earth;
-     The Named is the mother of all things.
-     Therefore let there always be non-being,
-       so we may see their subtlety,
-     And let there always be being,
-       so we may see their outcome.
-     The two are the same,
-     But after they are produced,
-       they have different names.
-""")
-
-
-TAO = split_lines("""     The Way that can be told of is not the eternal Way;
-     The name that can be named is not the eternal name.
-     The Nameless is the origin of Heaven and Earth;
-     The named is the mother of all things.
-     
-     Therefore let there always be non-being,
-       so we may see their subtlety,
-     And let there always be being,
-       so we may see their result.
-     The two are the same,
-     But after they are produced,
-       they have different names.
-     
-       -- The Way of Lao-Tzu, tr. Wing-tsit Chan
-
-""")
-
-MERGED_RESULT = split_lines("""     The Way that can be told of is not the eternal Way;
-     The name that can be named is not the eternal name.
-     The Nameless is the origin of Heaven and Earth;
-     The Named is the mother of all things.
-     Therefore let there always be non-being,
-       so we may see their subtlety,
-     And let there always be being,
-       so we may see their result.
-     The two are the same,
-     But after they are produced,
-       they have different names.
-<<<<<<<< LAO
-========
-     
-       -- The Way of Lao-Tzu, tr. Wing-tsit Chan
-
->>>>>>>> TAO
-""")
-
-
-
-class MergePoem(TestBase):
-    """Test case from diff3 manual"""
-    def runTest(self):
-        m3 = Merge3(TZU, LAO, TAO)
-        ml = list(m3.merge_lines('LAO', 'TAO'))
-        self.log('merge result:')
-        self.log(''.join(ml))
-        self.assertEquals(ml, MERGED_RESULT)
-
-
-
-TEST_CLASSES = [
-    NoChanges,
-    FrontInsert,
-    NullInsert,
-    NoConflicts,
-    AppendA,
-    AppendB,
-    AppendAgreement,
-    AppendClash,
-    InsertAgreement,
-    InsertClash,
-    ReplaceClash,
-    ReplaceMulti,
-    MergePoem,
-    ]

=== removed file 'bzrlib/selftest/testrevisionnamespaces.py'
--- bzrlib/selftest/testrevisionnamespaces.py	2005-07-11 06:13:18 +0000
+++ bzrlib/selftest/testrevisionnamespaces.py	1970-01-01 00:00:00 +0000
@@ -1,46 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-from bzrlib.selftest import InTempDir, TestBase
-
-class TestRevisionNamespaces(InTempDir):
-    """Functional tests for hashcache"""
-    def runTest(self):
-        from bzrlib.errors import BzrError
-        from bzrlib.branch import Branch
-        import os
-        import time
-
-        b = Branch('.', init=True)
-
-        b.commit('Commit one', rev_id='a@r-0-1')
-        b.commit('Commit two', rev_id='a@r-0-2')
-        b.commit('Commit three', rev_id='a@r-0-3')
-
-        self.assertEquals(b.get_revision_info(1), (1, 'a@r-0-1'))
-        self.assertEquals(b.get_revision_info('revno:1'), (1, 'a@r-0-1'))
-        self.assertEquals(b.get_revision_info('revid:a@r-0-1'), (1, 'a@r-0-1'))
-        self.assertRaises(BzrError, b.get_revision_info, 'revid:a@r-0-0')
-
-        self.assertEquals(b.get_revision_info('date:-tomorrow'), (3, 'a@r-0-3'))
-        self.assertEquals(b.get_revision_info('date:+today'), (1, 'a@r-0-1'))
-
-        self.assertEquals(b.get_revision_info('last:1'), (3, 'a@r-0-3'))
-
-TEST_CLASSES = [
-    TestRevisionNamespaces
-    ]

=== removed file 'bzrlib/selftest/teststatus.py'
--- bzrlib/selftest/teststatus.py	2005-07-12 01:44:23 +0000
+++ bzrlib/selftest/teststatus.py	1970-01-01 00:00:00 +0000
@@ -1,49 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Tests of status command.
-
-Most of these depend on the particular formatting used.
-"""
-
-
-from bzrlib.selftest import InTempDir
-
-class BranchStatus(InTempDir):
-    def runTest(self): 
-        """Basic 'bzr mkdir' operation"""
-        from cStringIO import StringIO
-        from bzrlib.status import show_status
-        from bzrlib.branch import Branch
-        
-        b = Branch('.', init=True)
-
-        # status with nothing
-        tof = StringIO()
-        show_status(b, to_file=tof)
-        self.assertEquals(tof.getvalue(), "")
-
-        tof = StringIO()
-        self.build_tree(['hello.c', 'bye.c'])
-        show_status(b, to_file=tof)
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['unknown:\n',
-                           '  bye.c\n',
-                           '  hello.c\n',
-                           ])
-

=== removed file 'bzrlib/selftest/versioning.py'
--- bzrlib/selftest/versioning.py	2005-07-23 14:06:37 +0000
+++ bzrlib/selftest/versioning.py	1970-01-01 00:00:00 +0000
@@ -1,92 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Tests of simple versioning operations"""
-
-
-from bzrlib.selftest import InTempDir
-
-class Mkdir(InTempDir):
-    def runTest(self): 
-        """Basic 'bzr mkdir' operation"""
-        from bzrlib.commands import run_bzr
-        import os
-
-        run_bzr(['init'])
-        run_bzr(['mkdir', 'foo'])
-        self.assert_(os.path.isdir('foo'))
-
-        self.assertRaises(OSError, run_bzr, ['mkdir', 'foo'])
-
-        from bzrlib.diff import compare_trees, TreeDelta
-        from bzrlib.branch import Branch
-        b = Branch('.')
-        
-        delta = compare_trees(b.basis_tree(), b.working_tree())
-
-        self.assertEquals(len(delta.added), 1)
-        self.assertEquals(delta.added[0][0], 'foo')
-        self.failIf(delta.modified)
-
-
-
-class AddInUnversioned(InTempDir):
-    def runTest(self):
-        """Try to add a file in an unversioned directory.
-
-        smart_add may eventually add the parent as necessary, but simple
-        branch add doesn't do that.
-        """
-        from bzrlib.branch import Branch
-        import os
-        from bzrlib.errors import NotVersionedError
-
-        b = Branch('.', init=True)
-
-        self.build_tree(['foo/',
-                         'foo/hello'])
-
-        self.assertRaises(NotVersionedError,
-                          b.add,
-                          'foo/hello')
-        
-        
-class SubdirCommit(InTempDir):
-    def runTest(self):
-        """Various commits from a subdirectory"""
-        
-        from bzrlib.branch import Branch
-        from bzrlib.commands import run_bzr
-        import os
-        
-        b = Branch('.', init=True)
-        self.build_tree(['src/', 'src/foo.c', 'README'])
-        
-        self.assertEqual(sorted(b.unknowns()),
-                         ['README', 'src'])
-        
-        self.assertEqual(run_bzr(['version']), 0)
-        
-        self.assertEqual(run_bzr(['add']), 0)
-        
-        
-
-
-TEST_CLASSES = [
-    Mkdir,
-    AddInUnversioned,
-    ]

=== modified file 'bzrlib/selftest/whitebox.py'
--- bzrlib/selftest/whitebox.py	2005-07-11 22:20:04 +0000
+++ bzrlib/selftest/whitebox.py	2005-06-21 06:10:18 +0000
@@ -1,200 +1,24 @@
 #! /usr/bin/python
 
-import os
-import unittest
-
-from bzrlib.selftest import InTempDir, TestBase
-from bzrlib.branch import ScratchBranch, Branch
-from bzrlib.errors import NotBranchError, NotVersionedError
-
-
-class Unknowns(InTempDir):
-    def runTest(self):
-        b = Branch('.', init=True)
-
-        self.build_tree(['hello.txt',
-                         'hello.txt~'])
-
-        self.assertEquals(list(b.unknowns()),
-                          ['hello.txt'])
-
-
-
-class NoChanges(InTempDir):
-    def runTest(self):
-        from bzrlib.errors import PointlessCommit
-        
-        b = Branch('.', init=True)
-
-        self.build_tree(['hello.txt'])
-
-        self.assertRaises(PointlessCommit,
-                          b.commit,
-                          'commit without adding',
-                          allow_pointless=False)
-
-        b.commit('commit pointless tree',
-                 allow_pointless=True)
-
-        b.add('hello.txt')
-        
-        b.commit('commit first added file',
-                 allow_pointless=False)
-        
-        self.assertRaises(PointlessCommit,
-                          b.commit,
-                          'commit after adding file',
-                          allow_pointless=False)
-        
-        b.commit('commit pointless revision with one file',
-                 allow_pointless=True)
-
-        b.add_pending_merge('mbp@892739123-2005-123123')
-        b.commit('commit new merge with no text changes',
-                 allow_pointless=False)
-        
-
-
-class ValidateRevisionId(TestBase):
-    def runTest(self):
-        from bzrlib.revision import validate_revision_id
-        validate_revision_id('mbp@sourcefrog.net-20050311061123-96a255005c7c9dbe')
-        
-        self.assertRaises(ValueError,
-                          validate_revision_id,
-                          ' asdkjas')
-
-
-        self.assertRaises(ValueError,
-                          validate_revision_id,
-                          'mbp@sourcefrog.net-20050311061123-96a255005c7c9dbe\n')
-
-
-        self.assertRaises(ValueError,
-                          validate_revision_id,
-                          ' mbp@sourcefrog.net-20050311061123-96a255005c7c9dbe')
-
-        self.assertRaises(ValueError,
-                          validate_revision_id,
-                          'Martin Pool <mbp@sourcefrog.net>-20050311061123-96a255005c7c9dbe')
-
-
-
-class PendingMerges(InTempDir):
-    """Tracking pending-merged revisions."""
-    def runTest(self):
-        b = Branch('.', init=True)
-
-        self.assertEquals(b.pending_merges(), [])
-        
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-    
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-
-        b.add_pending_merge('wibble@fofof--20050401--1928390812')
-        self.assertEquals(b.pending_merges(),
-                          ['foo@azkhazan-123123-abcabc',
-                           'wibble@fofof--20050401--1928390812'])
-
-        b.commit("commit from base with two merges")
-
-        rev = b.get_revision(b.revision_history()[0])
-        self.assertEquals(len(rev.parents), 2)
-        self.assertEquals(rev.parents[0].revision_id,
-                          'foo@azkhazan-123123-abcabc')
-        self.assertEquals(rev.parents[1].revision_id,
-                           'wibble@fofof--20050401--1928390812')
-
-        # list should be cleared when we do a commit
-        self.assertEquals(b.pending_merges(), [])
-        
-        
-        
-
-class Revert(InTempDir):
-    """Test selected-file revert"""
-    def runTest(self):
-        b = Branch('.', init=True)
-
-        self.build_tree(['hello.txt'])
-        file('hello.txt', 'w').write('initial hello')
-
-        self.assertRaises(NotVersionedError,
-                          b.revert, ['hello.txt'])
-        
-        b.add(['hello.txt'])
-        b.commit('create initial hello.txt')
-
-        self.check_file_contents('hello.txt', 'initial hello')
-        file('hello.txt', 'w').write('new hello')
-        self.check_file_contents('hello.txt', 'new hello')
-
-        # revert file modified since last revision
-        b.revert(['hello.txt'])
-        self.check_file_contents('hello.txt', 'initial hello')
-        self.check_file_contents('hello.txt~', 'new hello')
-
-        # reverting again clobbers the backup
-        b.revert(['hello.txt'])
-        self.check_file_contents('hello.txt', 'initial hello')
-        self.check_file_contents('hello.txt~', 'initial hello')
-
-
-
-class RenameDirs(InTempDir):
-    """Test renaming directories and the files within them."""
-    def runTest(self):
-        b = Branch('.', init=True)
-        self.build_tree(['dir/', 'dir/sub/', 'dir/sub/file'])
-        b.add(['dir', 'dir/sub', 'dir/sub/file'])
-
-        b.commit('create initial state')
-
-        # TODO: lift out to a test helper that checks the shape of
-        # an inventory
-        
-        revid = b.revision_history()[0]
-        self.log('first revision_id is {%s}' % revid)
-        
-        inv = b.get_revision_inventory(revid)
-        self.log('contents of inventory: %r' % inv.entries())
-
-        self.check_inventory_shape(inv,
-                                   ['dir', 'dir/sub', 'dir/sub/file'])
-
-        b.rename_one('dir', 'newdir')
-
-        self.check_inventory_shape(b.inventory,
-                                   ['newdir', 'newdir/sub', 'newdir/sub/file'])
-
-        b.rename_one('newdir/sub', 'newdir/newsub')
-        self.check_inventory_shape(b.inventory,
-                                   ['newdir', 'newdir/newsub',
-                                    'newdir/newsub/file'])
-
-        
-
-
-class BranchPathTestCase(TestBase):
+from bzrlib.branch import ScratchBranch
+from bzrlib.errors import NotBranchError
+from unittest import TestCase
+import os, unittest
+
+class BranchPathTestCase(TestCase):
     """test for branch path lookups
 
     Branch.relpath and bzrlib.branch._relpath do a simple but subtle
     job: given a path (either relative to cwd or absolute), work out
     if it is inside a branch and return the path relative to the base.
     """
-
+    
     def runTest(self):
         from bzrlib.branch import _relpath
         import tempfile, shutil
         
         savedir = os.getcwdu()
         dtmp = tempfile.mkdtemp()
-        # On Mac OSX, /tmp actually expands to /private/tmp
-        dtmp = os.path.realpath(dtmp)
 
         def rp(p):
             return _relpath(dtmp, p)
@@ -239,13 +63,7 @@
             os.chdir(savedir)
             shutil.rmtree(dtmp)
 
-
-
-
-TEST_CLASSES = [Unknowns,
-                ValidateRevisionId,
-                PendingMerges,
-                Revert,
-                RenameDirs,
-                BranchPathTestCase,
-                ]
+                              
+if __name__ == '__main__':
+    unittest.main()
+    

=== added file 'bzrlib/statcache.py'
--- bzrlib/statcache.py	1970-01-01 00:00:00 +0000
+++ bzrlib/statcache.py	2005-06-07 09:07:40 +0000
@@ -0,0 +1,292 @@
+# (C) 2005 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import stat, os, sha, time
+
+from trace import mutter
+from errors import BzrError, BzrCheckError
+
+
+"""File stat cache to speed up tree comparisons.
+
+This module basically gives a quick way to find the SHA-1 and related
+information of a file in the working directory, without actually
+reading and hashing the whole file.
+
+
+
+Implementation
+==============
+
+Users of this module should not need to know about how this is
+implemented, and in particular should not depend on the particular
+data which is stored or its format.
+
+This is done by maintaining a cache indexed by a file fingerprint of
+(path, size, mtime, ctime, ino, dev) pointing to the SHA-1.  If the
+fingerprint has changed, we assume the file content has not changed
+either and the SHA-1 is therefore the same.
+
+If any of the fingerprint fields have changed then the file content
+*may* have changed, or it may not have.  We need to reread the file
+contents to make sure, but this is not visible to the user or
+higher-level code (except as a delay of course).
+
+The mtime and ctime are stored with nanosecond fields, but not all
+filesystems give this level of precision.  There is therefore a
+possible race: the file might be modified twice within a second
+without changing the size or mtime, and a SHA-1 cached from the first
+version would be wrong.  We handle this by not recording a cached hash
+for any files which were modified in the current second and that
+therefore have the chance to change again before the second is up.
+
+The only known hole in this design is if the system clock jumps
+backwards crossing invocations of bzr.  Please don't do that; use ntp
+to gradually adjust your clock or don't use bzr over the step.
+
+At the moment this is stored in a simple textfile; it might be nice
+to use a tdb instead to allow faster lookup by file-id.
+
+The cache is represented as a map from file_id to a tuple of (file_id,
+sha1, path, size, mtime, ctime, ino, dev).
+
+The SHA-1 is stored in memory as a hexdigest.
+
+This version of the file on disk has one line per record, and fields
+separated by \0 records.
+"""
+
+# order of fields returned by fingerprint()
+FP_SIZE  = 0
+FP_MTIME = 1
+FP_CTIME = 2
+FP_INO   = 3
+FP_DEV   = 4
+
+# order of fields in the statcache file and in the in-memory map
+SC_FILE_ID = 0
+SC_SHA1    = 1
+SC_PATH    = 2
+SC_SIZE    = 3
+SC_MTIME   = 4
+SC_CTIME   = 5
+SC_INO     = 6
+SC_DEV     = 7
+
+
+
+CACHE_HEADER = "### bzr statcache v4"
+
+
+def fingerprint(abspath):
+    try:
+        fs = os.lstat(abspath)
+    except OSError:
+        # might be missing, etc
+        return None
+
+    if stat.S_ISDIR(fs.st_mode):
+        return None
+
+    return (fs.st_size, fs.st_mtime,
+            fs.st_ctime, fs.st_ino, fs.st_dev)
+
+
+
+def _write_cache(basedir, entries):
+    from atomicfile import AtomicFile
+
+    cachefn = os.path.join(basedir, '.bzr', 'stat-cache')
+    outf = AtomicFile(cachefn, 'wb')
+    try:
+        outf.write(CACHE_HEADER + '\n')
+    
+        for entry in entries:
+            if len(entry) != 8:
+                raise ValueError("invalid statcache entry tuple %r" % entry)
+            outf.write(entry[0].encode('utf-8')) # file id
+            outf.write('\0')
+            outf.write(entry[1])             # hex sha1
+            outf.write('\0')
+            outf.write(entry[2].encode('utf-8')) # name
+            for nf in entry[3:]:
+                outf.write('\0%d' % nf)
+            outf.write('\n')
+
+        outf.commit()
+    finally:
+        if not outf.closed:
+            outf.abort()
+
+
+def _try_write_cache(basedir, entries):
+    try:
+        return _write_cache(basedir, entries)
+    except IOError, e:
+        mutter("cannot update statcache in %s: %s" % (basedir, e))
+    except OSError, e:
+        mutter("cannot update statcache in %s: %s" % (basedir, e))
+        
+        
+        
+def load_cache(basedir):
+    import re
+    cache = {}
+    seen_paths = {}
+    from bzrlib.trace import warning
+
+    assert isinstance(basedir, basestring)
+
+    sha_re = re.compile(r'[a-f0-9]{40}')
+
+    try:
+        cachefn = os.path.join(basedir, '.bzr', 'stat-cache')
+        cachefile = open(cachefn, 'rb')
+    except IOError:
+        return cache
+
+    line1 = cachefile.readline().rstrip('\r\n')
+    if line1 != CACHE_HEADER:
+        mutter('cache header marker not found at top of %s; discarding cache'
+               % cachefn)
+        return cache
+
+    for l in cachefile:
+        f = l.split('\0')
+
+        file_id = f[0].decode('utf-8')
+        if file_id in cache:
+            warning("duplicated file_id in cache: {%s}" % file_id)
+
+        text_sha = f[1]
+        if len(text_sha) != 40 or not sha_re.match(text_sha):
+            raise BzrCheckError("invalid file SHA-1 in cache: %r" % text_sha)
+        
+        path = f[2].decode('utf-8')
+        if path in seen_paths:
+            warning("duplicated path in cache: %r" % path)
+        seen_paths[path] = True
+        
+        entry = (file_id, text_sha, path) + tuple([long(x) for x in f[3:]])
+        if len(entry) != 8:
+            raise ValueError("invalid statcache entry tuple %r" % entry)
+
+        cache[file_id] = entry
+    return cache
+
+
+
+def _files_from_inventory(inv):
+    for path, ie in inv.iter_entries():
+        if ie.kind != 'file':
+            continue
+        yield ie.file_id, path
+    
+
+
+def update_cache(basedir, inv, flush=False):
+    """Update and return the cache for the branch.
+
+    The returned cache may contain entries that have not been written
+    to disk for files recently touched.
+
+    flush -- discard any previous cache and recalculate from scratch.
+    """
+
+    # load the existing cache; use information there to find a list of
+    # files ordered by inode, which is alleged to be the fastest order
+    # to stat the files.
+    
+    to_update = _files_from_inventory(inv)
+
+    assert isinstance(flush, bool)
+    if flush:
+        cache = {}
+    else:
+        cache = load_cache(basedir)
+
+        by_inode = []
+        without_inode = []
+        for file_id, path in to_update:
+            if file_id in cache:
+                by_inode.append((cache[file_id][SC_INO], file_id, path))
+            else:
+                without_inode.append((file_id, path))
+        by_inode.sort()
+
+        to_update = [a[1:] for a in by_inode] + without_inode
+            
+    stat_cnt = missing_cnt = new_cnt = hardcheck = change_cnt = 0
+
+    # dangerfiles have been recently touched and can't be committed to
+    # a persistent cache yet, but they are returned to the caller.
+    dangerfiles = []
+    
+    now = int(time.time())
+
+    ## mutter('update statcache under %r' % basedir)
+    for file_id, path in to_update:
+        abspath = os.path.join(basedir, path)
+        fp = fingerprint(abspath)
+        stat_cnt += 1
+        
+        cacheentry = cache.get(file_id)
+
+        if fp == None: # not here
+            if cacheentry:
+                del cache[file_id]
+                change_cnt += 1
+            missing_cnt += 1
+            continue
+        elif not cacheentry:
+            new_cnt += 1
+
+        if (fp[FP_MTIME] >= now) or (fp[FP_CTIME] >= now):
+            dangerfiles.append(file_id)
+
+        if cacheentry and (cacheentry[3:] == fp):
+            continue                    # all stat fields unchanged
+
+        hardcheck += 1
+
+        dig = sha.new(file(abspath, 'rb').read()).hexdigest()
+
+        # We update the cache even if the digest has not changed from
+        # last time we looked, so that the fingerprint fields will
+        # match in future.
+        cacheentry = (file_id, dig, path) + fp
+        cache[file_id] = cacheentry
+        change_cnt += 1
+
+    mutter('statcache: statted %d files, read %d files, %d changed, %d dangerous, '
+           '%d deleted, %d new, '
+           '%d in cache'
+           % (stat_cnt, hardcheck, change_cnt, len(dangerfiles),
+              missing_cnt, new_cnt, len(cache)))
+        
+    if change_cnt:
+        mutter('updating on-disk statcache')
+
+        if dangerfiles:
+            safe_cache = cache.copy()
+            for file_id in dangerfiles:
+                del safe_cache[file_id]
+        else:
+            safe_cache = cache
+        
+        _try_write_cache(basedir, safe_cache.itervalues())
+
+    return cache

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2005-07-12 01:44:23 +0000
+++ bzrlib/status.py	2005-05-31 08:10:44 +0000
@@ -18,8 +18,7 @@
 
 def show_status(branch, show_unchanged=False,
                 specific_files=None,
-                show_ids=False,
-                to_file=None):
+                show_ids=False):
     """Display single-line status for non-ignored working files.
 
     show_all
@@ -27,15 +26,9 @@
 
     specific_files
         If set, only show the status of files in this list.
-
-    to_file
-        If set, write to this file (default stdout.)
     """
     import sys
     from bzrlib.diff import compare_trees
-
-    if to_file == None:
-        to_file = sys.stdout
     
     branch.lock_read()
     try:
@@ -46,8 +39,7 @@
         delta = compare_trees(old, new, want_unchanged=show_unchanged,
                               specific_files=specific_files)
 
-        delta.show(to_file,
-                   show_ids=show_ids,
+        delta.show(sys.stdout, show_ids=show_ids,
                    show_unchanged=show_unchanged)
 
         unknowns = new.unknowns()
@@ -59,9 +51,9 @@
                 if path not in specific_files:
                     continue
             if not done_header:
-                print >>to_file, 'unknown:'
+                print 'unknown:'
                 done_header = True
-            print >>to_file, ' ', path
+            print ' ', path
     finally:
         branch.unlock()
         

=== modified file 'bzrlib/store.py'
--- bzrlib/store.py	2005-07-11 07:33:45 +0000
+++ bzrlib/store.py	2005-06-20 04:33:23 +0000
@@ -90,7 +90,6 @@
             
         p = self._path(fileid)
         if os.access(p, os.F_OK) or os.access(p + '.gz', os.F_OK):
-            from bzrlib.errors import bailout
             raise BzrError("store %r already contains id %r" % (self._basedir, fileid))
 
         fn = p
@@ -120,8 +119,6 @@
         pb = ProgressBar()
         pb.update('preparing to copy')
         to_copy = [id for id in ids if id not in self]
-        if isinstance(other, ImmutableStore):
-            return self.copy_multi_immutable(other, to_copy, pb)
         count = 0
         for id in to_copy:
             count += 1
@@ -130,27 +127,6 @@
         assert count == len(to_copy)
         pb.clear()
         return count
-
-
-    def copy_multi_immutable(self, other, to_copy, pb):
-        from shutil import copyfile
-        count = 0
-        for id in to_copy:
-            p = self._path(id)
-            other_p = other._path(id)
-            try:
-                copyfile(other_p, p)
-            except IOError, e:
-                if e.errno == errno.ENOENT:
-                    copyfile(other_p+".gz", p+".gz")
-                else:
-                    raise
-            
-            count += 1
-            pb.update('copy', count, len(to_copy))
-        assert count == len(to_copy)
-        pb.clear()
-        return count
     
 
     def __contains__(self, fileid):

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2005-07-20 17:31:25 +0000
+++ bzrlib/trace.py	2005-05-09 03:03:55 +0000
@@ -13,13 +13,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-
-# TODO: Could probably replace this with something based on Python logging
-# module.
-
-
-
-
 __copyright__ = "Copyright (C) 2005 Canonical Ltd."
 __author__ = "Martin Pool <mbp@canonical.com>"
 
@@ -52,9 +45,8 @@
 
 
 def _write_trace(msg):
-    if 0:
-        if _tracefile:
-            _tracefile.write(_logprefix + msg + '\n')
+    if _tracefile:
+        _tracefile.write(_logprefix + msg + '\n')
 
 
 def warning(msg):

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2005-07-11 07:33:45 +0000
+++ bzrlib/tree.py	2005-06-17 07:28:53 +0000
@@ -17,11 +17,18 @@
 """Tree classes, representing directory at point in time.
 """
 
-from osutils import pumpfile, appendpath, fingerprint_file
-import os
-
+from sets import Set
+import os.path, os, fnmatch, time
+
+from osutils import pumpfile, filesize, quotefn, sha_file, \
+     joinpath, splitpath, appendpath, isdir, isfile, file_kind, fingerprint_file
+import errno
+from stat import S_ISREG, S_ISDIR, ST_MODE, ST_SIZE
+
+from bzrlib.inventory import Inventory
 from bzrlib.trace import mutter, note
 from bzrlib.errors import BzrError
+import branch
 
 import bzrlib
 
@@ -94,14 +101,13 @@
         pumpfile(self.get_file(fileid), sys.stdout)
         
         
-    def export(self, dest, format='dir', root=None):
+    def export(self, dest, format='dir'):
         """Export this tree."""
         try:
             exporter = exporters[format]
         except KeyError:
-            from bzrlib.errors import BzrCommandError
             raise BzrCommandError("export format %r not supported" % format)
-        exporter(self, dest, root)
+        exporter(self, dest)
 
 
 
@@ -143,9 +149,8 @@
 
 
 class EmptyTree(Tree):
-    def __init__(self, root_id):
-        from bzrlib.inventory import Inventory
-        self._inventory = Inventory(root_id)
+    def __init__(self):
+        self._inventory = Inventory()
 
     def has_filename(self, filename):
         return False
@@ -225,7 +230,7 @@
 ######################################################################
 # export
 
-def dir_exporter(tree, dest, root):
+def dir_exporter(tree, dest):
     """Export this tree to a new directory.
 
     `dest` should not exist, and will be created holding the
@@ -237,7 +242,6 @@
     :note: If the export fails, the destination directory will be
            left in a half-assed state.
     """
-    import os
     os.mkdir(dest)
     mutter('export version %r' % tree)
     inv = tree.inventory
@@ -258,39 +262,14 @@
 except ImportError:
     pass
 else:
-    def get_root_name(dest):
-        """Get just the root name for a tarball.
-
-        >>> get_root_name('mytar.tar')
-        'mytar'
-        >>> get_root_name('mytar.tar.bz2')
-        'mytar'
-        >>> get_root_name('tar.tar.tar.tgz')
-        'tar.tar.tar'
-        >>> get_root_name('bzr-0.0.5.tar.gz')
-        'bzr-0.0.5'
-        >>> get_root_name('a/long/path/mytar.tgz')
-        'mytar'
-        >>> get_root_name('../parent/../dir/other.tbz2')
-        'other'
-        """
-        endings = ['.tar', '.tar.gz', '.tgz', '.tar.bz2', '.tbz2']
-        dest = os.path.basename(dest)
-        for end in endings:
-            if dest.endswith(end):
-                return dest[:-len(end)]
-
-    def tar_exporter(tree, dest, root, compression=None):
+    def tar_exporter(tree, dest, compression=None):
         """Export this tree to a new tar file.
 
         `dest` will be created holding the contents of this tree; if it
         already exists, it will be clobbered, like with "tar -c".
         """
-        from time import time
-        now = time()
+        now = time.time()
         compression = str(compression or '')
-        if root is None:
-            root = get_root_name(dest)
         try:
             ball = tarfile.open(dest, 'w:' + compression)
         except tarfile.CompressionError, e:
@@ -299,7 +278,7 @@
         inv = tree.inventory
         for dp, ie in inv.iter_entries():
             mutter("  export {%s} kind %s to %s" % (ie.file_id, ie.kind, dest))
-            item = tarfile.TarInfo(os.path.join(root, dp))
+            item = tarfile.TarInfo(dp)
             # TODO: would be cool to actually set it to the timestamp of the
             # revision it was last changed
             item.mtime = now
@@ -322,12 +301,12 @@
         ball.close()
     exporters['tar'] = tar_exporter
 
-    def tgz_exporter(tree, dest, root):
-        tar_exporter(tree, dest, root, compression='gz')
+    def tgz_exporter(tree, dest):
+        tar_exporter(tree, dest, compression='gz')
     exporters['tgz'] = tgz_exporter
 
-    def tbz_exporter(tree, dest, root):
-        tar_exporter(tree, dest, root, compression='bz2')
+    def tbz_exporter(tree, dest):
+        tar_exporter(tree, dest, compression='bz2')
     exporters['tbz2'] = tbz_exporter
 
 

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2005-06-28 05:33:40 +0000
+++ bzrlib/upgrade.py	2005-06-20 03:45:02 +0000
@@ -92,10 +92,8 @@
                 # there should be *some* way of making old entries have
                 # the full meta information.
                 import tempfile, os, errno
-                from bzrlib.xml import pack_xml
-                
                 rev_tmp = tempfile.TemporaryFile()
-                pack_xml(rev, rev_tmp)
+                rev.write_xml(rev_tmp)
                 rev_tmp.seek(0)
 
                 tmpfd, tmp_path = tempfile.mkstemp(prefix=rev_id, suffix='.gz',

=== removed file 'bzrlib/weave.py'
--- bzrlib/weave.py	2005-07-18 18:53:46 +0000
+++ bzrlib/weave.py	1970-01-01 00:00:00 +0000
@@ -1,870 +0,0 @@
-#! /usr/bin/python
-
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-# Author: Martin Pool <mbp@canonical.com>
-
-
-"""Weave - storage of related text file versions"""
-
-# before intset (r923) 2000 versions in 41.5s
-# with intset (r926) 2000 versions in 93s !!!
-# better to just use plain sets.
-
-# making _extract build and return a list, rather than being a generator
-# takes 37.94s
-
-# with python -O, r923 does 2000 versions in 36.87s
-
-# with optimizations to avoid mutating lists - 35.75!  I guess copying
-# all the elements every time costs more than the small manipulations.
-# a surprisingly small change.
-
-# r931, which avoids using a generator for extract, does 36.98s
-
-# with memoized inclusions, takes 41.49s; not very good
-
-# with slots, takes 37.35s; without takes 39.16, a bit surprising
-
-# with the delta calculation mixed in with the add method, rather than
-# separated, takes 36.78s
-
-# with delta folded in and mutation of the list, 36.13s
-
-# with all this and simplification of add code, 33s 
-
-
-# TODO: Perhaps have copy method for Weave instances?
-
-# XXX: If we do weaves this way, will a merge still behave the same
-# way if it's done in a different order?  That's a pretty desirable
-# property.
-
-# TODO: Nothing here so far assumes the lines are really \n newlines,
-# rather than being split up in some other way.  We could accomodate
-# binaries, perhaps by naively splitting on \n or perhaps using
-# something like a rolling checksum.
-
-# TODO: Track version names as well as indexes. 
-
-# TODO: End marker for each version so we can stop reading?
-
-# TODO: Check that no insertion occurs inside a deletion that was
-# active in the version of the insertion.
-
-# TODO: In addition to the SHA-1 check, perhaps have some code that
-# checks structural constraints of the weave: ie that insertions are
-# properly nested, that there is no text outside of an insertion, that
-# insertions or deletions are not repeated, etc.
-
-# TODO: Parallel-extract that passes back each line along with a
-# description of which revisions include it.  Nice for checking all
-# shas in parallel.
-
-
-
-
-class WeaveError(Exception):
-    """Exception in processing weave"""
-
-
-class WeaveFormatError(WeaveError):
-    """Weave invariant violated"""
-    
-
-class Weave(object):
-    """weave - versioned text file storage.
-    
-    A Weave manages versions of line-based text files, keeping track
-    of the originating version for each line.
-
-    To clients the "lines" of the file are represented as a list of strings.
-    These strings  will typically have terminal newline characters, but
-    this is not required.  In particular files commonly do not have a newline
-    at the end of the file.
-
-    Texts can be identified in either of two ways:
-
-    * a nonnegative index number.
-
-    * a version-id string.
-
-    Typically the index number will be valid only inside this weave and
-    the version-id is used to reference it in the larger world.
-
-    The weave is represented as a list mixing edit instructions and
-    literal text.  Each entry in _weave can be either a string (or
-    unicode), or a tuple.  If a string, it means that the given line
-    should be output in the currently active revisions.
-
-    If a tuple, it gives a processing instruction saying in which
-    revisions the enclosed lines are active.  The tuple has the form
-    (instruction, version).
-
-    The instruction can be '{' or '}' for an insertion block, and '['
-    and ']' for a deletion block respectively.  The version is the
-    integer version index.  There is no replace operator, only deletes
-    and inserts.
-
-    Constraints/notes:
-
-    * A later version can delete lines that were introduced by any
-      number of ancestor versions; this implies that deletion
-      instructions can span insertion blocks without regard to the
-      insertion block's nesting.
-
-    * Similarly, deletions need not be properly nested with regard to
-      each other, because they might have been generated by
-      independent revisions.
-
-    * Insertions are always made by inserting a new bracketed block
-      into a single point in the previous weave.  This implies they
-      can nest but not overlap, and the nesting must always have later
-      insertions on the inside.
-
-    * It doesn't seem very useful to have an active insertion
-      inside an inactive insertion, but it might happen.
-      
-    * Therefore, all instructions are always"considered"; that
-      is passed onto and off the stack.  An outer inactive block
-      doesn't disable an inner block.
-
-    * Lines are enabled if the most recent enclosing insertion is
-      active and none of the enclosing deletions are active.
-
-    * There is no point having a deletion directly inside its own
-      insertion; you might as well just not write it.  And there
-      should be no way to get an earlier version deleting a later
-      version.
-
-    _weave
-        Text of the weave; list of control instruction tuples and strings.
-
-    _parents
-        List of parents, indexed by version number.
-        It is only necessary to store the minimal set of parents for
-        each version; the parent's parents are implied.
-
-    _sha1s
-        List of hex SHA-1 of each version, or None if not recorded.
-    """
-
-    __slots__ = ['_weave', '_parents', '_sha1s']
-    
-    def __init__(self):
-        self._weave = []
-        self._parents = []
-        self._sha1s = []
-
-
-    def __eq__(self, other):
-        if not isinstance(other, Weave):
-            return False
-        return self._parents == other._parents \
-               and self._weave == other._weave
-    
-
-    def __ne__(self, other):
-        return not self.__eq__(other)
-
-        
-    def add(self, parents, text):
-        """Add a single text on top of the weave.
-  
-        Returns the index number of the newly added version.
-
-        parents
-            List or set of direct parent version numbers.
-            
-        text
-            Sequence of lines to be added in the new version."""
-
-        self._check_versions(parents)
-        ## self._check_lines(text)
-        new_version = len(self._parents)
-
-        import sha
-        s = sha.new()
-        map(s.update, text)
-        sha1 = s.hexdigest()
-        del s
-
-        # if we abort after here the weave will be corrupt
-        self._parents.append(frozenset(parents))
-        self._sha1s.append(sha1)
-
-            
-        if not parents:
-            # special case; adding with no parents revision; can do
-            # this more quickly by just appending unconditionally.
-            # even more specially, if we're adding an empty text we
-            # need do nothing at all.
-            if text:
-                self._weave.append(('{', new_version))
-                self._weave.extend(text)
-                self._weave.append(('}', new_version))
-        
-            return new_version
-
-        if len(parents) == 1:
-            pv = list(parents)[0]
-            if sha1 == self._sha1s[pv]:
-                # special case: same as the single parent
-                return new_version
-            
-
-        ancestors = self.inclusions(parents)
-
-        l = self._weave
-
-        # basis a list of (origin, lineno, line)
-        basis_lineno = []
-        basis_lines = []
-        for origin, lineno, line in self._extract(ancestors):
-            basis_lineno.append(lineno)
-            basis_lines.append(line)
-
-        # another small special case: a merge, producing the same text as auto-merge
-        if text == basis_lines:
-            return new_version            
-
-        # add a sentinal, because we can also match against the final line
-        basis_lineno.append(len(self._weave))
-
-        # XXX: which line of the weave should we really consider
-        # matches the end of the file?  the current code says it's the
-        # last line of the weave?
-
-        #print 'basis_lines:', basis_lines
-        #print 'new_lines:  ', lines
-
-        from difflib import SequenceMatcher
-        s = SequenceMatcher(None, basis_lines, text)
-
-        # offset gives the number of lines that have been inserted
-        # into the weave up to the current point; if the original edit instruction
-        # says to change line A then we actually change (A+offset)
-        offset = 0
-
-        for tag, i1, i2, j1, j2 in s.get_opcodes():
-            # i1,i2 are given in offsets within basis_lines; we need to map them
-            # back to offsets within the entire weave
-            #print 'raw match', tag, i1, i2, j1, j2
-            if tag == 'equal':
-                continue
-
-            i1 = basis_lineno[i1]
-            i2 = basis_lineno[i2]
-
-            assert 0 <= j1 <= j2 <= len(text)
-
-            #print tag, i1, i2, j1, j2
-
-            # the deletion and insertion are handled separately.
-            # first delete the region.
-            if i1 != i2:
-                self._weave.insert(i1+offset, ('[', new_version))
-                self._weave.insert(i2+offset+1, (']', new_version))
-                offset += 2
-
-            if j1 != j2:
-                # there may have been a deletion spanning up to
-                # i2; we want to insert after this region to make sure
-                # we don't destroy ourselves
-                i = i2 + offset
-                self._weave[i:i] = ([('{', new_version)] 
-                                + text[j1:j2] 
-                                + [('}', new_version)])
-                offset += 2 + (j2 - j1)
-
-        return new_version
-
-
-    def inclusions(self, versions):
-        """Return set of all ancestors of given version(s)."""
-        i = set(versions)
-        v = max(versions)
-        try:
-            while v >= 0:
-                if v in i:
-                    # include all its parents
-                    i.update(self._parents[v])
-                v -= 1
-            return i
-        except IndexError:
-            raise ValueError("version %d not present in weave" % v)
-
-
-    def minimal_parents(self, version):
-        """Find the minimal set of parents for the version."""
-        included = self._parents[version]
-        if not included:
-            return []
-        
-        li = list(included)
-        li.sort(reverse=True)
-
-        mininc = []
-        gotit = set()
-
-        for pv in li:
-            if pv not in gotit:
-                mininc.append(pv)
-                gotit.update(self.inclusions(pv))
-
-        assert mininc[0] >= 0
-        assert mininc[-1] < version
-        return mininc
-
-
-
-    def _check_lines(self, text):
-        if not isinstance(text, list):
-            raise ValueError("text should be a list, not %s" % type(text))
-
-        for l in text:
-            if not isinstance(l, basestring):
-                raise ValueError("text line should be a string or unicode, not %s"
-                                 % type(l))
-        
-
-
-    def _check_versions(self, indexes):
-        """Check everything in the sequence of indexes is valid"""
-        for i in indexes:
-            try:
-                self._parents[i]
-            except IndexError:
-                raise IndexError("invalid version number %r" % i)
-
-    
-    def annotate(self, index):
-        return list(self.annotate_iter(index))
-
-
-    def annotate_iter(self, version):
-        """Yield list of (index-id, line) pairs for the specified version.
-
-        The index indicates when the line originated in the weave."""
-        for origin, lineno, text in self._extract([version]):
-            yield origin, text
-
-
-    def _walk(self):
-        """Walk the weave.
-
-        Yields sequence of
-        (lineno, insert, deletes, text)
-        for each literal line.
-        """
-        
-        istack = []
-        dset = set()
-
-        lineno = 0         # line of weave, 0-based
-
-        for l in self._weave:
-            if isinstance(l, tuple):
-                c, v = l
-                isactive = None
-                if c == '{':
-                    istack.append(v)
-                elif c == '}':
-                    oldv = istack.pop()
-                elif c == '[':
-                    assert v not in dset
-                    dset.add(v)
-                elif c == ']':
-                    dset.remove(v)
-                else:
-                    raise WeaveFormatError('unexpected instruction %r'
-                                           % v)
-            else:
-                assert isinstance(l, basestring)
-                assert istack
-                yield lineno, istack[-1], dset, l
-            lineno += 1
-
-
-
-    def _extract(self, versions):
-        """Yield annotation of lines in included set.
-
-        Yields a sequence of tuples (origin, lineno, text), where
-        origin is the origin version, lineno the index in the weave,
-        and text the text of the line.
-
-        The set typically but not necessarily corresponds to a version.
-        """
-        included = self.inclusions(versions)
-
-        istack = []
-        dset = set()
-
-        lineno = 0         # line of weave, 0-based
-
-        isactive = None
-
-        result = []
-
-        WFE = WeaveFormatError
-
-        for l in self._weave:
-            if isinstance(l, tuple):
-                c, v = l
-                isactive = None
-                if c == '{':
-                    assert v not in istack
-                    istack.append(v)
-                elif c == '}':
-                    oldv = istack.pop()
-                    assert oldv == v
-                elif c == '[':
-                    if v in included:
-                        assert v not in dset
-                        dset.add(v)
-                else:
-                    assert c == ']'
-                    if v in included:
-                        assert v in dset
-                        dset.remove(v)
-            else:
-                assert isinstance(l, basestring)
-                if isactive is None:
-                    isactive = (not dset) and istack and (istack[-1] in included)
-                if isactive:
-                    result.append((istack[-1], lineno, l))
-            lineno += 1
-
-        if istack:
-            raise WFE("unclosed insertion blocks at end of weave",
-                                   istack)
-        if dset:
-            raise WFE("unclosed deletion blocks at end of weave",
-                                   dset)
-
-        return result
-    
-
-
-    def get_iter(self, version):
-        """Yield lines for the specified version."""
-        for origin, lineno, line in self._extract([version]):
-            yield line
-
-
-    def get(self, index):
-        return list(self.get_iter(index))
-
-
-    def mash_iter(self, included):
-        """Return composed version of multiple included versions."""
-        for origin, lineno, text in self._extract(included):
-            yield text
-
-
-    def dump(self, to_file):
-        from pprint import pprint
-        print >>to_file, "Weave._weave = ",
-        pprint(self._weave, to_file)
-        print >>to_file, "Weave._parents = ",
-        pprint(self._parents, to_file)
-
-
-
-    def numversions(self):
-        l = len(self._parents)
-        assert l == len(self._sha1s)
-        return l
-
-
-    def __len__(self):
-        return self.numversions()
-
-
-    def check(self, progress_bar=None):
-        # check no circular inclusions
-        for version in range(self.numversions()):
-            inclusions = list(self._parents[version])
-            if inclusions:
-                inclusions.sort()
-                if inclusions[-1] >= version:
-                    raise WeaveFormatError("invalid included version %d for index %d"
-                                           % (inclusions[-1], version))
-
-        # try extracting all versions; this is a bit slow and parallel
-        # extraction could be used
-        import sha
-        nv = self.numversions()
-        for version in range(nv):
-            if progress_bar:
-                progress_bar.update('checking text', version, nv)
-            s = sha.new()
-            for l in self.get_iter(version):
-                s.update(l)
-            hd = s.hexdigest()
-            expected = self._sha1s[version]
-            if hd != expected:
-                raise WeaveError("mismatched sha1 for version %d; "
-                                 "got %s, expected %s"
-                                 % (version, hd, expected))
-
-        # TODO: check insertions are properly nested, that there are
-        # no lines outside of insertion blocks, that deletions are
-        # properly paired, etc.
-
-
-
-    def merge(self, merge_versions):
-        """Automerge and mark conflicts between versions.
-
-        This returns a sequence, each entry describing alternatives
-        for a chunk of the file.  Each of the alternatives is given as
-        a list of lines.
-
-        If there is a chunk of the file where there's no diagreement,
-        only one alternative is given.
-        """
-
-        # approach: find the included versions common to all the
-        # merged versions
-        raise NotImplementedError()
-
-
-
-    def _delta(self, included, lines):
-        """Return changes from basis to new revision.
-
-        The old text for comparison is the union of included revisions.
-
-        This is used in inserting a new text.
-
-        Delta is returned as a sequence of
-        (weave1, weave2, newlines).
-
-        This indicates that weave1:weave2 of the old weave should be
-        replaced by the sequence of lines in newlines.  Note that
-        these line numbers are positions in the total weave and don't
-        correspond to the lines in any extracted version, or even the
-        extracted union of included versions.
-
-        If line1=line2, this is a pure insert; if newlines=[] this is a
-        pure delete.  (Similar to difflib.)
-        """
-
-
-            
-    def plan_merge(self, ver_a, ver_b):
-        """Return pseudo-annotation indicating how the two versions merge.
-
-        This is computed between versions a and b and their common
-        base.
-
-        Weave lines present in none of them are skipped entirely.
-        """
-        inc_a = self.inclusions([ver_a])
-        inc_b = self.inclusions([ver_b])
-        inc_c = inc_a & inc_b
-
-        for lineno, insert, deleteset, line in self._walk():
-            if deleteset & inc_c:
-                # killed in parent; can't be in either a or b
-                # not relevant to our work
-                yield 'killed-base', line
-            elif insert in inc_c:
-                # was inserted in base
-                killed_a = bool(deleteset & inc_a)
-                killed_b = bool(deleteset & inc_b)
-                if killed_a and killed_b:
-                    yield 'killed-both', line
-                elif killed_a:
-                    yield 'killed-a', line
-                elif killed_b:
-                    yield 'killed-b', line
-                else:
-                    yield 'unchanged', line
-            elif insert in inc_a:
-                if deleteset & inc_a:
-                    yield 'ghost-a', line
-                else:
-                    # new in A; not in B
-                    yield 'new-a', line
-            elif insert in inc_b:
-                if deleteset & inc_b:
-                    yield 'ghost-b', line
-                else:
-                    yield 'new-b', line
-            else:
-                # not in either revision
-                yield 'irrelevant', line
-
-        yield 'unchanged', ''           # terminator
-
-
-
-    def weave_merge(self, plan):
-        lines_a = []
-        lines_b = []
-        ch_a = ch_b = False
-
-        for state, line in plan:
-            if state == 'unchanged' or state == 'killed-both':
-                # resync and flush queued conflicts changes if any
-                if not lines_a and not lines_b:
-                    pass
-                elif ch_a and not ch_b:
-                    # one-sided change:                    
-                    for l in lines_a: yield l
-                elif ch_b and not ch_a:
-                    for l in lines_b: yield l
-                elif lines_a == lines_b:
-                    for l in lines_a: yield l
-                else:
-                    yield '<<<<\n'
-                    for l in lines_a: yield l
-                    yield '====\n'
-                    for l in lines_b: yield l
-                    yield '>>>>\n'
-
-                del lines_a[:]
-                del lines_b[:]
-                ch_a = ch_b = False
-                
-            if state == 'unchanged':
-                if line:
-                    yield line
-            elif state == 'killed-a':
-                ch_a = True
-                lines_b.append(line)
-            elif state == 'killed-b':
-                ch_b = True
-                lines_a.append(line)
-            elif state == 'new-a':
-                ch_a = True
-                lines_a.append(line)
-            elif state == 'new-b':
-                ch_b = True
-                lines_b.append(line)
-            else:
-                assert state in ('irrelevant', 'ghost-a', 'ghost-b', 'killed-base',
-                                 'killed-both'), \
-                       state
-
-                
-
-
-
-
-
-def weave_info(w):
-    """Show some text information about the weave."""
-    print '%6s %40s %20s' % ('ver', 'sha1', 'parents')
-    for i in (6, 40, 20):
-        print '-' * i,
-    print
-    for i in range(w.numversions()):
-        sha1 = w._sha1s[i]
-        print '%6d %40s %s' % (i, sha1, ' '.join(map(str, w._parents[i])))
-
-
-
-def weave_stats(weave_file):
-    from bzrlib.progress import ProgressBar
-    from bzrlib.weavefile import read_weave
-
-    pb = ProgressBar()
-
-    wf = file(weave_file, 'rb')
-    w = read_weave(wf)
-    # FIXME: doesn't work on pipes
-    weave_size = wf.tell()
-
-    total = 0
-    vers = len(w)
-    for i in range(vers):
-        pb.update('checking sizes', i, vers)
-        for line in w.get_iter(i):
-            total += len(line)
-
-    pb.clear()
-
-    print 'versions          %9d' % vers
-    print 'weave file        %9d bytes' % weave_size
-    print 'total contents    %9d bytes' % total
-    print 'compression ratio %9.2fx' % (float(total) / float(weave_size))
-
-
-
-def usage():
-    print """bzr weave tool
-
-Experimental tool for weave algorithm.
-
-usage:
-    weave init WEAVEFILE
-        Create an empty weave file
-    weave get WEAVEFILE VERSION
-        Write out specified version.
-    weave check WEAVEFILE
-        Check consistency of all versions.
-    weave info WEAVEFILE
-        Display table of contents.
-    weave add WEAVEFILE [BASE...] < NEWTEXT
-        Add NEWTEXT, with specified parent versions.
-    weave annotate WEAVEFILE VERSION
-        Display origin of each line.
-    weave mash WEAVEFILE VERSION...
-        Display composite of all selected versions.
-    weave merge WEAVEFILE VERSION1 VERSION2 > OUT
-        Auto-merge two versions and display conflicts.
-
-example:
-
-    % weave init foo.weave
-    % vi foo.txt
-    % weave add foo.weave < foo.txt
-    added version 0
-
-    (create updated version)
-    % vi foo.txt
-    % weave get foo.weave 0 | diff -u - foo.txt
-    % weave add foo.weave 0 < foo.txt
-    added version 1
-
-    % weave get foo.weave 0 > foo.txt       (create forked version)
-    % vi foo.txt
-    % weave add foo.weave 0 < foo.txt
-    added version 2
-
-    % weave merge foo.weave 1 2 > foo.txt   (merge them)
-    % vi foo.txt                            (resolve conflicts)
-    % weave add foo.weave 1 2 < foo.txt     (commit merged version)     
-    
-"""
-    
-
-
-def main(argv):
-    import sys
-    import os
-    from weavefile import write_weave, read_weave
-    from bzrlib.progress import ProgressBar
-
-    #import psyco
-    #psyco.full()
-
-    cmd = argv[1]
-
-    def readit():
-        return read_weave(file(argv[2], 'rb'))
-    
-    if cmd == 'help':
-        usage()
-    elif cmd == 'add':
-        w = readit()
-        # at the moment, based on everything in the file
-        parents = map(int, argv[3:])
-        lines = sys.stdin.readlines()
-        ver = w.add(parents, lines)
-        write_weave(w, file(argv[2], 'wb'))
-        print 'added version %d' % ver
-    elif cmd == 'init':
-        fn = argv[2]
-        if os.path.exists(fn):
-            raise IOError("file exists")
-        w = Weave()
-        write_weave(w, file(fn, 'wb'))
-    elif cmd == 'get': # get one version
-        w = readit()
-        sys.stdout.writelines(w.get_iter(int(argv[3])))
-        
-    elif cmd == 'mash': # get composite
-        w = readit()
-        sys.stdout.writelines(w.mash_iter(map(int, argv[3:])))
-
-    elif cmd == 'annotate':
-        w = readit()
-        # newline is added to all lines regardless; too hard to get
-        # reasonable formatting otherwise
-        lasto = None
-        for origin, text in w.annotate(int(argv[3])):
-            text = text.rstrip('\r\n')
-            if origin == lasto:
-                print '      | %s' % (text)
-            else:
-                print '%5d | %s' % (origin, text)
-                lasto = origin
-                
-    elif cmd == 'info':
-        weave_info(readit())
-
-    elif cmd == 'stats':
-        weave_stats(argv[2])
-        
-    elif cmd == 'check':
-        w = readit()
-        pb = ProgressBar()
-        w.check(pb)
-        pb.clear()
-        print '%d versions ok' % w.numversions()
-
-    elif cmd == 'inclusions':
-        w = readit()
-        print ' '.join(map(str, w.inclusions([int(argv[3])])))
-
-    elif cmd == 'parents':
-        w = readit()
-        print ' '.join(map(str, w._parents[int(argv[3])]))
-
-    elif cmd == 'plan-merge':
-        w = readit()
-        for state, line in w.plan_merge(int(argv[3]), int(argv[4])):
-            if line:
-                print '%14s | %s' % (state, line),
-
-    elif cmd == 'merge':
-        w = readit()
-        p = w.plan_merge(int(argv[3]), int(argv[4]))
-        sys.stdout.writelines(w.weave_merge(p))
-            
-    elif cmd == 'mash-merge':
-        if len(argv) != 5:
-            usage()
-            return 1
-
-        w = readit()
-        v1, v2 = map(int, argv[3:5])
-
-        basis = w.inclusions([v1]).intersection(w.inclusions([v2]))
-
-        base_lines = list(w.mash_iter(basis))
-        a_lines = list(w.get(v1))
-        b_lines = list(w.get(v2))
-
-        from bzrlib.merge3 import Merge3
-        m3 = Merge3(base_lines, a_lines, b_lines)
-
-        name_a = 'version %d' % v1
-        name_b = 'version %d' % v2
-        sys.stdout.writelines(m3.merge_lines(name_a=name_a, name_b=name_b))
-    else:
-        raise ValueError('unknown command %r' % cmd)
-    
-
-if __name__ == '__main__':
-    import sys
-    sys.exit(main(sys.argv))

=== removed file 'bzrlib/weavefile.py'
--- bzrlib/weavefile.py	2005-07-18 13:38:13 +0000
+++ bzrlib/weavefile.py	1970-01-01 00:00:00 +0000
@@ -1,137 +0,0 @@
-#! /usr/bin/python
-
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-# Author: Martin Pool <mbp@canonical.com>
-
-
-
-
-"""Store and retrieve weaves in files.
-
-There is one format marker followed by a blank line, followed by a
-series of version headers, followed by the weave itself.
-
-Each version marker has 'i' and the included previous versions, then
-'1' and the SHA-1 of the text, if known.  The inclusions do not need
-to list versions included by a parent.
-
-The weave is bracketed by 'w' and 'W' lines, and includes the '{}[]'
-processing instructions.  Lines of text are prefixed by '.' if the
-line contains a newline, or ',' if not.
-"""
-
-# TODO: When extracting a single version it'd be enough to just pass
-# an iterator returning the weave lines...
-
-FORMAT_1 = '# bzr weave file v3\n'
-
-
-def write_weave(weave, f, format=None):
-    if format == None or format == 1:
-        return write_weave_v1(weave, f)
-    else:
-        raise ValueError("unknown weave format %r" % format)
-
-
-def write_weave_v1(weave, f):
-    """Write weave to file f."""
-    print >>f, FORMAT_1,
-
-    for version, included in enumerate(weave._parents):
-        if included:
-            # mininc = weave.minimal_parents(version)
-            mininc = included
-            print >>f, 'i',
-            for i in mininc:
-                print >>f, i,
-            print >>f
-        else:
-            print >>f, 'i'
-        print >>f, '1', weave._sha1s[version]
-        print >>f
-
-    print >>f, 'w'
-
-    for l in weave._weave:
-        if isinstance(l, tuple):
-            assert l[0] in '{}[]'
-            print >>f, '%s %d' % l
-        else: # text line
-            if not l:
-                print >>f, ', '
-            elif l[-1] == '\n':
-                assert l.find('\n', 0, -1) == -1
-                print >>f, '.', l,
-            else:
-                assert l.find('\n') == -1
-                print >>f, ',', l
-
-    print >>f, 'W'
-
-
-
-def read_weave(f):
-    return read_weave_v1(f)
-
-
-def read_weave_v1(f):
-    from weave import Weave, WeaveFormatError
-    w = Weave()
-
-    wfe = WeaveFormatError
-    l = f.readline()
-    if l != FORMAT_1:
-        raise WeaveFormatError('invalid weave file header: %r' % l)
-
-    ver = 0
-    while True:
-        l = f.readline()
-        if l[0] == 'i':
-            ver += 1
-
-            if len(l) > 2:
-                w._parents.append(frozenset(map(int, l[2:].split(' '))))
-            else:
-                w._parents.append(frozenset())
-
-            l = f.readline()[:-1]
-            assert l.startswith('1 ')
-            w._sha1s.append(l[2:])
-                
-            l = f.readline()
-            assert l == '\n'
-        elif l == 'w\n':
-            break
-        else:
-            raise WeaveFormatError('unexpected line %r' % l)
-
-    while True:
-        l = f.readline()
-        if l == 'W\n':
-            break
-        elif l.startswith('. '):
-            w._weave.append(l[2:])  # include newline
-        elif l.startswith(', '):
-            w._weave.append(l[2:-1])        # exclude newline
-        else:
-            assert l[0] in '{}[]', l
-            assert l[1] == ' ', l
-            w._weave.append((intern(l[0]), int(l[2:])))
-
-    return w
-    

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2005-07-22 19:32:52 +0000
+++ bzrlib/workingtree.py	2005-05-12 02:18:48 +0000
@@ -14,17 +14,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-# TODO: Don't allow WorkingTrees to be constructed for remote branches.
-
-# FIXME: I don't know if writing out the cache from the destructor is really a
-# good idea, because destructors are considered poor taste in Python, and
-# it's not predictable when it will be written out.
 
 import os
     
 import bzrlib.tree
 from errors import BzrCheckError
 from trace import mutter
+import statcache
 
 class WorkingTree(bzrlib.tree.Tree):
     """Working copy tree.
@@ -35,29 +31,13 @@
     It is possible for a `WorkingTree` to have a filename which is
     not listed in the Inventory and vice versa.
     """
+    _statcache = None
+    
     def __init__(self, basedir, inv):
-        from bzrlib.hashcache import HashCache
-        from bzrlib.trace import note, mutter
-
         self._inventory = inv
         self.basedir = basedir
         self.path2id = inv.path2id
-
-        # update the whole cache up front and write to disk if anything changed;
-        # in the future we might want to do this more selectively
-        hc = self._hashcache = HashCache(basedir)
-        hc.read()
-        hc.scan()
-
-        if hc.needs_write:
-            mutter("write hc")
-            hc.write()
-            
-            
-    def __del__(self):
-        if self._hashcache.needs_write:
-            self._hashcache.write()
-
+        self._update_statcache()
 
     def __iter__(self):
         """Iterate through file_ids for this tree.
@@ -66,16 +46,21 @@
         and the working file exists.
         """
         inv = self._inventory
-        for path, ie in inv.iter_entries():
-            if os.path.exists(self.abspath(path)):
-                yield ie.file_id
+        for file_id in self._inventory:
+            # TODO: This is slightly redundant; we should be able to just
+            # check the statcache but it only includes regular files.
+            # only include files which still exist on disk
+            ie = inv[file_id]
+            if ie.kind == 'file':
+                if ((file_id in self._statcache)
+                    or (os.path.exists(self.abspath(inv.id2path(file_id))))):
+                    yield file_id
+
 
 
     def __repr__(self):
         return "<%s of %s>" % (self.__class__.__name__,
-                               getattr(self, 'basedir', None))
-
-
+                               self.basedir)
 
     def abspath(self, filename):
         return os.path.join(self.basedir, filename)
@@ -96,24 +81,28 @@
                 
     def has_id(self, file_id):
         # files that have been deleted are excluded
-        inv = self._inventory
-        if not inv.has_id(file_id):
+        if not self.inventory.has_id(file_id):
             return False
-        path = inv.id2path(file_id)
-        return os.path.exists(self.abspath(path))
+        if file_id in self._statcache:
+            return True
+        return os.path.exists(self.abspath(self.id2path(file_id)))
 
 
     __contains__ = has_id
     
 
+    def _update_statcache(self):
+        import statcache
+        if not self._statcache:
+            self._statcache = statcache.update_cache(self.basedir, self.inventory)
+
     def get_file_size(self, file_id):
-        # is this still called?
-        raise NotImplementedError()
+        import os, stat
+        return os.stat(self._get_store_filename(file_id))[stat.ST_SIZE]
 
 
     def get_file_sha1(self, file_id):
-        path = self._inventory.id2path(file_id)
-        return self._hashcache.get_sha1(path)
+        return self._statcache[file_id][statcache.SC_SHA1]
 
 
     def file_class(self, filename):
@@ -138,7 +127,7 @@
         from osutils import appendpath, file_kind
         import os
 
-        inv = self._inventory
+        inv = self.inventory
 
         def descend(from_dir_relpath, from_dir_id, dp):
             ls = os.listdir(dp)
@@ -290,4 +279,8 @@
                     return pat
         else:
             return None
-        
\ No newline at end of file
+        
+
+        
+        
+

=== modified file 'bzrlib/xml.py'
--- bzrlib/xml.py	2005-06-28 05:33:40 +0000
+++ bzrlib/xml.py	2005-03-15 05:19:54 +0000
@@ -20,21 +20,30 @@
 # "XML is like violence: if it doesn't solve your problem, you aren't
 # using enough of it." -- various
 
-# importing this module is fairly slow because it has to load several ElementTree bits
+
+__copyright__ = "Copyright (C) 2005 Canonical Ltd."
+__author__ = "Martin Pool <mbp@canonical.com>"
+
 try:
-    from cElementTree import ElementTree, SubElement, Element
+    from cElementTree import Element, ElementTree, SubElement
 except ImportError:
-    from elementtree.ElementTree import ElementTree, SubElement, Element
-
-
-def pack_xml(o, f):
-    """Write object o to file f as XML.
-
-    o must provide a to_element method.
-    """
-    ElementTree(o.to_element()).write(f, 'utf-8')
-    f.write('\n')
-
-
-def unpack_xml(cls, f):
-    return cls.from_element(ElementTree().parse(f))
+    from elementtree.ElementTree import Element, ElementTree, SubElement
+
+import os, time
+from trace import mutter
+
+class XMLMixin:
+    def to_element(self):
+        raise Exception("XMLMixin.to_element must be overridden in concrete classes")
+    
+    def write_xml(self, f):
+        ElementTree(self.to_element()).write(f, 'utf-8')
+        f.write('\n')
+
+    def read_xml(cls, f):
+        return cls.from_element(ElementTree().parse(f))
+
+    read_xml = classmethod(read_xml)
+
+
+

=== modified file 'contrib/pwk'
--- contrib/pwk	2005-07-07 10:31:36 +0000
+++ contrib/pwk	2005-06-22 03:09:57 +0000
@@ -16,7 +16,7 @@
 usage() {
     cat <<EOF
 usage: 
-   pwk cat PATCH-ID       show the patch text
+   pwk show PATCH-ID       show the patch text
    pwk try PATCH-ID        see if the patch applies cleanly
    pwk apply PATCH-ID      apply patch into current directory
 EOF

=== modified file 'contrib/upload-bzr.dev'
--- contrib/upload-bzr.dev	2005-06-27 01:26:11 +0000
+++ contrib/upload-bzr.dev	2005-06-14 23:04:06 +0000
@@ -17,11 +17,11 @@
 rsync -rltv							    \
     .								    \
     escudero.ubuntu.com:/srv/www.bazaar-ng.org/rsync/bzr/bzr.dev/   \
+    --include-from -						    \
     --include .bzr						    \
     --include '.bzr/**'						    \
     --exclude-from .rsyncexclude				    \
     --exclude-from .bzrignore					    \
-    --include-from -						    \
     --exclude \*						    \
     --exclude '.*'						    \
     --delete-excluded --delete					    \

=== modified file 'doc/formats.txt'
--- doc/formats.txt	2005-07-04 12:26:02 +0000
+++ doc/formats.txt	2005-06-15 09:24:48 +0000
@@ -98,9 +98,9 @@
   include merges add to this file; lines are never removed or
   reordered.
 
-``pending-merges`` 
-  List (one per line) of non-mainline revisions that
-  have been merged and are waiting to be committed.
+``pending-merge-patches``
+  List of foreign patches that have been merged and are waiting to be
+  committed. 
 
 ``branch-name``
   User-qualified name of the branch, for the purpose of describing the
@@ -174,10 +174,6 @@
 An inventory is stored for recorded revisions, also a
 ``pending-inventory`` for a working directory.
 
-Inventories always have the same id as the revision they correspond
-to.  bzr up to 0.0.5 explicitly stores an inventory-id; in future
-versions this may be implied.
-
 
 
 Revision

=== removed directory 'effbot'
=== removed file 'effbot/__init__.py'
--- effbot/__init__.py	2005-06-27 01:39:26 +0000
+++ effbot/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-# $Id: __init__.py 271 2004-10-09 10:50:59Z fredrik $

=== removed directory 'effbot/org'
=== removed file 'effbot/org/__init__.py'
--- effbot/org/__init__.py	2005-06-27 01:39:26 +0000
+++ effbot/org/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-# $Id: __init__.py 271 2004-10-09 10:50:59Z fredrik $

=== removed file 'effbot/org/gzip_consumer.py'
--- effbot/org/gzip_consumer.py	2005-06-27 01:39:26 +0000
+++ effbot/org/gzip_consumer.py	1970-01-01 00:00:00 +0000
@@ -1,60 +0,0 @@
-# $Id: gzip_consumer.py 271 2004-10-09 10:50:59Z fredrik $
-# gzip consumer
-#
-# Copyright (c) 2001-2004 by Fredrik Lundh.  All rights reserved.
-#
-
-##
-# Consumer wrapper for GZIP streams.
-
-class GzipConsumer:
-
-    def __init__(self, consumer):
-        self.__consumer = consumer
-        self.__decoder = None
-        self.__data = ""
-
-    def __getattr__(self, key):
-        return getattr(self.__consumer, key)
-
-    def feed(self, data):
-        if self.__decoder is None:
-            # check if we have a full gzip header
-            data = self.__data + data
-            try:
-                i = 10
-                flag = ord(data[3])
-                if flag & 4: # extra
-                    x = ord(data[i]) + 256*ord(data[i+1])
-                    i = i + 2 + x
-                if flag & 8: # filename
-                    while ord(data[i]):
-                        i = i + 1
-                    i = i + 1
-                if flag & 16: # comment
-                    while ord(data[i]):
-                        i = i + 1
-                    i = i + 1
-                if flag & 2: # crc
-                    i = i + 2
-                if len(data) < i:
-                    raise IndexError("not enough data")
-                if data[:3] != "\x1f\x8b\x08":
-                    raise IOError("invalid gzip data")
-                data = data[i:]
-            except IndexError:
-                self.__data = data
-                return # need more data
-            import zlib
-            self.__data = ""
-            self.__decoder = zlib.decompressobj(-zlib.MAX_WBITS)
-        data = self.__decoder.decompress(data)
-        if data:
-            self.__consumer.feed(data)
-
-    def close(self):
-        if self.__decoder:
-            data = self.__decoder.flush()
-            if data:
-                self.__consumer.feed(data)
-        self.__consumer.close()

=== removed file 'effbot/org/http_client.py'
--- effbot/org/http_client.py	2005-06-27 01:39:26 +0000
+++ effbot/org/http_client.py	1970-01-01 00:00:00 +0000
@@ -1,268 +0,0 @@
-# $Id: http_client.py 271 2004-10-09 10:50:59Z fredrik $
-# a simple asynchronous http client (based on SimpleAsyncHTTP.py from
-# "Python Standard Library" by Fredrik Lundh, O'Reilly 2001)
-#
-# HTTP/1.1 and GZIP support added in January 2003 by Fredrik Lundh.
-#
-# changes:
-# 2004-08-26 fl   unified http callback
-# 2004-10-09 fl   factored out gzip_consumer support
-#
-# Copyright (c) 2001-2004 by Fredrik Lundh.  All rights reserved.
-#
-
-import asyncore
-import socket, string, time, sys
-import StringIO
-import mimetools, urlparse, urllib
-
-try:
-    from gzip_consumer import GzipConsumer
-except ImportError:
-    pass
-
-##
-# Close connection.   Request handlers can raise this exception to
-# indicate that the connection should be closed.
-
-class CloseConnection(Exception):
-    pass
-
-##
-# Redirect connection.  Request handlers can raise this exception to
-# indicate that the a new request should be issued.
-
-class Redirect(CloseConnection):
-    def __init__(self, location):
-        self.location = location
-
-##
-# Asynchronous HTTP/1.1 client.
-
-class async_http(asyncore.dispatcher_with_send):
-    # asynchronous http client
-
-    user_agent = "http_client.py 1.2 (http://effbot.org/zone)"
-    http_version = "1.1"
-
-    proxies = urllib.getproxies()
-
-    def __init__(self, uri, consumer, extra_headers=None):
-        asyncore.dispatcher_with_send.__init__(self)
-
-        # turn the uri into a valid request
-        scheme, host, path, params, query, fragment = urlparse.urlparse(uri)
-
-        # use origin host
-        self.host = host
-
-        # get proxy settings, if any
-        proxy = self.proxies.get(scheme)
-        if proxy:
-            scheme, host, x, x, x, x = urlparse.urlparse(proxy)
-
-        assert scheme == "http", "only supports HTTP requests (%s)" % scheme
-
-        if not path:
-            path = "/"
-        if params:
-            path = path + ";" + params
-        if query:
-            path = path + "?" + query
-        if proxy:
-            path = scheme + "://" + self.host + path
-
-        self.path = path
-
-        # get port number
-        try:
-            host, port = host.split(":", 1)
-            port = int(port)
-        except (TypeError, ValueError):
-            port = 80 # default port
-
-        self.consumer = consumer
-
-        self.status = None
-        self.header = None
-
-        self.bytes_in = 0
-        self.bytes_out = 0
-
-        self.content_type = None
-        self.content_length = None
-        self.content_encoding = None
-        self.transfer_encoding = None
-
-        self.data = ""
-
-        self.chunk_size = None
-
-        self.timestamp = time.time()
-
-        self.extra_headers = extra_headers
-
-        self.create_socket(socket.AF_INET, socket.SOCK_STREAM)
-        try:
-            self.connect((host, port))
-        except socket.error:
-            self.consumer.http(0, self, sys.exc_info())
-
-    def handle_connect(self):
-        # connection succeeded
-
-        request = [
-            "GET %s HTTP/%s" % (self.path, self.http_version),
-            "Host: %s" % self.host,
-            ]
-
-        if GzipConsumer:
-            request.append("Accept-Encoding: gzip")
-
-        if self.extra_headers:
-            request.extend(self.extra_headers)
-
-        # make sure to include a user agent
-        for header in request:
-            if string.lower(header).startswith("user-agent:"):
-                break
-        else:
-            request.append("User-Agent: %s" % self.user_agent)
-
-        request = string.join(request, "\r\n") + "\r\n\r\n"
-
-        self.send(request)
-
-        self.bytes_out = self.bytes_out + len(request)
-
-    def handle_expt(self):
-        # connection failed (windows); notify consumer
-
-        if sys.platform == "win32":
-            self.close()
-            self.consumer.http(0, self)
-
-    def handle_read(self):
-        # handle incoming data
-
-        data = self.recv(2048)
-
-        self.data = self.data + data
-        self.bytes_in = self.bytes_in + len(data)
-
-        while self.data:
-
-            if not self.header:
-                # check if we've seen a full header
-
-                header = self.data.split("\r\n\r\n", 1)
-                if len(header) <= 1:
-                    return
-                header, self.data = header
-
-                # parse header
-                fp = StringIO.StringIO(header)
-                self.status = fp.readline().split(" ", 2)
-                self.header = mimetools.Message(fp)
-
-                # get http headers
-                self.content_type = self.header.get("content-type")
-                try:
-                    self.content_length = int(
-                        self.header.get("content-length")
-                        )
-                except (ValueError, TypeError):
-                    self.content_length = None
-                self.transfer_encoding = self.header.get("transfer-encoding")
-                self.content_encoding = self.header.get("content-encoding")
-
-                if self.content_encoding == "gzip":
-                    # FIXME: report error if GzipConsumer is not available
-                    self.consumer = GzipConsumer(self.consumer)
-
-                try:
-                    self.consumer.http(1, self)
-                except Redirect, v:
-                    # redirect
-                    if v.location:
-                        do_request(
-                            v.location, self.consumer, self.extra_headers
-                            )
-                    self.close()
-                    return
-                except CloseConnection:
-                    self.close()
-                    return
-
-            if self.transfer_encoding == "chunked" and self.chunk_size is None:
-
-                # strip off leading whitespace
-                if self.data.startswith("\r\n"):
-                    self.data = self.data[2:]
-
-                chunk_size = self.data.split("\r\n", 1)
-                if len(chunk_size) <= 1:
-                    return
-                chunk_size, self.data = chunk_size
-
-                try:
-                    self.chunk_size = int(chunk_size, 16)
-                    if self.chunk_size <= 0:
-                        raise ValueError
-                except ValueError:
-                    return self.handle_close()
-
-            if not self.data:
-                return
-
-            data = self.data
-            self.data = ""
-
-            chunk_size = self.chunk_size or len(data)
-
-            if chunk_size < len(data):
-                self.data = data[chunk_size:]
-                data = data[:chunk_size]
-                self.chunk_size = None
-            else:
-                self.chunk_size = chunk_size - len(data)
-                if self.chunk_size <= 0:
-                    self.chunk_size = None
-
-            if data:
-                self.consumer.feed(data)
-
-            if self.content_length:
-                self.content_length -= chunk_size
-                if self.content_length <= 0:
-                    return self.handle_close()
-
-    def handle_close(self):
-        self.consumer.close()
-        self.close()
-
-    def handle_error(self):
-        self.consumer.http(0, self, sys.exc_info())
-        self.close()
-
-def do_request(uri, consumer, extra_headers=None):
-
-    return async_http(uri, consumer, extra_headers)
-
-if __name__ == "__main__":
-    class dummy_consumer:
-        def feed(self, data):
-            # print "feed", repr(data)
-            print "feed", repr(data[:20]), repr(data[-20:]), len(data)
-        def close(self):
-            print "close"
-        def http(self, ok, connection, **args):
-            print ok, connection, args
-            print "status", connection.status
-            print "header", connection.header
-    try:
-        url = sys.argv[1]
-    except IndexError:
-        url = "http://www.cnn.com/"
-    do_request(url, dummy_consumer())
-    asyncore.loop()

=== removed file 'effbot/org/http_manager.py'
--- effbot/org/http_manager.py	2005-06-27 01:39:26 +0000
+++ effbot/org/http_manager.py	1970-01-01 00:00:00 +0000
@@ -1,67 +0,0 @@
-# $Id: http_manager.py 270 2004-10-09 10:38:54Z fredrik $
-# effnews http
-#
-# manage a set of http clients
-#
-# Copyright (c) 2001-2004 by Fredrik Lundh.  All rights reserved.
-#
-
-import asyncore, time
-import http_client
-
-class http_manager:
-
-    max_connections = 8
-    max_size = 1000000
-    max_time = 60
-
-    def __init__(self):
-        self.queue = []
-
-    def request(self, uri, consumer, extra_headers=None):
-        self.queue.append((uri, consumer, extra_headers))
-
-    def priority_request(self, uri, consumer, extra_headers=None):
-        self.queue.insert(0, (uri, consumer, extra_headers))
-
-    def purge(self):
-        for channel in asyncore.socket_map.values():
-            channel.close()
-        del self.queue[:]
-
-    def prioritize(self, priority_uri):
-        i = 0
-        for uri, consumer, extra_headers in self.queue:
-            if uri == priority_uri:
-                del self.queue[i]
-                self.priority_request(uri, consumer, extra_headers)
-                return
-            i = i + 1
-
-    def poll(self, timeout=0.1):
-        # sanity checks
-        now = time.time()
-        for channel in asyncore.socket_map.values():
-            if channel.bytes_in > self.max_size:
-                channel.close() # too much data
-                try:
-                    channel.consumer.http(
-                        0, channel, ("HTTPManager", "too much data", None)
-                        )
-                except:
-                    pass
-            if channel.timestamp and now - channel.timestamp > self.max_time:
-                channel.close() # too slow
-                try:
-                    channel.consumer.http(
-                        0, channel, ("HTTPManager", "timeout", None)
-                        )
-                except:
-                    pass
-        # activate up to max_connections channels
-        while self.queue and len(asyncore.socket_map) < self.max_connections:
-            http_client.do_request(*self.queue.pop(0))
-        # keep the network running
-        asyncore.poll(timeout)
-        # return non-zero if we should keep on polling
-        return len(self.queue) or len(asyncore.socket_map)

=== removed file 'patches/ndiff.patch'
--- patches/ndiff.patch	2005-07-04 12:11:40 +0000
+++ patches/ndiff.patch	1970-01-01 00:00:00 +0000
@@ -1,149 +0,0 @@
-*** modified file 'bzrlib/commands.py'
---- bzrlib/commands.py 
-+++ bzrlib/commands.py 
-@@ -721,10 +721,11 @@
-     """
-     
-     takes_args = ['file*']
--    takes_options = ['revision', 'diff-options']
-+    takes_options = ['revision', 'diff-options', 'ndiff']
-     aliases = ['di', 'dif']
- 
--    def run(self, revision=None, file_list=None, diff_options=None):
-+    def run(self, revision=None, file_list=None, diff_options=None,
-+            ndiff=None):
-         from bzrlib.diff import show_diff
- 
-         if file_list:
-@@ -735,9 +736,15 @@
-                 file_list = None
-         else:
-             b = find_branch('.')
--    
-+
-+        if ndiff:
-+            format = 'ndiff'
-+        else:
-+            format = None
-+
-         show_diff(b, revision, specific_files=file_list,
--                  external_diff_options=diff_options)
-+                  external_diff_options=diff_options,
-+                  format=format)
- 
- 
-         
-@@ -1344,6 +1351,7 @@
-     'format':                 unicode,
-     'forward':                None,
-     'message':                unicode,
-+    'ndiff':                  None,
-     'no-recurse':             None,
-     'profile':                None,
-     'revision':               _parse_revision_str,
-
-*** modified file 'bzrlib/diff.py'
---- bzrlib/diff.py 
-+++ bzrlib/diff.py 
-@@ -70,6 +70,13 @@
-     print >>to_file
- 
- 
-+
-+def internal_ndiff(old_label, oldlines,
-+                   new_label, newlines,
-+                   to_file):
-+    """Show diff in python-specific ndiff format."""
-+    from difflib import ndiff
-+    to_file.writelines(ndiff(oldlines, newlines))
- 
- 
- def external_diff(old_label, oldlines, new_label, newlines, to_file,
-@@ -152,7 +159,8 @@
-     
- 
- 
--def show_diff(b, revision, specific_files, external_diff_options=None):
-+def show_diff(b, revision, specific_files, external_diff_options=None,
-+              format=None):
-     """Shortcut for showing the diff to the working tree.
- 
-     b
-@@ -160,6 +168,9 @@
- 
-     revision
-         None for each, or otherwise the old revision to compare against.
-+
-+    format
-+        'unified', 'context', 'ndiff', 'external'
-     
-     The more general form is show_diff_trees(), where the caller
-     supplies any two trees.
-@@ -174,12 +185,13 @@
-     new_tree = b.working_tree()
- 
-     show_diff_trees(old_tree, new_tree, sys.stdout, specific_files,
--                    external_diff_options)
-+                    external_diff_options, format)
- 
- 
- 
- def show_diff_trees(old_tree, new_tree, to_file, specific_files=None,
--                    external_diff_options=None):
-+                    external_diff_options=None,
-+                    format=None):
-     """Show in text form the changes from one tree to another.
- 
-     to_files
-@@ -204,10 +216,12 @@
-     if external_diff_options:
-         assert isinstance(external_diff_options, basestring)
-         opts = external_diff_options.split()
--        def diff_file(olab, olines, nlab, nlines, to_file):
-+        def diff_fn(olab, olines, nlab, nlines, to_file):
-             external_diff(olab, olines, nlab, nlines, to_file, opts)
-+    elif format == 'ndiff':
-+        diff_fn = internal_ndiff
-     else:
--        diff_file = internal_diff
-+        diff_fn = internal_diff
-     
- 
-     delta = compare_trees(old_tree, new_tree, want_unchanged=False,
-@@ -216,7 +230,7 @@
-     for path, file_id, kind in delta.removed:
-         print >>to_file, '*** removed %s %r' % (kind, path)
-         if kind == 'file':
--            diff_file(old_label + path,
-+            diff_fn(old_label + path,
-                       old_tree.get_file(file_id).readlines(),
-                       DEVNULL, 
-                       [],
-@@ -225,7 +239,7 @@
-     for path, file_id, kind in delta.added:
-         print >>to_file, '*** added %s %r' % (kind, path)
-         if kind == 'file':
--            diff_file(DEVNULL,
-+            diff_fn(DEVNULL,
-                       [],
-                       new_label + path,
-                       new_tree.get_file(file_id).readlines(),
-@@ -234,7 +248,7 @@
-     for old_path, new_path, file_id, kind, text_modified in delta.renamed:
-         print >>to_file, '*** renamed %s %r => %r' % (kind, old_path, new_path)
-         if text_modified:
--            diff_file(old_label + old_path,
-+            diff_fn(old_label + old_path,
-                       old_tree.get_file(file_id).readlines(),
-                       new_label + new_path,
-                       new_tree.get_file(file_id).readlines(),
-@@ -243,7 +257,7 @@
-     for path, file_id, kind in delta.modified:
-         print >>to_file, '*** modified %s %r' % (kind, path)
-         if kind == 'file':
--            diff_file(old_label + path,
-+            diff_fn(old_label + path,
-                       old_tree.get_file(file_id).readlines(),
-                       new_label + path,
-                       new_tree.get_file(file_id).readlines(),
-

=== removed directory 'plugins'
=== removed directory 'plugins/changeset'
=== removed file 'plugins/changeset/__init__.py'
--- plugins/changeset/__init__.py	2005-06-22 09:34:59 +0000
+++ plugins/changeset/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,105 +0,0 @@
-#!/usr/bin/env python
-"""\
-This is an attempt to take the internal delta object, and represent
-it as a single-file text-only changeset.
-This should have commands for both generating a changeset,
-and for applying a changeset.
-"""
-
-import bzrlib, bzrlib.commands
-
-class cmd_changeset(bzrlib.commands.Command):
-    """Generate a bundled up changeset.
-
-    This changeset contains all of the meta-information of a
-    diff, rather than just containing the patch information.
-
-    If a file is specified, only changes affecting that file are
-    specified; this gives a changeset that is probably not useful.
-
-    Right now, rollup changesets, or working tree changesets are
-    not supported. This will only generate a changeset that has been
-    committed. You can use "--revision" to specify a certain change
-    to display.
-    """
-    takes_options = ['revision', 'diff-options']
-    takes_args = ['file*']
-    aliases = ['cset']
-
-    def run(self, revision=None, file_list=None, diff_options=None):
-        from bzrlib import find_branch
-        import gen_changeset
-        import sys
-
-        if isinstance(revision, (list, tuple)):
-            if len(revision) > 1:
-                raise BzrCommandError('We do not support rollup-changesets yet.')
-            revision = revision[0]
-        if file_list:
-            b = find_branch(file_list[0])
-            file_list = [b.relpath(f) for f in file_list]
-            if file_list == ['']:
-                # just pointing to top-of-tree
-                file_list = None
-        else:
-            b = find_branch('.')
-
-        gen_changeset.show_changeset(b, revision,
-                specific_files=file_list,
-                external_diff_options=diff_options,
-                to_file=sys.stdout)
-
-class cmd_verify_changeset(bzrlib.commands.Command):
-    """Read a written changeset, and make sure it is valid.
-
-    """
-    takes_args = ['filename?']
-
-    def run(self, filename=None):
-        import sys, read_changeset
-        if filename is None or filename == '-':
-            f = sys.stdin
-        else:
-            f = open(filename, 'rb')
-
-        cset_info = read_changeset.read_changeset(f)
-        print cset_info
-        cset = cset_info.get_changeset()
-        print cset.entries
-
-class cmd_apply_changeset(bzrlib.commands.Command):
-    """Read in the given changeset, and apply it to the
-    current tree.
-
-    """
-    takes_args = ['filename?']
-    takes_options = []
-
-    def run(self, filename=None, reverse=False, auto_commit=False):
-        from bzrlib import find_branch
-        import sys
-        import apply_changeset
-
-        b = find_branch('.') # Make sure we are in a branch
-        if filename is None or filename == '-':
-            f = sys.stdin
-        else:
-            f = open(filename, 'rb')
-
-        apply_changeset.apply_changeset(b, f, reverse=reverse,
-                auto_commit=auto_commit)
-
-
-##if hasattr(bzrlib.commands, 'register_plugin_cmd'):
-
-## print dir(bzrlib.commands)
-
-bzrlib.commands.register_command(cmd_changeset)
-bzrlib.commands.register_command(cmd_verify_changeset)
-bzrlib.commands.register_command(cmd_apply_changeset)
-
-bzrlib.commands.OPTIONS['reverse'] = None
-bzrlib.commands.OPTIONS['auto-commit'] = None
-cmd_apply_changeset.takes_options.append('reverse')
-cmd_apply_changeset.takes_options.append('auto-commit')
-

=== removed file 'plugins/changeset/apply_changeset.py'
--- plugins/changeset/apply_changeset.py	2005-06-22 09:08:43 +0000
+++ plugins/changeset/apply_changeset.py	1970-01-01 00:00:00 +0000
@@ -1,41 +0,0 @@
-#!/usr/bin/env python
-"""\
-This contains the apply changset function for bzr
-"""
-
-import bzrlib
-
-def apply_changeset(branch, from_file, reverse=False, auto_commit=False):
-    from bzrlib.changeset import apply_changeset as _apply_changeset
-    from bzrlib.merge import regen_inventory
-    import sys, read_changeset
-
-
-    cset_info = read_changeset.read_changeset(from_file)
-    cset = cset_info.get_changeset()
-    inv = {}
-    for file_id in branch.inventory:
-        inv[file_id] = branch.inventory.id2path(file_id)
-    changes = _apply_changeset(cset, inv, branch.base,
-            reverse=reverse)
-
-    adjust_ids = []
-    for id, path in changes.iteritems():
-        if path is not None:
-            if path == '.':
-                path = ''
-        adjust_ids.append((path, id))
-
-    branch.set_inventory(regen_inventory(branch, branch.base, adjust_ids))
-
-    if auto_commit:
-        from bzrlib.commit import commit
-        if branch.last_patch() == cset_info.precursor:
-            # This patch can be applied directly
-            commit(branch, message = cset_info.message,
-                    timestamp=float(cset_info.timestamp),
-                    timezone=float(cset_info.timezone),
-                    committer=cset_info.committer,
-                    rev_id=cset_info.revision)
-
-

=== removed file 'plugins/changeset/common.py'
--- plugins/changeset/common.py	2005-06-22 09:08:43 +0000
+++ plugins/changeset/common.py	1970-01-01 00:00:00 +0000
@@ -1,15 +0,0 @@
-#!/usr/bin/env python
-"""\
-Common entries, like strings, etc, for the changeset reading + writing code.
-"""
-
-header_str = 'Bazaar-NG (bzr) changeset v'
-version = (0, 0, 5)
-
-def get_header():
-    return [
-        header_str + '.'.join([str(v) for v in version]),
-        'This changeset can be applied with bzr apply-changeset',
-        ''
-    ]
-

=== removed file 'plugins/changeset/gen_changeset.py'
--- plugins/changeset/gen_changeset.py	2005-06-22 09:08:43 +0000
+++ plugins/changeset/gen_changeset.py	1970-01-01 00:00:00 +0000
@@ -1,345 +0,0 @@
-#!/usr/bin/env python
-"""\
-Just some work for generating a changeset.
-"""
-
-import bzrlib, bzrlib.errors
-
-import common
-
-from bzrlib.inventory import ROOT_ID
-
-try:
-    set
-except NameError:
-    from sets import Set as set
-
-def _canonicalize_revision(branch, revno):
-    """Turn some sort of revision information into a single
-    set of from-to revision ids.
-
-    A revision id can be None if there is no associated revison.
-
-    :return: (old, new)
-    """
-    # This is a little clumsy because revision parsing may return
-    # a single entry, or a list
-    if revno is None:
-        new = branch.last_patch()
-    else:
-        new = branch.lookup_revision(revno)
-
-    if new is None:
-        raise BzrCommandError('Cannot generate a changset with no commits in tree.')
-
-    old = branch.get_revision(new).precursor
-
-    return old, new
-
-def _get_trees(branch, revisions):
-    """Get the old and new trees based on revision.
-    """
-    from bzrlib.tree import EmptyTree
-    if revisions[0] is None:
-        if hasattr(branch, 'get_root_id'): # Watch out for trees with labeled ROOT ids
-            old_tree = EmptyTree(branch.get_root_id) 
-        else:
-            old_tree = EmptyTree()
-    else:
-        old_tree = branch.revision_tree(revisions[0])
-
-    if revisions[1] is None:
-        # This is for the future, once we support rollup revisions
-        # Or working tree revisions
-        new_tree = branch.working_tree()
-    else:
-        new_tree = branch.revision_tree(revisions[1])
-    return old_tree, new_tree
-
-def _fake_working_revision(branch):
-    """Fake a Revision object for the working tree.
-    
-    This is for the future, to support changesets against the working tree.
-    """
-    from bzrlib.revision import Revision
-    import time
-    from bzrlib.osutils import local_time_offset, \
-            username
-
-    precursor = branch.last_patch()
-    precursor_sha1 = branch.get_revision_sha1(precursor)
-
-    return Revision(timestamp=time.time(),
-            timezone=local_time_offset(),
-            committer=username(),
-            precursor=precursor,
-            precursor_sha1=precursor_sha1)
-
-
-class MetaInfoHeader(object):
-    """Maintain all of the header information about this
-    changeset.
-    """
-
-    def __init__(self, branch, revisions, delta,
-            full_remove=True, full_rename=False,
-            external_diff_options = None,
-            new_tree=None, old_tree=None,
-            old_label = '', new_label = ''):
-        """
-        :param full_remove: Include the full-text for a delete
-        :param full_rename: Include an add+delete patch for a rename
-        """
-        self.branch = branch
-        self.delta = delta
-        self.full_remove=full_remove
-        self.full_rename=full_rename
-        self.external_diff_options = external_diff_options
-        self.old_label = old_label
-        self.new_label = new_label
-        self.old_tree = old_tree
-        self.new_tree = new_tree
-        self.to_file = None
-        self.revno = None
-        self.precursor_revno = None
-
-        self._get_revision_list(revisions)
-
-    def _get_revision_list(self, revisions):
-        """This generates the list of all revisions from->to.
-
-        This is for the future, when we support having a rollup changeset.
-        For now, the list should only be one long.
-        """
-        old_revno = None
-        new_revno = None
-        rh = self.branch.revision_history()
-        for revno, rev in enumerate(rh):
-            if rev == revisions[0]:
-                old_revno = revno
-            if rev == revisions[1]:
-                new_revno = revno
-
-        self.revision_list = []
-        if old_revno is None:
-            self.base_revision = None # Effectively the EmptyTree()
-            old_revno = -1
-        else:
-            self.base_revision = self.branch.get_revision(rh[old_revno])
-        if new_revno is None:
-            # For the future, when we support working tree changesets.
-            for rev_id in rh[old_revno+1:]:
-                self.revision_list.append(self.branch.get_revision(rev_id))
-            self.revision_list.append(_fake_working_revision(self.branch))
-        else:
-            for rev_id in rh[old_revno+1:new_revno+1]:
-                self.revision_list.append(self.branch.get_revision(rev_id))
-        self.precursor_revno = old_revno
-        self.revno = new_revno
-
-    def _write(self, txt, key=None):
-        if key:
-            self.to_file.write('# %s: %s\n' % (key, txt))
-        else:
-            self.to_file.write('# %s\n' % (txt,))
-
-    def write_meta_info(self, to_file):
-        """Write out the meta-info portion to the supplied file.
-
-        :param to_file: Write out the meta information to the supplied
-                        file
-        """
-        self.to_file = to_file
-
-        self._write_header()
-        self._write_diffs()
-        self._write_footer()
-
-    def _write_header(self):
-        """Write the stuff that comes before the patches."""
-        from bzrlib.osutils import username, format_date
-        write = self._write
-
-        for line in common.get_header():
-            write(line)
-
-        # This grabs the current username, what we really want is the
-        # username from the actual patches.
-        #write(username(), key='committer')
-        assert len(self.revision_list) == 1
-        rev = self.revision_list[0]
-        write(rev.committer, key='committer')
-        write(format_date(rev.timestamp, offset=rev.timezone), key='date')
-        write(str(self.revno), key='revno')
-        if rev.message:
-            self.to_file.write('# message:\n')
-            for line in rev.message.split('\n'):
-                self.to_file.write('#    %s\n' % line)
-        write(rev.revision_id, key='revision')
-
-        if self.base_revision:
-            write(self.base_revision.revision_id, key='precursor')
-            write(str(self.precursor_revno), key='precursor revno')
-
-
-        write('')
-        self.to_file.write('\n')
-
-    def _write_footer(self):
-        """Write the stuff that comes after the patches.
-
-        This is meant to be more meta-information, which people probably don't want
-        to read, but which is required for proper bzr operation.
-        """
-        write = self._write
-
-        write('BEGIN BZR FOOTER')
-
-        assert len(self.revision_list) == 1 # We only handle single revision entries
-        rev = self.revision_list[0]
-        write(self.branch.get_revision_sha1(rev.revision_id),
-                key='revision sha1')
-        if self.base_revision:
-            rev_id = self.base_revision.revision_id
-            write(self.branch.get_revision_sha1(rev_id),
-                    key='precursor sha1')
-
-        write('%.9f' % rev.timestamp, key='timestamp')
-        write(str(rev.timezone), key='timezone')
-
-        self._write_ids()
-
-        write('END BZR FOOTER')
-
-    def _write_revisions(self):
-        """Not used. Used for writing multiple revisions."""
-        first = True
-        for rev in self.revision_list:
-            if rev.revision_id is not None:
-                if first:
-                    self._write('revisions:')
-                    first = False
-                self._write(' '*4 + rev.revision_id + '\t' + self.branch.get_revision_sha1(rev.revision_id))
-
-
-    def _write_ids(self):
-        if hasattr(self.branch, 'get_root_id'):
-            root_id = self.branch.get_root_id()
-        else:
-            root_id = ROOT_ID
-
-        old_ids = set()
-        new_ids = set()
-
-        for path, file_id, kind in self.delta.removed:
-            old_ids.add(file_id)
-        for path, file_id, kind in self.delta.added:
-            new_ids.add(file_id)
-        for old_path, new_path, file_id, kind, text_modified in self.delta.renamed:
-            old_ids.add(file_id)
-            new_ids.add(file_id)
-        for path, file_id, kind in self.delta.modified:
-            new_ids.add(file_id)
-
-        self._write(root_id, key='tree root id')
-
-        def write_ids(tree, id_set, name):
-            if len(id_set) > 0:
-                self.to_file.write('# %s ids:\n' % name)
-            seen_ids = set([root_id])
-            while len(id_set) > 0:
-                file_id = id_set.pop()
-                if file_id in seen_ids:
-                    continue
-                seen_ids.add(file_id)
-                ie = tree.inventory[file_id]
-                if ie.parent_id not in seen_ids:
-                    id_set.add(ie.parent_id)
-                path = tree.inventory.id2path(file_id)
-                self.to_file.write('#    %s\t%s\t%s\n'
-                        % (path.encode('utf8'), file_id.encode('utf8'),
-                            ie.parent_id.encode('utf8')))
-        write_ids(self.new_tree, new_ids, 'file')
-        write_ids(self.old_tree, old_ids, 'old file')
-
-    def _write_diffs(self):
-        """Write out the specific diffs"""
-        from bzrlib.diff import internal_diff, external_diff
-        DEVNULL = '/dev/null'
-
-        if self.external_diff_options:
-            assert isinstance(self.external_diff_options, basestring)
-            opts = self.external_diff_options.split()
-            def diff_file(olab, olines, nlab, nlines, to_file):
-                external_diff(olab, olines, nlab, nlines, to_file, opts)
-        else:
-            diff_file = internal_diff
-
-        for path, file_id, kind in self.delta.removed:
-            print >>self.to_file, '*** removed %s %r' % (kind, path)
-            if kind == 'file' and self.full_remove:
-                diff_file(self.old_label + path,
-                          self.old_tree.get_file(file_id).readlines(),
-                          DEVNULL, 
-                          [],
-                          self.to_file)
-    
-        for path, file_id, kind in self.delta.added:
-            print >>self.to_file, '*** added %s %r' % (kind, path)
-            if kind == 'file':
-                diff_file(DEVNULL,
-                          [],
-                          self.new_label + path,
-                          self.new_tree.get_file(file_id).readlines(),
-                          self.to_file)
-    
-        for old_path, new_path, file_id, kind, text_modified in self.delta.renamed:
-            print >>self.to_file, '*** renamed %s %r => %r' % (kind, old_path, new_path)
-            if self.full_rename and kind == 'file':
-                diff_file(self.old_label + old_path,
-                          self.old_tree.get_file(file_id).readlines(),
-                          DEVNULL, 
-                          [],
-                          self.to_file)
-                diff_file(DEVNULL,
-                          [],
-                          self.new_label + new_path,
-                          self.new_tree.get_file(file_id).readlines(),
-                          self.to_file)
-            elif text_modified:
-                    diff_file(self.old_label + old_path,
-                              self.old_tree.get_file(file_id).readlines(),
-                              self.new_label + new_path,
-                              self.new_tree.get_file(file_id).readlines(),
-                              self.to_file)
-    
-        for path, file_id, kind in self.delta.modified:
-            print >>self.to_file, '*** modified %s %r' % (kind, path)
-            if kind == 'file':
-                diff_file(self.old_label + path,
-                          self.old_tree.get_file(file_id).readlines(),
-                          self.new_label + path,
-                          self.new_tree.get_file(file_id).readlines(),
-                          self.to_file)
-
-def show_changeset(branch, revision=None, specific_files=None,
-        external_diff_options=None, to_file=None,
-        include_full_diff=False):
-    from bzrlib.diff import compare_trees
-
-    if to_file is None:
-        import sys
-        to_file = sys.stdout
-    revisions = _canonicalize_revision(branch, revision)
-
-    old_tree, new_tree = _get_trees(branch, revisions)
-
-    delta = compare_trees(old_tree, new_tree, want_unchanged=False,
-                          specific_files=specific_files)
-
-    meta = MetaInfoHeader(branch, revisions, delta,
-            external_diff_options=external_diff_options,
-            old_tree=old_tree, new_tree=new_tree)
-    meta.write_meta_info(to_file)
-
-

=== removed file 'plugins/changeset/read_changeset.py'
--- plugins/changeset/read_changeset.py	2005-06-22 09:08:43 +0000
+++ plugins/changeset/read_changeset.py	1970-01-01 00:00:00 +0000
@@ -1,342 +0,0 @@
-#!/usr/bin/env python
-"""\
-Read in a changeset output, and process it into a Changeset object.
-"""
-
-import bzrlib, bzrlib.changeset
-import common
-
-class BadChangeset(Exception): pass
-class MalformedHeader(BadChangeset): pass
-class MalformedPatches(BadChangeset): pass
-class MalformedFooter(BadChangeset): pass
-
-def _unescape(name):
-    """Now we want to find the filename effected.
-    Unfortunately the filename is written out as
-    repr(filename), which means that it surrounds
-    the name with quotes which may be single or double
-    (single is preferred unless there is a single quote in
-    the filename). And some characters will be escaped.
-
-    TODO:   There has to be some pythonic way of undo-ing the
-            representation of a string rather than using eval.
-    """
-    delimiter = name[0]
-    if name[-1] != delimiter:
-        raise BadChangeset('Could not properly parse the'
-                ' filename: %r' % name)
-    # We need to handle escaped hexadecimals too.
-    return name[1:-1].replace('\"', '"').replace("\'", "'")
-
-class ChangesetInfo(object):
-    """This is the intermediate class that gets filled out as
-    the file is read.
-    """
-    def __init__(self):
-        self.committer = None
-        self.date = None
-        self.message = None
-        self.revno = None
-        self.revision = None
-        self.revision_sha1 = None
-        self.precursor = None
-        self.precursor_sha1 = None
-        self.precursor_revno = None
-
-        self.timestamp = None
-        self.timezone = None
-
-        self.tree_root_id = None
-        self.file_ids = None
-        self.old_file_ids = None
-
-        self.actions = [] #this is the list of things that happened
-        self.id2path = {} # A mapping from file id to path name
-        self.path2id = {} # The reverse mapping
-        self.id2parent = {} # A mapping from a given id to it's parent id
-
-        self.old_id2path = {}
-        self.old_path2id = {}
-        self.old_id2parent = {}
-
-    def __str__(self):
-        import pprint
-        return pprint.pformat(self.__dict__)
-
-    def create_maps(self):
-        """Go through the individual id sections, and generate the 
-        id2path and path2id maps.
-        """
-        # Rather than use an empty path, the changeset code seems 
-        # to like to use "./." for the tree root.
-        self.id2path[self.tree_root_id] = './.'
-        self.path2id['./.'] = self.tree_root_id
-        self.id2parent[self.tree_root_id] = bzrlib.changeset.NULL_ID
-        self.old_id2path = self.id2path.copy()
-        self.old_path2id = self.path2id.copy()
-        self.old_id2parent = self.id2parent.copy()
-
-        if self.file_ids:
-            for info in self.file_ids:
-                path, f_id, parent_id = info.split('\t')
-                self.id2path[f_id] = path
-                self.path2id[path] = f_id
-                self.id2parent[f_id] = parent_id
-        if self.old_file_ids:
-            for info in self.old_file_ids:
-                path, f_id, parent_id = info.split('\t')
-                self.old_id2path[f_id] = path
-                self.old_path2id[path] = f_id
-                self.old_id2parent[f_id] = parent_id
-
-    def get_changeset(self):
-        """Create a changeset from the data contained within."""
-        from bzrlib.changeset import Changeset, ChangesetEntry, \
-            PatchApply, ReplaceContents
-        cset = Changeset()
-        
-        entry = ChangesetEntry(self.tree_root_id, 
-                bzrlib.changeset.NULL_ID, './.')
-        cset.add_entry(entry)
-        for info, lines in self.actions:
-            parts = info.split(' ')
-            action = parts[0]
-            kind = parts[1]
-            extra = ' '.join(parts[2:])
-            if action == 'renamed':
-                old_path, new_path = extra.split(' => ')
-                old_path = _unescape(old_path)
-                new_path = _unescape(new_path)
-
-                new_id = self.path2id[new_path]
-                old_id = self.old_path2id[old_path]
-                assert old_id == new_id
-
-                new_parent = self.id2parent[new_id]
-                old_parent = self.old_id2parent[old_id]
-
-                entry = ChangesetEntry(old_id, old_parent, old_path)
-                entry.new_path = new_path
-                entry.new_parent = new_parent
-                if lines:
-                    entry.contents_change = PatchApply(''.join(lines))
-            elif action == 'removed':
-                old_path = _unescape(extra)
-                old_id = self.old_path2id[old_path]
-                old_parent = self.old_id2parent[old_id]
-                entry = ChangesetEntry(old_id, old_parent, old_path)
-                entry.new_path = None
-                entry.new_parent = None
-                if lines:
-                    # Technically a removed should be a ReplaceContents()
-                    # Where you need to have the old contents
-                    # But at most we have a remove style patch.
-                    #entry.contents_change = ReplaceContents()
-                    pass
-            elif action == 'added':
-                new_path = _unescape(extra)
-                new_id = self.path2id[new_path]
-                new_parent = self.id2parent[new_id]
-                entry = ChangesetEntry(new_id, new_parent, new_path)
-                entry.path = None
-                entry.parent = None
-                if lines:
-                    # Technically an added should be a ReplaceContents()
-                    # Where you need to have the old contents
-                    # But at most we have an add style patch.
-                    #entry.contents_change = ReplaceContents()
-                    entry.contents_change = PatchApply(''.join(lines))
-            elif action == 'modified':
-                new_path = _unescape(extra)
-                new_id = self.path2id[new_path]
-                new_parent = self.id2parent[new_id]
-                entry = ChangesetEntry(new_id, new_parent, new_path)
-                entry.path = None
-                entry.parent = None
-                if lines:
-                    # Technically an added should be a ReplaceContents()
-                    # Where you need to have the old contents
-                    # But at most we have an add style patch.
-                    #entry.contents_change = ReplaceContents()
-                    entry.contents_change = PatchApply(''.join(lines))
-            else:
-                raise BadChangeset('Unrecognized action: %r' % action)
-            cset.add_entry(entry)
-        return cset
-
-class ChangesetReader(object):
-    """This class reads in a changeset from a file, and returns
-    a Changeset object, which can then be applied against a tree.
-    """
-    def __init__(self, from_file):
-        """Read in the changeset from the file.
-
-        :param from_file: A file-like object (must have iterator support).
-        """
-        object.__init__(self)
-        self.from_file = from_file
-        
-        self.info = ChangesetInfo()
-        # We put the actual inventory ids in the footer, so that the patch
-        # is easier to read for humans.
-        # Unfortunately, that means we need to read everything before we
-        # can create a proper changeset.
-        self._read_header()
-        next_line = self._read_patches()
-        if next_line is not None:
-            self._read_footer(next_line)
-
-    def get_info(self):
-        """Create the actual changeset object.
-        """
-        self.info.create_maps()
-        return self.info
-
-    def _read_header(self):
-        """Read the bzr header"""
-        header = common.get_header()
-        for head_line, line in zip(header, self.from_file):
-            if (line[:2] != '# '
-                    or line[-1] != '\n'
-                    or line[2:-1] != head_line):
-                raise MalformedHeader('Did not read the opening'
-                    ' header information.')
-
-        for line in self.from_file:
-            if self._handle_info_line(line) is not None:
-                break
-
-    def _handle_info_line(self, line, in_footer=False):
-        """Handle reading a single line.
-
-        This may call itself, in the case that we read_multi,
-        and then had a dangling line on the end.
-        """
-        # The bzr header is terminated with a blank line
-        # which does not start with #
-        next_line = None
-        if line[:1] == '\n':
-            return 'break'
-        if line[:2] != '# ':
-            raise MalformedHeader('Opening bzr header did not start with #')
-
-        line = line[2:-1] # Remove the '# '
-        if not line:
-            return # Ignore blank lines
-
-        if in_footer and line in ('BEGIN BZR FOOTER', 'END BZR FOOTER'):
-            return
-
-        loc = line.find(': ')
-        if loc != -1:
-            key = line[:loc]
-            value = line[loc+2:]
-            if not value:
-                value, next_line = self._read_many()
-        else:
-            if line[-1:] == ':':
-                key = line[:-1]
-                value, next_line = self._read_many()
-            else:
-                raise MalformedHeader('While looking for key: value pairs,'
-                        ' did not find the colon %r' % (line))
-
-        key = key.replace(' ', '_')
-        if hasattr(self.info, key):
-            if getattr(self.info, key) is None:
-                setattr(self.info, key, value)
-            else:
-                raise MalformedHeader('Duplicated Key: %s' % key)
-        else:
-            # What do we do with a key we don't recognize
-            raise MalformedHeader('Unknown Key: %s' % key)
-        
-        if next_line:
-            self._handle_info_line(next_line, in_footer=in_footer)
-
-    def _read_many(self):
-        """If a line ends with no entry, that means that it should be
-        followed with multiple lines of values.
-
-        This detects the end of the list, because it will be a line that
-        does not start with '#    '. Because it has to read that extra
-        line, it returns the tuple: (values, next_line)
-        """
-        values = []
-        for line in self.from_file:
-            if line[:5] != '#    ':
-                return values, line
-            values.append(line[5:-1])
-        return values, None
-
-    def _read_one_patch(self, first_line=None):
-        """Read in one patch, return the complete patch, along with
-        the next line.
-
-        :return: action, lines, next_line, do_continue
-        """
-        first = True
-        action = None
-
-        def parse_firstline(line):
-            if line[:1] == '#':
-                return None
-            if line[:3] != '***':
-                raise MalformedPatches('The first line of all patches'
-                    ' should be a bzr meta line "***"')
-            return line[4:-1]
-
-        if first_line is not None:
-            action = parse_firstline(first_line)
-            first = False
-            if action is None:
-                return None, [], first_line, False
-
-        lines = []
-        for line in self.from_file:
-            if first:
-                action = parse_firstline(line)
-                first = False
-                if action is None:
-                    return None, [], line, False
-            else:
-                if line[:3] == '***':
-                    return action, lines, line, True
-                elif line[:1] == '#':
-                    return action, lines, line, False
-                lines.append(line)
-        return action, lines, None, False
-            
-    def _read_patches(self):
-        next_line = None
-        do_continue = True
-        while do_continue:
-            action, lines, next_line, do_continue = \
-                    self._read_one_patch(next_line)
-            if action is not None:
-                self.info.actions.append((action, lines))
-        return next_line
-
-    def _read_footer(self, first_line=None):
-        """Read the rest of the meta information.
-
-        :param first_line:  The previous step iterates past what it
-                            can handle. That extra line is given here.
-        """
-        if first_line is not None:
-            if self._handle_info_line(first_line, in_footer=True) is not None:
-                return
-        for line in self.from_file:
-            if self._handle_info_line(line, in_footer=True) is not None:
-                break
-
-
-def read_changeset(from_file):
-    """Read in a changeset from a filelike object (must have "readline" support), and
-    parse it into a Changeset object.
-    """
-    cr = ChangesetReader(from_file)
-    info = cr.get_info()
-    return info
-

=== removed file 'plugins/checkperms'
--- plugins/checkperms	2005-06-27 05:14:15 +0000
+++ plugins/checkperms	1970-01-01 00:00:00 +0000
@@ -1,5 +0,0 @@
-#! /bin/sh -ex
-
-root=`bzr root`
-
-find $root \! -perm -0444 
\ No newline at end of file

=== removed file 'testsweet.py'
--- testsweet.py	2005-07-22 23:31:09 +0000
+++ testsweet.py	1970-01-01 00:00:00 +0000
@@ -1,366 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Enhanced layer on unittest.
-
-This does several things:
-
-* nicer reporting as tests run
-
-* test code can log messages into a buffer that is recorded to disk
-  and displayed if the test fails
-
-* tests can be run in a separate directory, which is useful for code that
-  wants to create files
-
-* utilities to run external commands and check their return code
-  and/or output
-
-Test cases should normally subclass TestBase.  The test runner should
-call runsuite().
-
-This is meant to become independent of bzr, though that's not quite
-true yet.
-"""  
-
-
-from unittest import TestResult, TestCase
-
-def _need_subprocess():
-    sys.stderr.write("sorry, this test suite requires the subprocess module\n"
-                     "this is shipped with python2.4 and available separately for 2.3\n")
-    
-
-class CommandFailed(Exception):
-    pass
-
-
-
-class TestSkipped(Exception):
-    """Indicates that a test was intentionally skipped, rather than failing."""
-    # XXX: Not used yet
-
-
-class TestBase(TestCase):
-    """Base class for bzr test cases.
-
-    Just defines some useful helper functions; doesn't actually test
-    anything.
-    """
-    
-    # TODO: Special methods to invoke bzr, so that we can run it
-    # through a specified Python intepreter
-
-    OVERRIDE_PYTHON = None # to run with alternative python 'python'
-    BZRPATH = 'bzr'
-
-    _log_buf = ""
-
-
-    def setUp(self):
-        super(TestBase, self).setUp()
-        self.log("%s setup" % self.id())
-
-
-    def tearDown(self):
-        super(TestBase, self).tearDown()
-        self.log("%s teardown" % self.id())
-        self.log('')
-
-
-    def formcmd(self, cmd):
-        if isinstance(cmd, basestring):
-            cmd = cmd.split()
-
-        if cmd[0] == 'bzr':
-            cmd[0] = self.BZRPATH
-            if self.OVERRIDE_PYTHON:
-                cmd.insert(0, self.OVERRIDE_PYTHON)
-
-        self.log('$ %r' % cmd)
-
-        return cmd
-
-
-    def runcmd(self, cmd, retcode=0):
-        """Run one command and check the return code.
-
-        Returns a tuple of (stdout,stderr) strings.
-
-        If a single string is based, it is split into words.
-        For commands that are not simple space-separated words, please
-        pass a list instead."""
-        try:
-            import shutil
-            from subprocess import call
-        except ImportError, e:
-            _need_subprocess()
-            raise
-
-
-        cmd = self.formcmd(cmd)
-
-        self.log('$ ' + ' '.join(cmd))
-        actual_retcode = call(cmd, stdout=self.TEST_LOG, stderr=self.TEST_LOG)
-
-        if retcode != actual_retcode:
-            raise CommandFailed("test failed: %r returned %d, expected %d"
-                                % (cmd, actual_retcode, retcode))
-
-
-    def backtick(self, cmd, retcode=0):
-        """Run a command and return its output"""
-        try:
-            import shutil
-            from subprocess import Popen, PIPE
-        except ImportError, e:
-            _need_subprocess()
-            raise
-
-        cmd = self.formcmd(cmd)
-        child = Popen(cmd, stdout=PIPE, stderr=self.TEST_LOG)
-        outd, errd = child.communicate()
-        self.log(outd)
-        actual_retcode = child.wait()
-
-        outd = outd.replace('\r', '')
-
-        if retcode != actual_retcode:
-            raise CommandFailed("test failed: %r returned %d, expected %d"
-                                % (cmd, actual_retcode, retcode))
-
-        return outd
-
-
-
-    def build_tree(self, shape):
-        """Build a test tree according to a pattern.
-
-        shape is a sequence of file specifications.  If the final
-        character is '/', a directory is created.
-
-        This doesn't add anything to a branch.
-        """
-        # XXX: It's OK to just create them using forward slashes on windows?
-        import os
-        for name in shape:
-            assert isinstance(name, basestring)
-            if name[-1] == '/':
-                os.mkdir(name[:-1])
-            else:
-                f = file(name, 'wt')
-                print >>f, "contents of", name
-                f.close()
-
-
-    def log(self, msg):
-        """Log a message to a progress file"""
-        self._log_buf = self._log_buf + str(msg) + '\n'
-        print >>self.TEST_LOG, msg
-
-
-    def check_inventory_shape(self, inv, shape):
-        """
-        Compare an inventory to a list of expected names.
-
-        Fail if they are not precisely equal.
-        """
-        extras = []
-        shape = list(shape)             # copy
-        for path, ie in inv.entries():
-            name = path.replace('\\', '/')
-            if ie.kind == 'dir':
-                name = name + '/'
-            if name in shape:
-                shape.remove(name)
-            else:
-                extras.append(name)
-        if shape:
-            self.fail("expected paths not found in inventory: %r" % shape)
-        if extras:
-            self.fail("unexpected paths found in inventory: %r" % extras)
-
-
-    def check_file_contents(self, filename, expect):
-        self.log("check contents of file %s" % filename)
-        contents = file(filename, 'r').read()
-        if contents != expect:
-            self.log("expected: %r" % expect)
-            self.log("actually: %r" % contents)
-            self.fail("contents of %s not as expected")
-            
-
-
-class InTempDir(TestBase):
-    """Base class for tests run in a temporary branch."""
-    def setUp(self):
-        import os
-        self.test_dir = os.path.join(self.TEST_ROOT, self.__class__.__name__)
-        os.mkdir(self.test_dir)
-        os.chdir(self.test_dir)
-        
-    def tearDown(self):
-        import os
-        os.chdir(self.TEST_ROOT)
-
-
-
-
-
-class _MyResult(TestResult):
-    """
-    Custom TestResult.
-
-    No special behaviour for now.
-    """
-    def __init__(self, out, style):
-        self.out = out
-        TestResult.__init__(self)
-        assert style in ('none', 'progress', 'verbose')
-        self.style = style
-
-
-    def startTest(self, test):
-        # TODO: Maybe show test.shortDescription somewhere?
-        what = test.id()
-        # python2.3 has the bad habit of just "runit" for doctests
-        if what == 'runit':
-            what = test.shortDescription()
-        
-        if self.style == 'verbose':
-            print >>self.out, '%-60.60s' % what,
-            self.out.flush()
-        elif self.style == 'progress':
-            self.out.write('~')
-            self.out.flush()
-        TestResult.startTest(self, test)
-
-
-    def stopTest(self, test):
-        # print
-        TestResult.stopTest(self, test)
-
-
-    def addError(self, test, err):
-        if self.style == 'verbose':
-            print >>self.out, 'ERROR'
-        TestResult.addError(self, test, err)
-        _show_test_failure('error', test, err, self.out)
-
-    def addFailure(self, test, err):
-        if self.style == 'verbose':
-            print >>self.out, 'FAILURE'
-        TestResult.addFailure(self, test, err)
-        _show_test_failure('failure', test, err, self.out)
-
-    def addSuccess(self, test):
-        if self.style == 'verbose':
-            print >>self.out, 'OK'
-        TestResult.addSuccess(self, test)
-
-
-
-def run_suite(suite, name='test', verbose=False):
-    import os
-    import shutil
-    import time
-    import sys
-    
-    _setup_test_log(name)
-    _setup_test_dir(name)
-    print
-
-    # save stdout & stderr so there's no leakage from code-under-test
-    real_stdout = sys.stdout
-    real_stderr = sys.stderr
-    sys.stdout = sys.stderr = TestBase.TEST_LOG
-    try:
-        if verbose:
-            style = 'verbose'
-        else:
-            style = 'progress'
-        result = _MyResult(real_stdout, style)
-        suite.run(result)
-    finally:
-        sys.stdout = real_stdout
-        sys.stderr = real_stderr
-
-    _show_results(result)
-
-    return result.wasSuccessful()
-
-
-
-def _setup_test_log(name):
-    import time
-    import os
-    
-    log_filename = os.path.abspath(name + '.log')
-    TestBase.TEST_LOG = open(log_filename, 'wt', buffering=1) # line buffered
-
-    print >>TestBase.TEST_LOG, "tests run at " + time.ctime()
-    print '%-30s %s' % ('test log', log_filename)
-
-
-def _setup_test_dir(name):
-    import os
-    import shutil
-    
-    TestBase.ORIG_DIR = os.getcwdu()
-    TestBase.TEST_ROOT = os.path.abspath(name + '.tmp')
-
-    print '%-30s %s' % ('running tests in', TestBase.TEST_ROOT)
-
-    if os.path.exists(TestBase.TEST_ROOT):
-        shutil.rmtree(TestBase.TEST_ROOT)
-    os.mkdir(TestBase.TEST_ROOT)
-    os.chdir(TestBase.TEST_ROOT)
-
-    # make a fake bzr directory there to prevent any tests propagating
-    # up onto the source directory's real branch
-    os.mkdir(os.path.join(TestBase.TEST_ROOT, '.bzr'))
-
-    
-
-def _show_results(result):
-     print
-     print '%4d tests run' % result.testsRun
-     print '%4d errors' % len(result.errors)
-     print '%4d failures' % len(result.failures)
-
-
-
-def _show_test_failure(kind, case, exc_info, out):
-    from traceback import print_exception
-    
-    print >>out, '-' * 60
-    print >>out, case
-    
-    desc = case.shortDescription()
-    if desc:
-        print >>out, '   (%s)' % desc
-         
-    print_exception(exc_info[0], exc_info[1], exc_info[2], None, out)
-        
-    if isinstance(case, TestBase):
-        print >>out
-        print >>out, 'log from this test:'
-        print >>out, case._log_buf
-         
-    print >>out, '-' * 60
-    
-

=== removed directory 'tools'
=== removed file 'tools/convertfile.py'
--- tools/convertfile.py	2005-07-18 13:12:43 +0000
+++ tools/convertfile.py	1970-01-01 00:00:00 +0000
@@ -1,87 +0,0 @@
-#! /usr/bin/python
-
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Experiment in converting existing bzr branches to weaves."""
-
-
-import sys
-import bzrlib.branch
-from bzrlib.weave import Weave
-from bzrlib.weavefile import write_weave
-
-import hotshot
-import tempfile
-
-
-def convert():
-    WEAVE_NAME = "test.weave"
-
-    wf = Weave()
-
-    toconvert = sys.argv[1]
-    
-    b = bzrlib.branch.find_branch(toconvert)
-    rp = b.relpath(toconvert)
-
-    print 'converting...'
-
-    fid = b.read_working_inventory().path2id(rp)
-
-    last_lines = None
-    parents = set()
-    revno = 0
-    for rev_id in b.revision_history():
-        revno += 1
-        print revno
-        tree = b.revision_tree(rev_id)
-        inv = tree.inventory
-
-        if fid not in tree:
-            print '  (not present)'
-            continue
-
-        text = tree.get_file(fid).readlines()
-
-        if text == last_lines:
-            continue
-        last_lines = text
-        
-        weave_id = wf.add(parents, text)
-        parents = [weave_id]
-
-        print '  %4d lines' % len(text)
-
-    write_weave(wf, file(WEAVE_NAME, 'wb'))
-
-
-prof_f = tempfile.NamedTemporaryFile()
-
-prof = hotshot.Profile(prof_f.name)
-
-prof.runcall(convert) 
-prof.close()
-
-import hotshot.stats
-stats = hotshot.stats.load(prof_f.name)
-#stats.strip_dirs()
-stats.sort_stats('time')
-## XXX: Might like to write to stderr or the trace file instead but
-## print_stats seems hardcoded to stdout
-stats.print_stats(20)
-            
-

=== removed file 'tools/convertinv.py'
--- tools/convertinv.py	2005-07-11 04:53:07 +0000
+++ tools/convertinv.py	1970-01-01 00:00:00 +0000
@@ -1,75 +0,0 @@
-#! /usr/bin/python
-
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Experiment in converting existing bzr branches to weaves."""
-
-
-import bzrlib.branch
-from bzrlib.weave import Weave
-from bzrlib.weavefile import write_weave
-from bzrlib.progress import ProgressBar
-import tempfile
-import hotshot, hotshot.stats
-import sys
-
-def convert():
-    WEAVE_NAME = "inventory.weave"
-
-    pb = ProgressBar()
-
-    wf = Weave()
-
-    b = bzrlib.branch.find_branch('.')
-
-    parents = set()
-    revno = 1
-    rev_history = b.revision_history()
-    for rev_id in rev_history:
-        pb.update('converting inventory', revno, len(rev_history))
-        inv_xml = b.inventory_store[rev_id].readlines()
-        weave_id = wf.add(parents, inv_xml)
-        parents = set([weave_id])       # always just one parent
-        revno += 1
-
-    pb.update('write weave', None, None)
-    write_weave(wf, file(WEAVE_NAME, 'wb'))
-
-    pb.clear()
-
-
-def profile_convert(): 
-    prof_f = tempfile.NamedTemporaryFile()
-
-    prof = hotshot.Profile(prof_f.name)
-
-    prof.runcall(convert) 
-    prof.close()
-
-    stats = hotshot.stats.load(prof_f.name)
-    #stats.strip_dirs()
-    stats.sort_stats('time')
-    ## XXX: Might like to write to stderr or the trace file instead but
-    ## print_stats seems hardcoded to stdout
-    stats.print_stats(20)
-            
-
-if '-p' in sys.argv[1:]:
-    profile_convert()
-else:
-    convert()
-    

=== removed file 'tools/testweave.py'
--- tools/testweave.py	2005-07-18 14:28:13 +0000
+++ tools/testweave.py	1970-01-01 00:00:00 +0000
@@ -1,770 +0,0 @@
-#! /usr/bin/python2.4
-
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-
-
-"""test suite for weave algorithm"""
-
-
-import testsweet
-from bzrlib.weave import Weave, WeaveFormatError
-from bzrlib.weavefile import write_weave, read_weave
-from pprint import pformat
-
-
-try:
-    set
-    frozenset
-except NameError:
-    from sets import Set, ImmutableSet
-    set = Set
-    frozenset = ImmutableSet
-    del Set, ImmutableSet
-
-
-
-# texts for use in testing
-TEXT_0 = ["Hello world"]
-TEXT_1 = ["Hello world",
-          "A second line"]
-
-
-
-class TestBase(testsweet.TestBase):
-    def check_read_write(self, k):
-        """Check the weave k can be written & re-read."""
-        from tempfile import TemporaryFile
-        tf = TemporaryFile()
-
-        write_weave(k, tf)
-        tf.seek(0)
-        k2 = read_weave(tf)
-
-        if k != k2:
-            tf.seek(0)
-            self.log('serialized weave:')
-            self.log(tf.read())
-            self.fail('read/write check failed')
-        
-        
-
-
-class Easy(TestBase):
-    def runTest(self):
-        k = Weave()
-
-
-class StoreText(TestBase):
-    """Store and retrieve a simple text."""
-    def runTest(self):
-        k = Weave()
-        idx = k.add([], TEXT_0)
-        self.assertEqual(k.get(idx), TEXT_0)
-        self.assertEqual(idx, 0)
-
-
-
-class AnnotateOne(TestBase):
-    def runTest(self):
-        k = Weave()
-        k.add([], TEXT_0)
-        self.assertEqual(k.annotate(0),
-                         [(0, TEXT_0[0])])
-
-
-class StoreTwo(TestBase):
-    def runTest(self):
-        k = Weave()
-
-        idx = k.add([], TEXT_0)
-        self.assertEqual(idx, 0)
-
-        idx = k.add([], TEXT_1)
-        self.assertEqual(idx, 1)
-
-        self.assertEqual(k.get(0), TEXT_0)
-        self.assertEqual(k.get(1), TEXT_1)
-
-        k.dump(self.TEST_LOG)
-
-
-
-class InvalidAdd(TestBase):
-    """Try to use invalid version number during add."""
-    def runTest(self):
-        k = Weave()
-
-        self.assertRaises(IndexError,
-                          k.add,
-                          [69],
-                          ['new text!'])
-
-
-class InsertLines(TestBase):
-    """Store a revision that adds one line to the original.
-
-    Look at the annotations to make sure that the first line is matched
-    and not stored repeatedly."""
-    def runTest(self):
-        k = Weave()
-
-        k.add([], ['line 1'])
-        k.add([0], ['line 1', 'line 2'])
-
-        self.assertEqual(k.annotate(0),
-                         [(0, 'line 1')])
-
-        self.assertEqual(k.get(1),
-                         ['line 1',
-                          'line 2'])
-
-        self.assertEqual(k.annotate(1),
-                         [(0, 'line 1'),
-                          (1, 'line 2')])
-
-        k.add([0], ['line 1', 'diverged line'])
-
-        self.assertEqual(k.annotate(2),
-                         [(0, 'line 1'),
-                          (2, 'diverged line')])
-
-        text3 = ['line 1', 'middle line', 'line 2']
-        k.add([0, 1],
-              text3)
-
-        # self.log("changes to text3: " + pformat(list(k._delta(set([0, 1]), text3))))
-
-        self.log("k._weave=" + pformat(k._weave))
-
-        self.assertEqual(k.annotate(3),
-                         [(0, 'line 1'),
-                          (3, 'middle line'),
-                          (1, 'line 2')])
-
-        # now multiple insertions at different places
-        k.add([0, 1, 3],
-              ['line 1', 'aaa', 'middle line', 'bbb', 'line 2', 'ccc'])
-
-        self.assertEqual(k.annotate(4), 
-                         [(0, 'line 1'),
-                          (4, 'aaa'),
-                          (3, 'middle line'),
-                          (4, 'bbb'),
-                          (1, 'line 2'),
-                          (4, 'ccc')])
-
-
-
-class DeleteLines(TestBase):
-    """Deletion of lines from existing text.
-
-    Try various texts all based on a common ancestor."""
-    def runTest(self):
-        k = Weave()
-
-        base_text = ['one', 'two', 'three', 'four']
-
-        k.add([], base_text)
-        
-        texts = [['one', 'two', 'three'],
-                 ['two', 'three', 'four'],
-                 ['one', 'four'],
-                 ['one', 'two', 'three', 'four'],
-                 ]
-
-        for t in texts:
-            ver = k.add([0], t)
-
-        self.log('final weave:')
-        self.log('k._weave=' + pformat(k._weave))
-
-        for i in range(len(texts)):
-            self.assertEqual(k.get(i+1),
-                             texts[i])
-            
-
-
-
-class SuicideDelete(TestBase):
-    """Invalid weave which tries to add and delete simultaneously."""
-    def runTest(self):
-        k = Weave()
-
-        k._parents = [(),
-                ]
-        k._weave = [('{', 0),
-                'first line',
-                ('[', 0),
-                'deleted in 0',
-                (']', 0),
-                ('}', 0),
-                ]
-        ################################### SKIPPED
-        # Weave.get doesn't trap this anymore
-        return 
-
-        self.assertRaises(WeaveFormatError,
-                          k.get,
-                          0)        
-
-
-
-class CannedDelete(TestBase):
-    """Unpack canned weave with deleted lines."""
-    def runTest(self):
-        k = Weave()
-
-        k._parents = [(),
-                frozenset([0]),
-                ]
-        k._weave = [('{', 0),
-                'first line',
-                ('[', 1),
-                'line to be deleted',
-                (']', 1),
-                'last line',
-                ('}', 0),
-                ]
-
-        self.assertEqual(k.get(0),
-                         ['first line',
-                          'line to be deleted',
-                          'last line',
-                          ])
-
-        self.assertEqual(k.get(1),
-                         ['first line',
-                          'last line',
-                          ])
-
-
-
-class CannedReplacement(TestBase):
-    """Unpack canned weave with deleted lines."""
-    def runTest(self):
-        k = Weave()
-
-        k._parents = [frozenset(),
-                frozenset([0]),
-                ]
-        k._weave = [('{', 0),
-                'first line',
-                ('[', 1),
-                'line to be deleted',
-                (']', 1),
-                ('{', 1),
-                'replacement line',                
-                ('}', 1),
-                'last line',
-                ('}', 0),
-                ]
-
-        self.assertEqual(k.get(0),
-                         ['first line',
-                          'line to be deleted',
-                          'last line',
-                          ])
-
-        self.assertEqual(k.get(1),
-                         ['first line',
-                          'replacement line',
-                          'last line',
-                          ])
-
-
-
-class BadWeave(TestBase):
-    """Test that we trap an insert which should not occur."""
-    def runTest(self):
-        k = Weave()
-
-        k._parents = [frozenset(),
-                ]
-        k._weave = ['bad line',
-                ('{', 0),
-                'foo {',
-                ('{', 1),
-                '  added in version 1',
-                ('{', 2),
-                '  added in v2',
-                ('}', 2),
-                '  also from v1',
-                ('}', 1),
-                '}',
-                ('}', 0)]
-
-        ################################### SKIPPED
-        # Weave.get doesn't trap this anymore
-        return 
-
-
-        self.assertRaises(WeaveFormatError,
-                          k.get,
-                          0)
-
-
-class BadInsert(TestBase):
-    """Test that we trap an insert which should not occur."""
-    def runTest(self):
-        k = Weave()
-
-        k._parents = [frozenset(),
-                frozenset([0]),
-                frozenset([0]),
-                frozenset([0,1,2]),
-                ]
-        k._weave = [('{', 0),
-                'foo {',
-                ('{', 1),
-                '  added in version 1',
-                ('{', 1),
-                '  more in 1',
-                ('}', 1),
-                ('}', 1),
-                ('}', 0)]
-
-
-        # this is not currently enforced by get
-        return  ##########################################
-
-        self.assertRaises(WeaveFormatError,
-                          k.get,
-                          0)
-
-        self.assertRaises(WeaveFormatError,
-                          k.get,
-                          1)
-
-
-class InsertNested(TestBase):
-    """Insertion with nested instructions."""
-    def runTest(self):
-        k = Weave()
-
-        k._parents = [frozenset(),
-                frozenset([0]),
-                frozenset([0]),
-                frozenset([0,1,2]),
-                ]
-        k._weave = [('{', 0),
-                'foo {',
-                ('{', 1),
-                '  added in version 1',
-                ('{', 2),
-                '  added in v2',
-                ('}', 2),
-                '  also from v1',
-                ('}', 1),
-                '}',
-                ('}', 0)]
-
-        self.assertEqual(k.get(0),
-                         ['foo {',
-                          '}'])
-
-        self.assertEqual(k.get(1),
-                         ['foo {',
-                          '  added in version 1',
-                          '  also from v1',
-                          '}'])
-                       
-        self.assertEqual(k.get(2),
-                         ['foo {',
-                          '  added in v2',
-                          '}'])
-
-        self.assertEqual(k.get(3),
-                         ['foo {',
-                          '  added in version 1',
-                          '  added in v2',
-                          '  also from v1',
-                          '}'])
-                         
-
-
-class DeleteLines2(TestBase):
-    """Test recording revisions that delete lines.
-
-    This relies on the weave having a way to represent lines knocked
-    out by a later revision."""
-    def runTest(self):
-        k = Weave()
-
-        k.add([], ["line the first",
-                   "line 2",
-                   "line 3",
-                   "fine"])
-
-        self.assertEqual(len(k.get(0)), 4)
-
-        k.add([0], ["line the first",
-                   "fine"])
-
-        self.assertEqual(k.get(1),
-                         ["line the first",
-                          "fine"])
-
-        self.assertEqual(k.annotate(1),
-                         [(0, "line the first"),
-                          (0, "fine")])
-
-
-
-class IncludeVersions(TestBase):
-    """Check texts that are stored across multiple revisions.
-
-    Here we manually create a weave with particular encoding and make
-    sure it unpacks properly.
-
-    Text 0 includes nothing; text 1 includes text 0 and adds some
-    lines.
-    """
-
-    def runTest(self):
-        k = Weave()
-
-        k._parents = [frozenset(), frozenset([0])]
-        k._weave = [('{', 0),
-                "first line",
-                ('}', 0),
-                ('{', 1),
-                "second line",
-                ('}', 1)]
-
-        self.assertEqual(k.get(1),
-                         ["first line",
-                          "second line"])
-
-        self.assertEqual(k.get(0),
-                         ["first line"])
-
-        k.dump(self.TEST_LOG)
-
-
-class DivergedIncludes(TestBase):
-    """Weave with two diverged texts based on version 0.
-    """
-    def runTest(self):
-        k = Weave()
-
-        k._parents = [frozenset(),
-                frozenset([0]),
-                frozenset([0]),
-                ]
-        k._weave = [('{', 0),
-                "first line",
-                ('}', 0),
-                ('{', 1),
-                "second line",
-                ('}', 1),
-                ('{', 2),
-                "alternative second line",
-                ('}', 2),                
-                ]
-
-        self.assertEqual(k.get(0),
-                         ["first line"])
-
-        self.assertEqual(k.get(1),
-                         ["first line",
-                          "second line"])
-
-        self.assertEqual(k.get(2),
-                         ["first line",
-                          "alternative second line"])
-
-        self.assertEqual(list(k.inclusions([2])),
-                         [0, 2])
-
-
-
-class ReplaceLine(TestBase):
-    def runTest(self):
-        k = Weave()
-
-        text0 = ['cheddar', 'stilton', 'gruyere']
-        text1 = ['cheddar', 'blue vein', 'neufchatel', 'chevre']
-        
-        k.add([], text0)
-        k.add([0], text1)
-
-        self.log('k._weave=' + pformat(k._weave))
-
-        self.assertEqual(k.get(0), text0)
-        self.assertEqual(k.get(1), text1)
-
-
-
-class Merge(TestBase):
-    """Storage of versions that merge diverged parents"""
-    def runTest(self):
-        k = Weave()
-
-        texts = [['header'],
-                 ['header', '', 'line from 1'],
-                 ['header', '', 'line from 2', 'more from 2'],
-                 ['header', '', 'line from 1', 'fixup line', 'line from 2'],
-                 ]
-
-        k.add([], texts[0])
-        k.add([0], texts[1])
-        k.add([0], texts[2])
-        k.add([0, 1, 2], texts[3])
-
-        for i, t in enumerate(texts):
-            self.assertEqual(k.get(i), t)
-
-        self.assertEqual(k.annotate(3),
-                         [(0, 'header'),
-                          (1, ''),
-                          (1, 'line from 1'),
-                          (3, 'fixup line'),
-                          (2, 'line from 2'),
-                          ])
-
-        self.assertEqual(list(k.inclusions([3])),
-                         [0, 1, 2, 3])
-
-        self.log('k._weave=' + pformat(k._weave))
-
-        self.check_read_write(k)
-
-
-class Conflicts(TestBase):
-    """Test detection of conflicting regions during a merge.
-
-    A base version is inserted, then two descendents try to
-    insert different lines in the same place.  These should be
-    reported as a possible conflict and forwarded to the user."""
-    def runTest(self):
-        return  # NOT RUN
-        k = Weave()
-
-        k.add([], ['aaa', 'bbb'])
-        k.add([0], ['aaa', '111', 'bbb'])
-        k.add([1], ['aaa', '222', 'bbb'])
-
-        merged = k.merge([1, 2])
-
-        self.assertEquals([[['aaa']],
-                           [['111'], ['222']],
-                           [['bbb']]])
-
-
-
-class NonConflict(TestBase):
-    """Two descendants insert compatible changes.
-
-    No conflict should be reported."""
-    def runTest(self):
-        return  # NOT RUN
-        k = Weave()
-
-        k.add([], ['aaa', 'bbb'])
-        k.add([0], ['111', 'aaa', 'ccc', 'bbb'])
-        k.add([1], ['aaa', 'ccc', 'bbb', '222'])
-
-    
-    
-
-
-class AutoMerge(TestBase):
-    def runTest(self):
-        k = Weave()
-
-        texts = [['header', 'aaa', 'bbb'],
-                 ['header', 'aaa', 'line from 1', 'bbb'],
-                 ['header', 'aaa', 'bbb', 'line from 2', 'more from 2'],
-                 ]
-
-        k.add([], texts[0])
-        k.add([0], texts[1])
-        k.add([0], texts[2])
-
-        self.log('k._weave=' + pformat(k._weave))
-
-        m = list(k.mash_iter([0, 1, 2]))
-
-        self.assertEqual(m,
-                         ['header', 'aaa',
-                          'line from 1',
-                          'bbb',
-                          'line from 2', 'more from 2'])
-        
-
-
-class Khayyam(TestBase):
-    """Test changes to multi-line texts, and read/write"""
-    def runTest(self):
-        rawtexts = [
-            """A Book of Verses underneath the Bough,
-            A Jug of Wine, a Loaf of Bread, -- and Thou
-            Beside me singing in the Wilderness --
-            Oh, Wilderness were Paradise enow!""",
-            
-            """A Book of Verses underneath the Bough,
-            A Jug of Wine, a Loaf of Bread, -- and Thou
-            Beside me singing in the Wilderness --
-            Oh, Wilderness were Paradise now!""",
-
-            """A Book of poems underneath the tree,
-            A Jug of Wine, a Loaf of Bread,
-            and Thou
-            Beside me singing in the Wilderness --
-            Oh, Wilderness were Paradise now!
-
-            -- O. Khayyam""",
-
-            """A Book of Verses underneath the Bough,
-            A Jug of Wine, a Loaf of Bread,
-            and Thou
-            Beside me singing in the Wilderness --
-            Oh, Wilderness were Paradise now!""",
-            ]
-        texts = [[l.strip() for l in t.split('\n')] for t in rawtexts]
-
-        k = Weave()
-        parents = set()
-        for t in texts:
-            ver = k.add(list(parents), t)
-            parents.add(ver)
-
-        self.log("k._weave=" + pformat(k._weave))
-
-        for i, t in enumerate(texts):
-            self.assertEqual(k.get(i), t)
-
-        self.check_read_write(k)
-
-
-
-class MergeCases(TestBase):
-    def doMerge(self, base, a, b, mp):
-        from cStringIO import StringIO
-        from textwrap import dedent
-
-        def addcrlf(x):
-            return x + '\n'
-        
-        w = Weave()
-        w.add([], map(addcrlf, base))
-        w.add([0], map(addcrlf, a))
-        w.add([0], map(addcrlf, b))
-
-        self.log('weave is:')
-        tmpf = StringIO()
-        write_weave(w, tmpf)
-        self.log(tmpf.getvalue())
-
-        self.log('merge plan:')
-        p = list(w.plan_merge(1, 2))
-        for state, line in p:
-            if line:
-                self.log('%12s | %s' % (state, line[:-1]))
-
-        self.log('merge:')
-        mt = StringIO()
-        mt.writelines(w.weave_merge(p))
-        mt.seek(0)
-        self.log(mt.getvalue())
-
-        mp = map(addcrlf, mp)
-        self.assertEqual(mt.readlines(), mp)
-        
-        
-    def testOneInsert(self):
-        self.doMerge([],
-                     ['aa'],
-                     [],
-                     ['aa'])
-
-    def testSeparateInserts(self):
-        self.doMerge(['aaa', 'bbb', 'ccc'],
-                     ['aaa', 'xxx', 'bbb', 'ccc'],
-                     ['aaa', 'bbb', 'yyy', 'ccc'],
-                     ['aaa', 'xxx', 'bbb', 'yyy', 'ccc'])
-
-    def testSameInsert(self):
-        self.doMerge(['aaa', 'bbb', 'ccc'],
-                     ['aaa', 'xxx', 'bbb', 'ccc'],
-                     ['aaa', 'xxx', 'bbb', 'yyy', 'ccc'],
-                     ['aaa', 'xxx', 'bbb', 'yyy', 'ccc'])
-
-    def testOverlappedInsert(self):
-        self.doMerge(['aaa', 'bbb'],
-                     ['aaa', 'xxx', 'yyy', 'bbb'],
-                     ['aaa', 'xxx', 'bbb'],
-                     ['aaa', '<<<<', 'xxx', 'yyy', '====', 'xxx', '>>>>', 'bbb'])
-
-        # really it ought to reduce this to 
-        # ['aaa', 'xxx', 'yyy', 'bbb']
-
-
-    def testClashReplace(self):
-        self.doMerge(['aaa'],
-                     ['xxx'],
-                     ['yyy', 'zzz'],
-                     ['<<<<', 'xxx', '====', 'yyy', 'zzz', '>>>>'])
-
-    def testNonClashInsert(self):
-        self.doMerge(['aaa'],
-                     ['xxx', 'aaa'],
-                     ['yyy', 'zzz'],
-                     ['<<<<', 'xxx', 'aaa', '====', 'yyy', 'zzz', '>>>>'])
-
-        self.doMerge(['aaa'],
-                     ['aaa'],
-                     ['yyy', 'zzz'],
-                     ['yyy', 'zzz'])
-
-
-    def testDeleteAndModify(self):
-        """Clashing delete and modification.
-
-        If one side modifies a region and the other deletes it then
-        there should be a conflict with one side blank.
-        """
-
-        #######################################
-        # skippd, not working yet
-        return
-        
-        self.doMerge(['aaa', 'bbb', 'ccc'],
-                     ['aaa', 'ddd', 'ccc'],
-                     ['aaa', 'ccc'],
-                     ['<<<<', 'aaa', '====', '>>>>', 'ccc'])
-    
-
-
-def testweave():
-    import testsweet
-    from unittest import TestSuite, TestLoader
-    import testweave
-
-    tl = TestLoader()
-    suite = TestSuite()
-    suite.addTest(tl.loadTestsFromModule(testweave))
-    
-    return int(not testsweet.run_suite(suite)) # for shell 0=true
-
-
-if __name__ == '__main__':
-    import sys
-    sys.exit(testweave())
-    

=== removed file 'tools/weavebench.py'
--- tools/weavebench.py	2005-07-18 11:23:40 +0000
+++ tools/weavebench.py	1970-01-01 00:00:00 +0000
@@ -1,106 +0,0 @@
-#! /usr/bin/python
-
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Weave algorithms benchmark"""
-
-import bzrlib.branch
-from bzrlib.weave import Weave
-from bzrlib.weavefile import write_weave
-from bzrlib.progress import ProgressBar
-from random import randrange, randint, seed
-import tempfile
-import hotshot, hotshot.stats
-import sys
-
-WEAVE_NAME = "bench.weave"
-NUM_REVS = 2000
-
-seed(0)
-
-def build():
-    pb = ProgressBar(show_eta=False)
-
-    wf = Weave()
-    lines = []
-
-    parents = []
-    for i in xrange(NUM_REVS):
-        pb.update('building', i, NUM_REVS)
-
-        for j in range(randint(0, 4)):
-            o = randint(0, len(lines))
-            lines.insert(o, "new in version %i\n" % i)
-
-        for j in range(randint(0, 2)):
-            if lines:
-                del lines[randrange(0, len(lines))]
-
-        rev_id = wf.add(parents, lines)
-        parents = [rev_id]
-
-    write_weave(wf, file(WEAVE_NAME, 'wb'))
-
-        
-#     parents = set()
-#     revno = 1
-#     rev_history = b.revision_history()
-#     for rev_id in rev_history:
-#         pb.update('converting inventory', revno, len(rev_history))
-#         inv_xml = b.inventory_store[rev_id].readlines()
-#         weave_id = wf.add(parents, inv_xml)
-#         parents = set([weave_id])       # always just one parent
-#         revno += 1
-
-#     pb.update('write weave', None, None)
-#     write_weave(wf, file(WEAVE_NAME, 'wb'))
-
-    pb.clear()
-
-
-
-def profileit(fn): 
-    prof_f = tempfile.NamedTemporaryFile()
-
-    prof = hotshot.Profile(prof_f.name)
-
-    prof.runcall(fn) 
-    prof.close()
-
-    stats = hotshot.stats.load(prof_f.name)
-    #stats.strip_dirs()
-    stats.sort_stats('time')
-    ## XXX: Might like to write to stderr or the trace file instead but
-    ## print_stats seems hardcoded to stdout
-    stats.print_stats(20)
-            
-
-if '-p' in sys.argv[1:]:
-    opt_p = True
-    sys.argv.remove('-p')
-else:
-    opt_p = False
-
-if len(sys.argv) > 1:
-    NUM_REVS = int(sys.argv[1])
-
-if opt_p:
-    profileit(build)
-else:
-    build()
-    

=== removed file 'tools/weavemerge.sh'
--- tools/weavemerge.sh	2005-07-15 22:55:36 +0000
+++ tools/weavemerge.sh	1970-01-01 00:00:00 +0000
@@ -1,57 +0,0 @@
-#! /bin/zsh -xe
-
-weave init test.weave
-
-weave add test.weave <<EOF
-aaa
-bbb
-ccc
-EOF
-
-weave add test.weave 0 <<EOF
-aaa
-bbb
-stuff from martin
-ccc
-ddd
-EOF
-
-weave add test.weave 0 <<EOF
-aaa
-bbb
-stuff from john
-more john stuff
-ccc
-EOF
-
-weave add test.weave 1 2 <<EOF
-aaa
-bbb
-stuff from martin
-fix up merge
-more john stuff
-ccc
-ddd
-EOF
-
-weave add test.weave 3 <<EOF
-aaa
-bbb
-stuff from martin
-fix up merge
-modify john's code
-ccc
-ddd
-add stuff here
-EOF
-
-# v5 
-weave add test.weave 2 <<EOF
-aaa
-bbb
-stuff from john
-more john stuff
-john replaced ccc line
-EOF
-
-# now try merging 5(2) with 4(3(2 1))
\ No newline at end of file

